#ifdef eTeX
const_string ETEXHELP[] = {
  "Usage: etex [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n",
  "   or: etex [OPTION]... \\FIRST-LINE\n",
  "   or: etex [OPTION]... &FMT ARGS\n",
  "  Run e-TeX on TEXNAME, usually creating TEXNAME.dvi.\n",
  "  Any remaining COMMANDS are processed as e-TeX input, after TEXNAME is read.\n",
  "  If the first line of TEXNAME is %&FMT, and FMT is an existing .efmt file,\n",
  "  use it.  Else use `NAME.efmt', where NAME is the program invocation name,\n",
  "  most commonly `etex'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of e-TeX input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the FMT to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-efmt=FMTNAME            use FMTNAME instead of program name or a %& line\n",
  "-ini                     be einitex, for dumping formats; this is implicitly\n",
  "                          true if the program name is `einitex'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=tex/tfm)\n",
  "-mltex                   enable MLTeX extensions such as \\charsubdef\n",
#if defined(WIN32) && defined(OEM)
  "-oem                     Use DOS codepage for console output.\n",
#endif
  "-output-comment=STRING   use STRING for DVI file comment instead of date\n",
  "-progname=STRING         set program (and fmt) name to STRING\n",
  "-shell-escape            enable \\write18{SHELL COMMAND}\n",
  "-src-specials            insert source specials into the DVI file\n",
  "-src-specials=WHERE      insert source specials in certain places of\n",
  "                         the DVI file. WHERE is a comma-separated value\n",
  "                         list: cr display hbox math par parend vbox\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* eTeX */

#ifdef MF
const_string MFHELP[] = {
  "Usage: mf [OPTION]... [MFNAME[.mf]] [COMMANDS]\n",
  "   or: mf [OPTION]... \\FIRST-LINE\n",
  "   or: mf [OPTION]... &BASE ARGS\n",
  "  Run Metafont on MFNAME, usually creating MFNAME.tfm and MFNAME.NNNNgf,\n",
  "  where NNNN is the resolution of the specified mode (2602 by default).\n",
  "  Any following COMMANDS are processed as Metafont input,\n",
  "  after MFNAME is read.\n",
  "  If the first line of MFNAME is %&BASE, and BASE is an existing .base file,\n",
  "  use it.  Else use `NAME.base', where NAME is the program invocation name,\n",
  "  most commonly `mf'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of Metafont input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the BASE to read, overriding all else. Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-base=BASENAME           use BASENAME instead of program name or a %& line\n",
  "-ini                     be inimf, for dumping bases; this is implicitly\n",
  "                          true if the program name is `inimf'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=mf)\n",
#if defined(WIN32) && defined(OEM)
  "-oem                     Use DOS codepage for console output.\n",
#endif
  "-progname=STRING         set program (and base) name to STRING\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* MF */

#ifdef MP
const_string MPHELP[] = {
  "Usage: mpost [OPTION]... [MPNAME[.mp]] [COMMANDS]\n",
  "   or: mpost [OPTION]... \\FIRST-LINE\n",
  "   or: mpost [OPTION]... &MEM ARGS\n",
  "  Run MetaPost on MPNAME, usually creating MPNAME.NNN (and perhaps\n",
  "  MPNAME.tfm), where NNN are the character numbers generated.\n",
  "  Any remaining COMMANDS are processed as MetaPost input,\n",
  "  after MPNAME is read.\n",
  "  If the first line of MPNAME is %&MEM, and MEM is an existing .mem file,\n",
  "  use it.  Else use `NAME.mem', where NAME is the program invocation name,\n",
  "  most commonly `mp'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of MetaPost input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the MEM to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-ini                     be inimpost, for dumping mems; this is implicitly\n",
  "                          true if the program name is `inimpost'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "-mem=MEMNAME             use MEMNAME instead of program name or a %& line\n",
#if defined(WIN32) && defined(OEM)
  "-oem                     Use DOS codepage for console output.\n",
#endif
  "-progname=STRING         set program (and mem) name to STRING\n",
  "-tex=TEXPROGRAM          use TEXPROGRAM for text labels.\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-T, -troff               set the prologues variable, use `makempx -troff'\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* MP */

#ifdef Omega
const_string OMEGAHELP[] = {
  "Usage: omega [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n",
  "   or: omega [OPTION]... \\FIRST-LINE\n",
  "   or: omega [OPTION]... &FMT ARGS\n",
  "  Run Omega on TEXNAME, usually creating TEXNAME.dvi.\n",
  "  Any remaining COMMANDS are processed as Omega input, after TEXNAME is read.\n",
  "  If the first line of TEXNAME is %&FMT, and FMT is an existing .fmt file,\n",
  "  use it.  Else use `NAME.fmt', where NAME is the program invocation name,\n",
  "  most commonly `omega'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of Omega input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the FMT to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-fmt=FMTNAME             use FMTNAME instead of program name or a %& line\n",
  "-ini                     be iniomega, for dumping formats; this is implicitly\n",
  "                          true if the program name is `iniomega'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=tex/tfm)\n",
  "-output-comment=STRING   use STRING for DVI file comment instead of date\n",
  "-progname=STRING         set program (and fmt) name to STRING\n",
  "-shell-escape            enable \\write18{SHELL COMMAND}\n",
  "-src-specials            insert source specials into the DVI file\n",
  "-src-specials=WHERE      insert source specials in certain places of\n",
  "                         the DVI file. WHERE is a comma-separated value\n",
  "                         list: cr display hbox math par parend vbox\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* Omega */

#ifdef pdfTeX
const_string PDFTEXHELP[] = {
  "Usage: pdftex [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n",
  "   or: pdftex [OPTION]... \\FIRST-LINE\n",
  "   or: pdftex [OPTION]... &FMT ARGS\n",
  "  Run pdfTeX on TEXNAME, usually creating TEXNAME.pdf.\n",
  "  Any remaining COMMANDS are processed as pdfTeX input, after TEXNAME is read.\n",
  "  If the first line of TEXNAME is %&FMT, and FMT is an existing .fmt file,\n",
  "  use it.  Else use `NAME.fmt', where NAME is the program invocation name,\n",
  "  most commonly `pdftex'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of pdfTeX input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the FMT to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-fmt=FMTNAME             use FMTNAME instead of program name or a %& line\n",
  "-ini                     be pdfinitex, for dumping formats; this is implicitly\n",
  "                          true if the program name is `pdfinitex'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=tex/tfm)\n",
#if defined(WIN32) && defined(OEM)
  "-oem                     Use DOS codepage for console output.\n",
#endif
  "-output-comment=STRING   use STRING for PDF file comment instead of date\n",
  "-progname=STRING         set program (and fmt) name to STRING\n",
  "-shell-escape            enable \\write18{SHELL COMMAND}\n",
  "-src-specials            insert source specials into the DVI file\n",
  "-src-specials=WHERE      insert source specials in certain places of\n",
  "                         the DVI file. WHERE is a comma-separated value\n",
  "                         list: cr display hbox math par parend vbox\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* pdfTeX */

#ifdef pdfeTeX
const_string PDFETEXHELP[] = {
  "Usage: pdfetex [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n",
  "   or: pdfetex [OPTION]... \\FIRST-LINE\n",
  "   or: pdfetex [OPTION]... &FMT ARGS\n",
  "  Run pdfeTeX on TEXNAME, usually creating TEXNAME.pdf.\n",
  "  Any remaining COMMANDS are processed as pdfeTeX input, after TEXNAME is read.\n",
  "  If the first line of TEXNAME is %&FMT, and FMT is an existing .fmt file,\n",
  "  use it.  Else use `NAME.efmt', where NAME is the program invocation name,\n",
  "  most commonly `pdfetex'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of pdfeTeX input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the FMT to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-efmt=FMTNAME             use FMTNAME instead of program name or a %& line\n",
  "-ini                     be pdfeinitex, for dumping formats; this is implicitly\n",
  "                          true if the program name is `pdfeinitex'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
    "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=tex/tfm)\n",
  "-output-comment=STRING   use STRING for PDF file comment instead of date\n",
  "-progname=STRING         set program (and fmt) name to STRING\n",
  "-shell-escape            enable \\write18{SHELL COMMAND}\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#endif /* pdfeTeX */

#ifdef TeX
EXTERN const_string TEXHELP[] = {
  "Usage: tex [OPTION]... [TEXNAME[.tex]] [COMMANDS]\n",
  "   or: tex [OPTION]... \\FIRST-LINE\n",
  "   or: tex [OPTION]... &FMT ARGS\n",
  "  Run TeX on TEXNAME, usually creating TEXNAME.dvi.\n",
  "  Any remaining COMMANDS are processed as TeX input, after TEXNAME is read.\n",
  "  If the first line of TEXNAME is %&FMT, and FMT is an existing .fmt file,\n",
  "  use it.  Else use `NAME.fmt', where NAME is the program invocation name,\n",
  "  most commonly `tex'.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a backslash,\n",
  "  interpret all non-option arguments as a line of TeX input.\n",
  "\n",
  "  Alternatively, if the first non-option argument begins with a &, the\n",
  "  next word is taken as the FMT to read, overriding all else.  Any\n",
  "  remaining arguments are processed as above.\n",
  "\n",
  "  If no arguments or options are specified, prompt for input.\n",
  "\n",
  "-c-style-errors          print C/C++ style error messages.\n",
  "-fmt=FMTNAME             use FMTNAME instead of program name or a %& line\n",
  "-ini                     be initex, for dumping formats; this is implicitly\n",
  "                          true if the program name is `initex'\n",
  "-interaction=STRING      set interaction mode (STRING=batchmode/nonstopmode/\n",
  "                          scrollmode/errorstopmode)\n",
  "-kpathsea-debug=NUMBER   set path searching debugging flags according to\n",
  "                          the bits of NUMBER\n",
  "[-no]-mktex=FMT          disable/enable mktexFMT generation (FMT=tex/tfm)\n",
  "-mltex                   enable MLTeX extensions such as \\charsubdef\n",
#if defined(WIN32) && defined(OEM)
  "-oem                     Use DOS codepage for console output.\n",
#endif
  "-output-comment=STRING   use STRING for DVI file comment instead of date\n",
  "-progname=STRING         set program (and fmt) name to STRING\n",
  "-shell-escape            enable \\write18{SHELL COMMAND}\n",
  "-src-specials            insert source specials into the DVI file\n",
  "-src-specials=WHERE      insert source specials in certain places of\n",
  "                         the DVI file. WHERE is a comma-separated value\n",
  "                         list: cr display hbox math par parend vbox\n",
  "-translate-file=TCXNAME  use the TCX file TCXNAME\n",
  "-stack-size=N            set stack_size to N\n",
  "-help                    display this help and exit\n",
  "-version                 output version information and exit\n",
  NULL
};
#ifdef IPC
const_string TEX_IPC_HELP[] = {
  "-ipc                     send DVI output to a socket as well as the usual\n",
  "                          output file\n",
  "-ipc-start               as -ipc, and also start the server at the other end\n",
  NULL
};
#endif /* IPC */
#endif /* TeX */
/* FIXME: include help for TCX files.
	"-translate-file=TCXFILE  use TCXFILE for printable chars and translations\n",
*/

