#define EXTERN extern
#include "pdfetexd.h"

void 
#ifdef HAVE_PROTOTYPES
zsetrectdimens ( halfword p , halfword parentbox , scaled x , scaled y , 
scaled w , scaled h , scaled d , scaled margin ) 
#else
zsetrectdimens ( p , parentbox , x , y , w , h , d , margin ) 
  halfword p ;
  halfword parentbox ;
  scaled x ;
  scaled y ;
  scaled w ;
  scaled h ;
  scaled d ;
  scaled margin ;
#endif
{
  setrectdimens_regmem 
  mem [p + 1 ].cint = curh ;
  if ( ( w == -1073741824L ) ) 
  mem [p + 3 ].cint = x + mem [parentbox + 1 ].cint ;
  else mem [p + 3 ].cint = curh + w ;
  if ( ( h == -1073741824L ) ) 
  mem [p + 2 ].cint = y - mem [parentbox + 3 ].cint ;
  else mem [p + 2 ].cint = curv - h ;
  if ( ( d == -1073741824L ) ) 
  mem [p + 4 ].cint = y + mem [parentbox + 2 ].cint ;
  else mem [p + 4 ].cint = curv + d ;
  mem [p + 1 ].cint = mem [p + 1 ].cint - margin ;
  mem [p + 2 ].cint = mem [p + 2 ].cint - margin ;
  mem [p + 3 ].cint = mem [p + 3 ].cint + margin ;
  mem [p + 4 ].cint = mem [p + 4 ].cint + margin ;
} 
void 
#ifdef HAVE_PROTOTYPES
zdoannot ( halfword p , halfword parentbox , scaled x , scaled y ) 
#else
zdoannot ( p , parentbox , x , y ) 
  halfword p ;
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  doannot_regmem 
  if ( doingleaders ) 
  return ;
  setrectdimens ( p , parentbox , x , y , mem [p + 1 ].cint , mem [p + 2 ]
  .cint , mem [p + 3 ].cint , 0 ) ;
  objtab [mem [p + 6 ].cint ].int3 = p ;
  {
    pdfappendlistarg = mem [p + 6 ].cint ;
    pdfannotlist = appendptr ( pdfannotlist , pdfappendlistarg ) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zsavelinklevel ( halfword l ) 
#else
zsavelinklevel ( l ) 
  halfword l ;
#endif
{
  savelinklevel_regmem 
  halfword p, r  ;
  pdflinklevel = curs ;
  r = copynodelist ( l ) ;
  pdflinkwd = mem [r + 1 ].cint ;
  pdflinkht = mem [r + 2 ].cint ;
  pdflinkdp = mem [r + 3 ].cint ;
  p = getnode ( 2 ) ;
  mem [p ].hh .v.LH = pdflinklevel ;
  mem [p + 1 ].hh .v.LH = r ;
  mem [p ].hh .v.RH = linklevelstack ;
  linklevelstack = p ;
} 
void 
#ifdef HAVE_PROTOTYPES
zdolink ( halfword p , halfword parentbox , scaled x , scaled y ) 
#else
zdolink ( p , parentbox , x , y ) 
  halfword p ;
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  dolink_regmem 
  if ( mem [parentbox ].hh.b0 != 0 ) 
  pdferror ( 1619 , 1688 ) ;
  savelinklevel ( p ) ;
  setrectdimens ( p , parentbox , x , y , pdflinkwd , pdflinkht , pdflinkdp , 
  eqtb [15788 ].cint ) ;
  lastlink = p ;
  pdfcreateobj ( 0 , 0 ) ;
  objtab [objptr ].int3 = p ;
  {
    pdfappendlistarg = objptr ;
    pdflinklist = appendptr ( pdflinklist , pdfappendlistarg ) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
restorelinklevel ( void ) 
#else
restorelinklevel ( ) 
#endif
{
  restorelinklevel_regmem 
  halfword p, r  ;
  if ( linklevelstack == -268435455L ) 
  pdferror ( 1619 , 1689 ) ;
  p = linklevelstack ;
  linklevelstack = mem [p ].hh .v.RH ;
  r = mem [p + 1 ].hh .v.LH ;
  flushnodelist ( r ) ;
  freenode ( p , 2 ) ;
  p = linklevelstack ;
  if ( p == -268435455L ) 
  pdflinklevel = -1 ;
  else {
      
    pdflinklevel = mem [p ].hh .v.LH ;
    r = mem [p + 1 ].hh .v.LH ;
    pdflinkwd = mem [r + 1 ].cint ;
    pdflinkht = mem [r + 2 ].cint ;
    pdflinkdp = mem [r + 3 ].cint ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
endlink ( void ) 
#else
endlink ( ) 
#endif
{
  endlink_regmem 
  if ( pdflinklevel != curs ) 
  pdferror ( 1619 , 1690 ) ;
  if ( ( pdflinkwd == -1073741824L ) && ( lastlink != -268435455L ) ) 
  mem [lastlink + 3 ].cint = curh + eqtb [15788 ].cint ;
  restorelinklevel () ;
  lastlink = -268435455L ;
} 
void 
#ifdef HAVE_PROTOTYPES
zappendlink ( halfword parentbox , scaled x , scaled y ) 
#else
zappendlink ( parentbox , x , y ) 
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  appendlink_regmem 
  integer p, r  ;
  if ( mem [parentbox ].hh.b0 != 0 ) 
  pdferror ( 1619 , 1688 ) ;
  r = copynodelist ( mem [linklevelstack + 1 ].hh .v.LH ) ;
  mem [r ].hh .v.LH = 268435455L ;
  mem [r ].hh .v.RH = -268435455L ;
  setrectdimens ( r , parentbox , x , y , pdflinkwd , pdflinkht , pdflinkdp , 
  eqtb [15788 ].cint ) ;
  pdfcreateobj ( 0 , 0 ) ;
  objtab [objptr ].int3 = r ;
  lastlink = r ;
  {
    pdfappendlistarg = objptr ;
    pdflinklist = appendptr ( pdflinklist , pdfappendlistarg ) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zappendbead ( halfword p ) 
#else
zappendbead ( p ) 
  halfword p ;
#endif
{
  appendbead_regmem 
  integer a, b, c, t  ;
  t = getobj ( 9 , mem [p + 5 ].hh .v.RH , mem [p + 5 ].hh.b1 ) ;
  b = pdfnewobjnum () ;
  objtab [b ].int3 = pdfgetmem ( 5 ) ;
  pdfmem [objtab [b ].int3 + 1 ]= pdflastpage ;
  pdfmem [objtab [b ].int3 ]= p ;
  if ( mem [p + 6 ].hh .v.LH != -268435455L ) 
  pdfmem [objtab [b ].int3 + 4 ]= tokenstostring ( mem [p + 6 ].hh .v.LH 
  ) ;
  else pdfmem [objtab [b ].int3 + 4 ]= 0 ;
  if ( objtab [t ].int3 == 0 ) 
  {
    objtab [t ].int3 = b ;
    pdfmem [objtab [b ].int3 + 2 ]= b ;
    pdfmem [objtab [b ].int3 + 3 ]= b ;
  } 
  else {
      
    a = objtab [t ].int3 ;
    c = pdfmem [objtab [a ].int3 + 3 ];
    pdfmem [objtab [b ].int3 + 3 ]= c ;
    pdfmem [objtab [b ].int3 + 2 ]= a ;
    pdfmem [objtab [a ].int3 + 3 ]= b ;
    pdfmem [objtab [c ].int3 + 2 ]= b ;
  } 
  {
    pdfappendlistarg = b ;
    pdfbeadlist = appendptr ( pdfbeadlist , pdfappendlistarg ) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zdothread ( halfword p , halfword parentbox , scaled x , scaled y ) 
#else
zdothread ( p , parentbox , x , y ) 
  halfword p ;
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  dothread_regmem 
  if ( doingleaders ) 
  return ;
  if ( mem [p ].hh.b1 == 19 ) 
  {
    pdfthreadwd = mem [p + 1 ].cint ;
    pdfthreadht = mem [p + 2 ].cint ;
    pdfthreaddp = mem [p + 3 ].cint ;
    pdflastthreadid = mem [p + 5 ].hh .v.RH ;
    pdflastthreadnamedid = ( mem [p + 5 ].hh.b1 > 0 ) ;
    if ( pdflastthreadnamedid ) 
    incr ( mem [mem [p + 5 ].hh .v.RH ].hh .v.LH ) ;
    pdfthreadlevel = curs ;
  } 
  setrectdimens ( p , parentbox , x , y , mem [p + 1 ].cint , mem [p + 2 ]
  .cint , mem [p + 3 ].cint , eqtb [15790 ].cint ) ;
  appendbead ( p ) ;
  lastthread = p ;
} 
void 
#ifdef HAVE_PROTOTYPES
zappendthread ( halfword parentbox , scaled x , scaled y ) 
#else
zappendthread ( parentbox , x , y ) 
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  appendthread_regmem 
  halfword p  ;
  p = getnode ( 7 ) ;
  mem [p ].hh .v.LH = 268435455L ;
  mem [p ].hh .v.RH = -268435455L ;
  mem [p + 1 ].cint = pdfthreadwd ;
  mem [p + 2 ].cint = pdfthreadht ;
  mem [p + 3 ].cint = pdfthreaddp ;
  mem [p + 6 ].hh .v.LH = -268435455L ;
  mem [p + 5 ].hh .v.RH = pdflastthreadid ;
  if ( pdflastthreadnamedid ) 
  {
    incr ( mem [mem [p + 5 ].hh .v.RH ].hh .v.LH ) ;
    mem [p + 5 ].hh.b1 = 1 ;
  } 
  else mem [p + 5 ].hh.b1 = 0 ;
  setrectdimens ( p , parentbox , x , y , mem [p + 1 ].cint , mem [p + 2 ]
  .cint , mem [p + 3 ].cint , eqtb [15790 ].cint ) ;
  appendbead ( p ) ;
  lastthread = p ;
} 
void 
#ifdef HAVE_PROTOTYPES
endthread ( void ) 
#else
endthread ( ) 
#endif
{
  endthread_regmem 
  if ( pdfthreadlevel != curs ) 
  pdferror ( 1619 , 1691 ) ;
  if ( ( pdfthreaddp == -1073741824L ) && ( lastthread != -268435455L ) ) 
  mem [lastthread + 4 ].cint = curv + eqtb [15790 ].cint ;
  if ( pdflastthreadnamedid ) 
  deletetokenref ( pdflastthreadid ) ;
  lastthread = -268435455L ;
} 
integer 
#ifdef HAVE_PROTOTYPES
zopensubentries ( halfword p ) 
#else
zopensubentries ( p ) 
  halfword p ;
#endif
{
  register integer Result; opensubentries_regmem 
  integer k, c  ;
  integer l, r  ;
  k = 0 ;
  if ( pdfmem [objtab [p ].int3 + 4 ]!= 0 ) 
  {
    l = pdfmem [objtab [p ].int3 + 4 ];
    do {
	incr ( k ) ;
      c = opensubentries ( l ) ;
      if ( objtab [l ].int0 > 0 ) 
      k = k + c ;
      pdfmem [objtab [l ].int3 + 1 ]= p ;
      r = pdfmem [objtab [l ].int3 + 3 ];
      if ( r == 0 ) 
      pdfmem [objtab [p ].int3 + 5 ]= l ;
      l = r ;
    } while ( ! ( l == 0 ) ) ;
  } 
  if ( objtab [p ].int0 > 0 ) 
  objtab [p ].int0 = k ;
  else objtab [p ].int0 = - (integer) k ;
  Result = k ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zdodest ( halfword p , halfword parentbox , scaled x , scaled y ) 
#else
zdodest ( p , parentbox , x , y ) 
  halfword p ;
  halfword parentbox ;
  scaled x ;
  scaled y ;
#endif
{
  dodest_regmem 
  integer k  ;
  if ( doingleaders ) 
  return ;
  k = getobj ( 5 , mem [p + 5 ].hh .v.RH , mem [p + 5 ].hh.b1 ) ;
  if ( objtab [k ].int3 != -268435455L ) 
  {
    warndestdup ( mem [p + 5 ].hh .v.RH , mem [p + 5 ].hh.b1 , 1619 , 1620 
    ) ;
    return ;
  } 
  objtab [k ].int3 = p ;
  {
    pdfappendlistarg = k ;
    pdfdestlist = appendptr ( pdfdestlist , pdfappendlistarg ) ;
  } 
  switch ( mem [p + 5 ].hh.b0 ) 
  {case 0 : 
    {
      mem [p + 1 ].cint = curh ;
      mem [p + 2 ].cint = curv ;
    } 
    break ;
  case 2 : 
  case 5 : 
    mem [p + 2 ].cint = curv ;
    break ;
  case 3 : 
  case 6 : 
    mem [p + 1 ].cint = curh ;
    break ;
  case 1 : 
  case 4 : 
    ;
    break ;
  case 7 : 
    setrectdimens ( p , parentbox , x , y , mem [p + 1 ].cint , mem [p + 2 
    ].cint , mem [p + 3 ].cint , eqtb [15789 ].cint ) ;
    break ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zoutform ( halfword p ) 
#else
zoutform ( p ) 
  halfword p ;
#endif
{
  outform_regmem 
  pdfendtext () ;
  {
    pdfprint ( 113 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  if ( pdflookuplist ( pdfxformlist , mem [p + 4 ].hh .v.LH ) == -268435455L 
  ) 
  {
    pdfappendlistarg = mem [p + 4 ].hh .v.LH ;
    pdfxformlist = appendptr ( pdfxformlist , pdfappendlistarg ) ;
  } 
  curv = curv + pdfmem [objtab [mem [p + 4 ].hh .v.LH ].int3 + 2 ];
  pdfprint ( 923 ) ;
  pdfprintbp ( ( ( curh ) - pdforiginh ) ) ;
  {
    if ( pdfptr + 1 >= pdfbufsize ) 
    pdfflush () ;
    {
      pdfbuf [pdfptr ]= 32 ;
      incr ( pdfptr ) ;
    } 
  } 
  pdfprintbp ( ( pdforiginv - ( curv ) ) ) ;
  {
    pdfprint ( 924 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  pdfprint ( 996 ) ;
  pdfprintint ( objtab [mem [p + 4 ].hh .v.LH ].int0 ) ;
  if ( pdfresnameprefix != 0 ) 
  pdfprint ( pdfresnameprefix ) ;
  {
    pdfprint ( 1692 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  {
    pdfprint ( 81 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zoutimage ( halfword p ) 
#else
zoutimage ( p ) 
  halfword p ;
#endif
{
  outimage_regmem 
  integer image  ;
  image = pdfmem [objtab [mem [p + 4 ].hh .v.LH ].int3 + 4 ];
  pdfendtext () ;
  {
    pdfprint ( 113 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  if ( pdflookuplist ( pdfximagelist , mem [p + 4 ].hh .v.LH ) == 
  -268435455L ) 
  {
    pdfappendlistarg = mem [p + 4 ].hh .v.LH ;
    pdfximagelist = appendptr ( pdfximagelist , pdfappendlistarg ) ;
  } 
  if ( ! ispdfimage ( image ) ) 
  {
    pdfprintbp ( mem [p + 1 ].cint ) ;
    pdfprint ( 991 ) ;
    pdfprintbp ( mem [p + 2 ].cint + mem [p + 3 ].cint ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintbp ( ( ( curh ) - pdforiginh ) ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintbp ( ( pdforiginv - ( curv ) ) ) ;
  } 
  else {
      
    pdfprintbp ( extxnoverd ( mem [p + 1 ].cint , onebp , imagewidth ( image 
    ) ) ) ;
    pdfprint ( 991 ) ;
    pdfprintbp ( extxnoverd ( mem [p + 2 ].cint + mem [p + 3 ].cint , 
    onebp , imageheight ( image ) ) ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintbp ( ( ( curh ) - pdforiginh ) - extxnoverd ( mem [p + 1 ].cint 
    , epdforigx ( image ) , imagewidth ( image ) ) ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintbp ( ( pdforiginv - ( curv ) ) - extxnoverd ( mem [p + 2 ].cint 
    , epdforigy ( image ) , imageheight ( image ) ) ) ;
  } 
  {
    pdfprint ( 924 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  pdfprint ( 997 ) ;
  pdfprintint ( objtab [mem [p + 4 ].hh .v.LH ].int0 ) ;
  if ( pdfresnameprefix != 0 ) 
  pdfprint ( pdfresnameprefix ) ;
  {
    pdfprint ( 1692 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  {
    pdfprint ( 81 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zdosnap ( halfword p ) 
#else
zdosnap ( p ) 
  halfword p ;
#endif
{
  dosnap_regmem 
  scaled gapamount, stretchamount, shrinkamount  ;
  scaled curpoint, lastpoint, nextpoint  ;
  gapamount = mem [mem [p + 1 ].hh .v.LH + 1 ].cint ;
  if ( mem [mem [p + 1 ].hh .v.LH ].hh.b0 > 0 ) 
  stretchamount = 1073741823L ;
  else stretchamount = mem [mem [p + 1 ].hh .v.LH + 2 ].cint ;
  if ( mem [mem [p + 1 ].hh .v.LH ].hh.b1 > 0 ) 
  shrinkamount = 1073741823L ;
  else shrinkamount = mem [mem [p + 1 ].hh .v.LH + 3 ].cint ;
  if ( mem [p ].hh.b1 == 23 ) 
  {
    curpoint = curh ;
    lastpoint = pdfsnapxpos + gapamount * ( ( curpoint - pdfsnapxpos ) / 
    gapamount ) ;
  } 
  else {
      
    curpoint = curv ;
    lastpoint = pdfsnapypos + gapamount * ( ( curpoint - pdfsnapypos ) / 
    gapamount ) ;
  } 
  nextpoint = lastpoint + gapamount ;
  if ( ( curpoint - lastpoint > shrinkamount ) && ( nextpoint - curpoint > 
  stretchamount ) ) 
  return ;
  if ( curpoint - lastpoint > shrinkamount ) 
  curpoint = nextpoint ;
  else if ( nextpoint - curpoint > stretchamount ) 
  curpoint = lastpoint ;
  else if ( curpoint - lastpoint <= nextpoint - curpoint ) 
  curpoint = lastpoint ;
  else curpoint = nextpoint ;
  if ( mem [p ].hh.b1 == 23 ) 
  curh = curpoint ;
  else curv = curpoint ;
} 
integer 
#ifdef HAVE_PROTOTYPES
znodetype ( halfword p ) 
#else
znodetype ( p ) 
  halfword p ;
#endif
{
  register integer Result; nodetype_regmem 
  Result = 0 ;
  if ( p == -268435455L ) 
  return Result ;
  if ( ( p >= himemmin ) ) 
  print ( 1693 ) ;
  else switch ( mem [p ].hh.b0 ) 
  {case 0 : 
    print ( 1694 ) ;
    break ;
  case 1 : 
    print ( 1695 ) ;
    break ;
  case 2 : 
    print ( 1696 ) ;
    break ;
  case 3 : 
    print ( 1697 ) ;
    break ;
  case 4 : 
    print ( 1698 ) ;
    break ;
  case 5 : 
    print ( 1699 ) ;
    break ;
  case 6 : 
    print ( 1700 ) ;
    break ;
  case 7 : 
    print ( 1701 ) ;
    break ;
  case 8 : 
    print ( 1702 ) ;
    break ;
  case 9 : 
    print ( 1703 ) ;
    break ;
  case 10 : 
    print ( 1704 ) ;
    break ;
  case 11 : 
    print ( 1705 ) ;
    break ;
  case 12 : 
    print ( 1706 ) ;
    break ;
  case 13 : 
    print ( 1707 ) ;
    break ;
  case 14 : 
    print ( 1708 ) ;
    break ;
  case 15 : 
    print ( 1709 ) ;
    break ;
  } 
  println () ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
pdfhlistout ( void ) 
#else
pdfhlistout ( ) 
#endif
{
  /* 21 13 14 15 40 22 */ pdfhlistout_regmem 
  scaled baseline  ;
  scaled leftedge  ;
  scaled saveh  ;
  halfword thisbox  ;
  char gsign  ;
  halfword p  ;
  halfword leaderbox  ;
  scaled leaderwd  ;
  scaled lx  ;
  boolean outerdoingleaders  ;
  scaled edge  ;
  halfword prevp  ;
  halfword runninglink  ;
  thisbox = tempptr ;
  gsign = mem [thisbox + 5 ].hh.b0 ;
  p = mem [thisbox + 5 ].hh .v.RH ;
  incr ( curs ) ;
  baseline = curv ;
  prevp = thisbox + 5 ;
  if ( ( eTeXmode == 1 ) ) 
  {
    {
      tempptr = getavail () ;
      mem [tempptr ].hh .v.LH = 0 ;
      mem [tempptr ].hh .v.RH = LRptr ;
      LRptr = tempptr ;
    } 
    if ( mem [thisbox ].hh.b1 == 2 ) 
    if ( curdir == 1 ) 
    {
      curdir = 0 ;
      curh = curh - mem [thisbox + 1 ].cint ;
    } 
    else mem [thisbox ].hh.b1 = 0 ;
    if ( ( curdir == 1 ) && ( mem [thisbox ].hh.b1 != 1 ) ) 
    {
      saveh = curh ;
      tempptr = p ;
      p = newkern ( 0 ) ;
      mem [prevp ].hh .v.RH = p ;
      curh = 0 ;
      mem [p ].hh .v.RH = reverse ( thisbox , -268435455L ) ;
      mem [p + 1 ].cint = - (integer) curh ;
      curh = saveh ;
      mem [thisbox ].hh.b1 = 1 ;
    } 
  } 
  leftedge = curh ;
  runninglink = -268435455L ;
  if ( runninglink == -268435455L ) 
  {
    if ( ( pdflinkwd == -1073741824L ) && ( pdflinklevel == curs ) ) 
    {
      appendlink ( thisbox , leftedge , baseline ) ;
      runninglink = lastlink ;
    } 
  } 
  else lastlink = runninglink ;
  while ( p != -268435455L ) lab21: if ( ( p >= himemmin ) ) 
  {
    do {
	f = mem [p ].hh.b0 ;
      c = mem [p ].hh.b1 ;
      if ( ( ( fontbc [f ]<= c ) && ( c <= fontec [f ]) && ( fontinfo [
      charbase [f ]+ c ].qqqq .b0 > 0 ) ) ) 
      {
	{
	  if ( pdffonttype [f ]== 0 ) 
	  {
	    tmpf = f ;
	    dovf () ;
	  } 
	  if ( pdffonttype [f ]== 1 ) 
	  dovfpacket ( f , c ) ;
	  else {
	      
	    pdfbeginstring ( f ) ;
	    pdfprintchar ( f , c ) ;
	    advcharwidth ( f , fontinfo [widthbase [f ]+ fontinfo [
	    charbase [f ]+ effectivechar ( true , f , c ) ].qqqq .b0 ]
	    .cint ) ;
	  } 
	} 
	curh = curh + fontinfo [widthbase [f ]+ fontinfo [charbase [f ]+ 
	effectivechar ( true , f , c ) ].qqqq .b0 ].cint ;
	goto lab22 ;
      } 
      if ( mltexenabledp ) 
      {
	if ( c >= eqtb [15238 ].cint ) 
	if ( c <= eqtb [15239 ].cint ) 
	if ( ( eqtb [14915 + c ].hh .v.RH > 0 ) ) 
	{
	  basec = ( eqtb [14915 + c ].hh .v.RH % 256 ) ;
	  accentc = ( eqtb [14915 + c ].hh .v.RH / 256 ) ;
	  if ( ( fontec [f ]>= basec ) ) 
	  if ( ( fontbc [f ]<= basec ) ) 
	  if ( ( fontec [f ]>= accentc ) ) 
	  if ( ( fontbc [f ]<= accentc ) ) 
	  {
	    iac = fontinfo [charbase [f ]+ effectivechar ( true , f , 
	    accentc ) ].qqqq ;
	    ibc = fontinfo [charbase [f ]+ effectivechar ( true , f , basec 
	    ) ].qqqq ;
	    if ( ( ibc .b0 > 0 ) ) 
	    if ( ( iac .b0 > 0 ) ) 
	    goto lab40 ;
	  } 
	  begindiagnostic () ;
	  printnl ( 1820 ) ;
	  print ( c ) ;
	  print ( 1443 ) ;
	  print ( accentc ) ;
	  print ( 32 ) ;
	  print ( basec ) ;
	  print ( 877 ) ;
	  print ( fontname [f ]) ;
	  printchar ( 33 ) ;
	  enddiagnostic ( false ) ;
	  goto lab22 ;
	} 
	begindiagnostic () ;
	printnl ( 876 ) ;
	print ( 1819 ) ;
	print ( c ) ;
	print ( 877 ) ;
	print ( fontname [f ]) ;
	printchar ( 33 ) ;
	enddiagnostic ( false ) ;
	goto lab22 ;
	lab40: if ( eqtb [15206 ].cint > 99 ) 
	{
	  begindiagnostic () ;
	  printnl ( 1821 ) ;
	  print ( c ) ;
	  print ( 1443 ) ;
	  print ( accentc ) ;
	  print ( 32 ) ;
	  print ( basec ) ;
	  print ( 877 ) ;
	  print ( fontname [f ]) ;
	  printchar ( 46 ) ;
	  enddiagnostic ( false ) ;
	} 
	basexheight = fontinfo [5 + parambase [f ]].cint ;
	baseslant = fontinfo [1 + parambase [f ]].cint / ((double) 65536.0 
	) ;
	accentslant = baseslant ;
	basewidth = fontinfo [widthbase [f ]+ ibc .b0 ].cint ;
	baseheight = fontinfo [heightbase [f ]+ ( ibc .b1 ) / 16 ].cint ;
	accentwidth = fontinfo [widthbase [f ]+ iac .b0 ].cint ;
	accentheight = fontinfo [heightbase [f ]+ ( iac .b1 ) / 16 ].cint 
	;
	delta = round ( ( basewidth - accentwidth ) / ((double) 2.0 ) + 
	baseheight * baseslant - basexheight * accentslant ) ;
	curh = curh + delta ;
	if ( ( ( baseheight != basexheight ) && ( accentheight > 0 ) ) ) 
	{
	  curv = baseline + ( basexheight - baseheight ) ;
	  {
	    if ( pdffonttype [f ]== 0 ) 
	    {
	      tmpf = f ;
	      dovf () ;
	    } 
	    if ( pdffonttype [f ]== 1 ) 
	    dovfpacket ( f , accentc ) ;
	    else {
		
	      pdfbeginstring ( f ) ;
	      pdfprintchar ( f , accentc ) ;
	      advcharwidth ( f , fontinfo [widthbase [f ]+ fontinfo [
	      charbase [f ]+ effectivechar ( true , f , accentc ) ].qqqq 
	      .b0 ].cint ) ;
	    } 
	  } 
	  curv = baseline ;
	} 
	else {
	    
	  {
	    if ( pdffonttype [f ]== 0 ) 
	    {
	      tmpf = f ;
	      dovf () ;
	    } 
	    if ( pdffonttype [f ]== 1 ) 
	    dovfpacket ( f , accentc ) ;
	    else {
		
	      pdfbeginstring ( f ) ;
	      pdfprintchar ( f , accentc ) ;
	      advcharwidth ( f , fontinfo [widthbase [f ]+ fontinfo [
	      charbase [f ]+ effectivechar ( true , f , accentc ) ].qqqq 
	      .b0 ].cint ) ;
	    } 
	  } 
	} 
	curh = curh + accentwidth ;
	curh = curh + ( - (integer) accentwidth - delta ) ;
	{
	  if ( pdffonttype [f ]== 0 ) 
	  {
	    tmpf = f ;
	    dovf () ;
	  } 
	  if ( pdffonttype [f ]== 1 ) 
	  dovfpacket ( f , basec ) ;
	  else {
	      
	    pdfbeginstring ( f ) ;
	    pdfprintchar ( f , basec ) ;
	    advcharwidth ( f , fontinfo [widthbase [f ]+ fontinfo [
	    charbase [f ]+ effectivechar ( true , f , basec ) ].qqqq .b0 ]
	    .cint ) ;
	  } 
	} 
	curh = curh + basewidth ;
      } 
      lab22: prevp = mem [prevp ].hh .v.RH ;
      p = mem [p ].hh .v.RH ;
    } while ( ! ( ! ( p >= himemmin ) ) ) ;
  } 
  else {
      
    switch ( mem [p ].hh.b0 ) 
    {case 0 : 
    case 1 : 
      if ( mem [p + 5 ].hh .v.RH == -268435455L ) 
      curh = curh + mem [p + 1 ].cint ;
      else {
	  
	curv = baseline + mem [p + 4 ].cint ;
	tempptr = p ;
	edge = curh + mem [p + 1 ].cint ;
	if ( curdir == 1 ) 
	curh = edge ;
	if ( mem [p ].hh.b0 == 1 ) 
	pdfvlistout () ;
	else pdfhlistout () ;
	curh = edge ;
	curv = baseline ;
      } 
      break ;
    case 2 : 
      {
	ruleht = mem [p + 3 ].cint ;
	ruledp = mem [p + 2 ].cint ;
	rulewd = mem [p + 1 ].cint ;
	goto lab14 ;
      } 
      break ;
    case 8 : 
      switch ( mem [p ].hh.b1 ) 
      {case 6 : 
	pdfoutliteral ( p ) ;
	break ;
      case 8 : 
	{
	  pdfappendlistarg = mem [p + 1 ].hh .v.LH ;
	  pdfobjlist = appendptr ( pdfobjlist , pdfappendlistarg ) ;
	} 
	break ;
      case 10 : 
	{
	  curv = baseline ;
	  edge = curh ;
	  outform ( p ) ;
	  curh = edge + mem [p + 1 ].cint ;
	  curv = baseline ;
	} 
	break ;
      case 12 : 
	{
	  curv = baseline + mem [p + 3 ].cint ;
	  edge = curh ;
	  outimage ( p ) ;
	  curh = edge + mem [p + 1 ].cint ;
	  curv = baseline ;
	} 
	break ;
      case 13 : 
	doannot ( p , thisbox , leftedge , baseline ) ;
	break ;
      case 14 : 
	dolink ( p , thisbox , leftedge , baseline ) ;
	break ;
      case 15 : 
	{
	  endlink () ;
	  if ( runninglink == -268435455L ) 
	  {
	    if ( ( pdflinkwd == -1073741824L ) && ( pdflinklevel == curs ) ) 
	    {
	      appendlink ( thisbox , leftedge , baseline ) ;
	      runninglink = lastlink ;
	    } 
	  } 
	  else lastlink = runninglink ;
	} 
	break ;
      case 17 : 
	dodest ( p , thisbox , leftedge , baseline ) ;
	break ;
      case 18 : 
	dothread ( p , thisbox , leftedge , baseline ) ;
	break ;
      case 19 : 
	pdferror ( 1619 , 1712 ) ;
	break ;
      case 20 : 
	pdferror ( 1619 , 1713 ) ;
	break ;
      case 21 : 
	{
	  pdflastxpos = curh ;
	  if ( isshippingpage ) 
	  pdflastypos = curpageheight - curv ;
	  else pdflastypos = pdfxformheight + pdfxformdepth - curv ;
	} 
	break ;
      case 22 : 
	{
	  pdfsnapxpos = curh ;
	  pdfsnapypos = curv ;
	} 
	break ;
      case 23 : 
      case 24 : 
	{
	  dosnap ( p ) ;
	  if ( mem [thisbox + 5 ].hh .v.RH == p ) 
	  {
	    baseline = curv ;
	    leftedge = curh ;
	  } 
	} 
	break ;
      case 3 : 
	pdfspecial ( p ) ;
	break ;
	default: 
	outwhat ( p ) ;
	break ;
      } 
      break ;
    case 10 : 
      {
	g = mem [p + 1 ].hh .v.LH ;
	rulewd = mem [g + 1 ].cint ;
	if ( gsign != 0 ) 
	rulewd = rulewd + doglue ( thisbox , p ) ;
	if ( mem [p ].hh.b1 >= 100 ) 
	{
	  leaderbox = mem [p + 1 ].hh .v.RH ;
	  if ( mem [leaderbox ].hh.b0 == 2 ) 
	  {
	    ruleht = mem [leaderbox + 3 ].cint ;
	    ruledp = mem [leaderbox + 2 ].cint ;
	    goto lab14 ;
	  } 
	  leaderwd = mem [leaderbox + 1 ].cint ;
	  if ( ( leaderwd > 0 ) && ( rulewd > 0 ) ) 
	  {
	    rulewd = rulewd + 10 ;
	    if ( curdir == 1 ) 
	    curh = curh - 10 ;
	    edge = curh + rulewd ;
	    lx = 0 ;
	    if ( mem [p ].hh.b1 == 100 ) 
	    {
	      saveh = curh ;
	      curh = leftedge + leaderwd * ( ( curh - leftedge ) / leaderwd ) 
	      ;
	      if ( curh < saveh ) 
	      curh = curh + leaderwd ;
	    } 
	    else {
		
	      lq = rulewd / leaderwd ;
	      lr = rulewd % leaderwd ;
	      if ( mem [p ].hh.b1 == 101 ) 
	      curh = curh + ( lr / 2 ) ;
	      else {
		  
		lx = ( 2 * lr + lq + 1 ) / ( 2 * lq + 2 ) ;
		curh = curh + ( ( lr - ( lq - 1 ) * lx ) / 2 ) ;
	      } 
	    } 
	    while ( curh + leaderwd <= edge ) {
		
	      curv = baseline + mem [leaderbox + 4 ].cint ;
	      saveh = curh ;
	      tempptr = leaderbox ;
	      if ( curdir == 1 ) 
	      curh = curh + leaderwd ;
	      outerdoingleaders = doingleaders ;
	      doingleaders = true ;
	      if ( mem [leaderbox ].hh.b0 == 1 ) 
	      pdfvlistout () ;
	      else pdfhlistout () ;
	      doingleaders = outerdoingleaders ;
	      curv = baseline ;
	      curh = saveh + leaderwd + lx ;
	    } 
	    if ( curdir == 1 ) 
	    curh = edge ;
	    else curh = edge - 10 ;
	    goto lab15 ;
	  } 
	} 
	goto lab13 ;
      } 
      break ;
    case 40 : 
      curh = curh + mem [p + 1 ].cint ;
      break ;
    case 11 : 
      curh = curh + mem [p + 1 ].cint ;
      break ;
    case 9 : 
      {
	if ( ( eTeXmode == 1 ) ) 
	{
	  if ( odd ( mem [p ].hh.b1 ) ) 
	  if ( mem [LRptr ].hh .v.LH == ( 4 * ( mem [p ].hh.b1 / 4 ) + 3 ) 
	  ) 
	  {
	    tempptr = LRptr ;
	    LRptr = mem [tempptr ].hh .v.RH ;
	    {
	      mem [tempptr ].hh .v.RH = avail ;
	      avail = tempptr ;
	;
#ifdef STAT
	      decr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	  else {
	      
	    if ( mem [p ].hh.b1 > 4 ) 
	    incr ( LRproblems ) ;
	  } 
	  else {
	      
	    {
	      tempptr = getavail () ;
	      mem [tempptr ].hh .v.LH = ( 4 * ( mem [p ].hh.b1 / 4 ) + 3 ) 
	      ;
	      mem [tempptr ].hh .v.RH = LRptr ;
	      LRptr = tempptr ;
	    } 
	    if ( ( mem [p ].hh.b1 / 8 ) != curdir ) 
	    {
	      saveh = curh ;
	      tempptr = mem [p ].hh .v.RH ;
	      rulewd = mem [p + 1 ].cint ;
	      freenode ( p , 2 ) ;
	      curdir = 1 - curdir ;
	      p = newedge ( curdir , rulewd ) ;
	      mem [prevp ].hh .v.RH = p ;
	      curh = curh - leftedge + rulewd ;
	      mem [p ].hh .v.RH = reverse ( thisbox , newedge ( 1 - curdir , 
	      0 ) ) ;
	      mem [p + 2 ].cint = curh ;
	      curdir = 1 - curdir ;
	      curh = saveh ;
	      goto lab21 ;
	    } 
	  } 
	  mem [p ].hh.b0 = 11 ;
	} 
	curh = curh + mem [p + 1 ].cint ;
      } 
      break ;
    case 6 : 
      {
	mem [memtop - 12 ]= mem [p + 1 ];
	mem [memtop - 12 ].hh .v.RH = mem [p ].hh .v.RH ;
	p = memtop - 12 ;
	goto lab21 ;
      } 
      break ;
    case 14 : 
      {
	curh = curh + mem [p + 1 ].cint ;
	leftedge = curh + mem [p + 2 ].cint ;
	curdir = mem [p ].hh.b1 ;
      } 
      break ;
      default: 
      ;
      break ;
    } 
    goto lab15 ;
    lab14: if ( ( ruleht == -1073741824L ) ) 
    ruleht = mem [thisbox + 3 ].cint ;
    if ( ( ruledp == -1073741824L ) ) 
    ruledp = mem [thisbox + 2 ].cint ;
    ruleht = ruleht + ruledp ;
    if ( ( ruleht > 0 ) && ( rulewd > 0 ) ) 
    {
      curv = baseline + ruledp ;
      pdfsetrule ( curh , curv , rulewd , ruleht ) ;
      curv = baseline ;
    } 
    lab13: curh = curh + rulewd ;
    lab15: prevp = p ;
    p = mem [p ].hh .v.RH ;
  } 
  if ( ( eTeXmode == 1 ) ) 
  {
    {
      while ( mem [LRptr ].hh .v.LH != 0 ) {
	  
	if ( mem [LRptr ].hh .v.LH > 4 ) 
	LRproblems = LRproblems + 10000 ;
	{
	  tempptr = LRptr ;
	  LRptr = mem [tempptr ].hh .v.RH ;
	  {
	    mem [tempptr ].hh .v.RH = avail ;
	    avail = tempptr ;
	;
#ifdef STAT
	    decr ( dynused ) ;
#endif /* STAT */
	  } 
	} 
      } 
      {
	tempptr = LRptr ;
	LRptr = mem [tempptr ].hh .v.RH ;
	{
	  mem [tempptr ].hh .v.RH = avail ;
	  avail = tempptr ;
	;
#ifdef STAT
	  decr ( dynused ) ;
#endif /* STAT */
	} 
      } 
    } 
    if ( mem [thisbox ].hh.b1 == 2 ) 
    curdir = 1 ;
  } 
  decr ( curs ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
pdfvlistout ( void ) 
#else
pdfvlistout ( ) 
#endif
{
  /* 13 14 15 */ pdfvlistout_regmem 
  scaled leftedge  ;
  scaled topedge  ;
  scaled savev  ;
  halfword thisbox  ;
  char gsign  ;
  halfword p  ;
  halfword leaderbox  ;
  scaled leaderht  ;
  scaled lx  ;
  boolean outerdoingleaders  ;
  scaled edge  ;
  thisbox = tempptr ;
  gsign = mem [thisbox + 5 ].hh.b0 ;
  p = mem [thisbox + 5 ].hh .v.RH ;
  incr ( curs ) ;
  leftedge = curh ;
  curv = curv - mem [thisbox + 3 ].cint ;
  topedge = curv ;
  if ( ( lastthread != -268435455L ) && ( pdfthreaddp == -1073741824L ) && ( 
  pdfthreadlevel == curs ) ) 
  appendthread ( thisbox , leftedge , topedge + mem [thisbox + 3 ].cint ) ;
  while ( p != -268435455L ) {
      
    if ( ( p >= himemmin ) ) 
    confusion ( 983 ) ;
    else {
	
      switch ( mem [p ].hh.b0 ) 
      {case 0 : 
      case 1 : 
	if ( mem [p + 5 ].hh .v.RH == -268435455L ) 
	curv = curv + mem [p + 3 ].cint + mem [p + 2 ].cint ;
	else {
	    
	  curv = curv + mem [p + 3 ].cint ;
	  savev = curv ;
	  if ( curdir == 1 ) 
	  curh = leftedge - mem [p + 4 ].cint ;
	  else curh = leftedge + mem [p + 4 ].cint ;
	  tempptr = p ;
	  if ( mem [p ].hh.b0 == 1 ) 
	  pdfvlistout () ;
	  else pdfhlistout () ;
	  curv = savev + mem [p + 2 ].cint ;
	  curh = leftedge ;
	} 
	break ;
      case 2 : 
	{
	  ruleht = mem [p + 3 ].cint ;
	  ruledp = mem [p + 2 ].cint ;
	  rulewd = mem [p + 1 ].cint ;
	  goto lab14 ;
	} 
	break ;
      case 8 : 
	switch ( mem [p ].hh.b1 ) 
	{case 6 : 
	  pdfoutliteral ( p ) ;
	  break ;
	case 8 : 
	  {
	    pdfappendlistarg = mem [p + 1 ].hh .v.LH ;
	    pdfobjlist = appendptr ( pdfobjlist , pdfappendlistarg ) ;
	  } 
	  break ;
	case 10 : 
	  {
	    curv = curv + mem [p + 2 ].cint ;
	    savev = curv ;
	    curh = leftedge ;
	    outform ( p ) ;
	    curv = savev + mem [p + 3 ].cint ;
	    curh = leftedge ;
	  } 
	  break ;
	case 12 : 
	  {
	    curv = curv + mem [p + 2 ].cint + mem [p + 3 ].cint ;
	    savev = curv ;
	    curh = leftedge ;
	    outimage ( p ) ;
	    curv = savev ;
	    curh = leftedge ;
	  } 
	  break ;
	case 13 : 
	  doannot ( p , thisbox , leftedge , topedge + mem [thisbox + 3 ]
	  .cint ) ;
	  break ;
	case 14 : 
	  pdferror ( 1619 , 1710 ) ;
	  break ;
	case 15 : 
	  pdferror ( 1619 , 1711 ) ;
	  break ;
	case 17 : 
	  dodest ( p , thisbox , leftedge , topedge + mem [thisbox + 3 ]
	  .cint ) ;
	  break ;
	case 18 : 
	case 19 : 
	  dothread ( p , thisbox , leftedge , topedge + mem [thisbox + 3 ]
	  .cint ) ;
	  break ;
	case 20 : 
	  endthread () ;
	  break ;
	case 21 : 
	  {
	    pdflastxpos = curh ;
	    if ( isshippingpage ) 
	    pdflastypos = curpageheight - curv ;
	    else pdflastypos = pdfxformheight + pdfxformdepth - curv ;
	  } 
	  break ;
	case 22 : 
	  {
	    pdfsnapxpos = curh ;
	    pdfsnapypos = curv ;
	  } 
	  break ;
	case 23 : 
	case 24 : 
	  {
	    dosnap ( p ) ;
	    if ( mem [thisbox + 5 ].hh .v.RH == p ) 
	    {
	      topedge = curv ;
	      leftedge = curh ;
	    } 
	  } 
	  break ;
	case 3 : 
	  pdfspecial ( p ) ;
	  break ;
	  default: 
	  outwhat ( p ) ;
	  break ;
	} 
	break ;
      case 10 : 
	{
	  g = mem [p + 1 ].hh .v.LH ;
	  ruleht = mem [g + 1 ].cint ;
	  if ( gsign != 0 ) 
	  ruleht = ruleht + doglue ( thisbox , p ) ;
	  if ( mem [p ].hh.b1 >= 100 ) 
	  {
	    leaderbox = mem [p + 1 ].hh .v.RH ;
	    if ( mem [leaderbox ].hh.b0 == 2 ) 
	    {
	      rulewd = mem [leaderbox + 1 ].cint ;
	      ruledp = 0 ;
	      goto lab14 ;
	    } 
	    leaderht = mem [leaderbox + 3 ].cint + mem [leaderbox + 2 ]
	    .cint ;
	    if ( ( leaderht > 0 ) && ( ruleht > 0 ) ) 
	    {
	      ruleht = ruleht + 10 ;
	      edge = curv + ruleht ;
	      lx = 0 ;
	      if ( mem [p ].hh.b1 == 100 ) 
	      {
		savev = curv ;
		curv = topedge + leaderht * ( ( curv - topedge ) / leaderht ) 
		;
		if ( curv < savev ) 
		curv = curv + leaderht ;
	      } 
	      else {
		  
		lq = ruleht / leaderht ;
		lr = ruleht % leaderht ;
		if ( mem [p ].hh.b1 == 101 ) 
		curv = curv + ( lr / 2 ) ;
		else {
		    
		  lx = ( 2 * lr + lq + 1 ) / ( 2 * lq + 2 ) ;
		  curv = curv + ( ( lr - ( lq - 1 ) * lx ) / 2 ) ;
		} 
	      } 
	      while ( curv + leaderht <= edge ) {
		  
		if ( curdir == 1 ) 
		curh = leftedge - mem [leaderbox + 4 ].cint ;
		else curh = leftedge + mem [leaderbox + 4 ].cint ;
		curv = curv + mem [leaderbox + 3 ].cint ;
		savev = curv ;
		tempptr = leaderbox ;
		outerdoingleaders = doingleaders ;
		doingleaders = true ;
		if ( mem [leaderbox ].hh.b0 == 1 ) 
		pdfvlistout () ;
		else pdfhlistout () ;
		doingleaders = outerdoingleaders ;
		curh = leftedge ;
		curv = savev - mem [leaderbox + 3 ].cint + leaderht + lx ;
	      } 
	      curv = edge - 10 ;
	      goto lab15 ;
	    } 
	  } 
	  goto lab13 ;
	} 
	break ;
      case 11 : 
	curv = curv + mem [p + 1 ].cint ;
	break ;
	default: 
	;
	break ;
      } 
      goto lab15 ;
      lab14: if ( ( rulewd == -1073741824L ) ) 
      rulewd = mem [thisbox + 1 ].cint ;
      ruleht = ruleht + ruledp ;
      curv = curv + ruleht ;
      if ( ( ruleht > 0 ) && ( rulewd > 0 ) ) 
      {
	if ( curdir == 1 ) 
	curh = curh - rulewd ;
	pdfsetrule ( curh , curv , rulewd , ruleht ) ;
	curh = leftedge ;
      } 
      goto lab15 ;
      lab13: curv = curv + ruleht ;
    } 
    lab15: p = mem [p ].hh .v.RH ;
  } 
  decr ( curs ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
zpdfshipout ( halfword p , boolean shippingpage ) 
#else
zpdfshipout ( p , shippingpage ) 
  halfword p ;
  boolean shippingpage ;
#endif
{
  /* 30 31 */ pdfshipout_regmem 
  integer i, j, k  ;
  integer r  ;
  halfword savefontlist  ;
  halfword saveobjlist  ;
  halfword saveximagelist  ;
  halfword savexformlist  ;
  integer saveimageprocset  ;
  integer savetextprocset  ;
  integer pdflastresources  ;
  strnumber s  ;
  char oldsetting  ;
  if ( eqtb [15205 ].cint > 0 ) 
  {
    printnl ( 263 ) ;
    println () ;
    print ( 880 ) ;
  } 
  if ( ! initpdfoutput ) 
  {
    ensurepdfopen () ;
    preparemag () ;
    if ( ( eqtb [15188 ].cint != 1000 ) && ( eqtb [15188 ].cint != 0 ) ) 
    {
      if ( ( eqtb [15763 + cfghorigincode ].cint == cfgpar ( cfghorigincode 
      ) ) && iscfgtruedimen ( cfghorigincode ) ) 
      eqtb [15763 + cfghorigincode ].cint = roundxnoverd ( eqtb [15763 + 
      cfghorigincode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfgvorigincode ].cint == cfgpar ( cfgvorigincode 
      ) ) && iscfgtruedimen ( cfgvorigincode ) ) 
      eqtb [15763 + cfgvorigincode ].cint = roundxnoverd ( eqtb [15763 + 
      cfgvorigincode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfgpageheightcode ].cint == cfgpar ( 
      cfgpageheightcode ) ) && iscfgtruedimen ( cfgpageheightcode ) ) 
      eqtb [15763 + cfgpageheightcode ].cint = roundxnoverd ( eqtb [15763 + 
      cfgpageheightcode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfgpagewidthcode ].cint == cfgpar ( 
      cfgpagewidthcode ) ) && iscfgtruedimen ( cfgpagewidthcode ) ) 
      eqtb [15763 + cfgpagewidthcode ].cint = roundxnoverd ( eqtb [15763 + 
      cfgpagewidthcode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfglinkmargincode ].cint == cfgpar ( 
      cfglinkmargincode ) ) && iscfgtruedimen ( cfglinkmargincode ) ) 
      eqtb [15763 + cfglinkmargincode ].cint = roundxnoverd ( eqtb [15763 + 
      cfglinkmargincode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfgdestmargincode ].cint == cfgpar ( 
      cfgdestmargincode ) ) && iscfgtruedimen ( cfgdestmargincode ) ) 
      eqtb [15763 + cfgdestmargincode ].cint = roundxnoverd ( eqtb [15763 + 
      cfgdestmargincode ].cint , 1000 , eqtb [15188 ].cint ) ;
      if ( ( eqtb [15763 + cfgthreadmargincode ].cint == cfgpar ( 
      cfgthreadmargincode ) ) && iscfgtruedimen ( cfgthreadmargincode ) ) 
      eqtb [15763 + cfgthreadmargincode ].cint = roundxnoverd ( eqtb [15763 
      + cfgthreadmargincode ].cint , 1000 , eqtb [15188 ].cint ) ;
    } 
    fixeddecimaldigits = fixint ( eqtb [15229 ].cint , 0 , 4 ) ;
    minbpval = dividescaled ( onehundredbp , tenpow [fixeddecimaldigits + 2 ]
    , 0 ) ;
    fixedpkresolution = fixint ( eqtb [15232 ].cint , 72 , 2400 ) ;
    pkscalefactor = dividescaled ( 72 , fixedpkresolution , 5 + 
    fixeddecimaldigits ) ;
    setjobid ( eqtb [15194 ].cint , eqtb [15193 ].cint , eqtb [15192 ]
    .cint , eqtb [15191 ].cint ) ;
    if ( ( eqtb [15233 ].cint > 0 ) && ( pdfresnameprefix == 0 ) ) 
    pdfresnameprefix = getresnameprefix () ;
    initpdfoutput = true ;
  } 
  isshippingpage = shippingpage ;
  if ( shippingpage ) 
  {
    if ( termoffset > maxprintline - 9 ) 
    println () ;
    else if ( ( termoffset > 0 ) || ( fileoffset > 0 ) ) 
    printchar ( 32 ) ;
    printchar ( 91 ) ;
    j = 9 ;
    while ( ( eqtb [15251 + j ].cint == 0 ) && ( j > 0 ) ) decr ( j ) ;
    {register integer for_end; k = 0 ;for_end = j ; if ( k <= for_end) do 
      {
	printint ( eqtb [15251 + k ].cint ) ;
	if ( k < j ) 
	printchar ( 46 ) ;
      } 
    while ( k++ < for_end ) ;} 
    fflush ( stdout ) ;
  } 
  if ( eqtb [15205 ].cint > 0 ) 
  {
    if ( shippingpage ) 
    printchar ( 93 ) ;
    begindiagnostic () ;
    showbox ( p ) ;
    enddiagnostic ( true ) ;
  } 
  if ( ( mem [p + 3 ].cint > 1073741823L ) || ( mem [p + 2 ].cint > 
  1073741823L ) || ( mem [p + 3 ].cint + mem [p + 2 ].cint + eqtb [15782 
  ].cint > 1073741823L ) || ( mem [p + 1 ].cint + eqtb [15781 ].cint > 
  1073741823L ) ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 884 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 884 ) ;
      } 
    } 
    {
      helpptr = 2 ;
      helpline [1 ]= 885 ;
      helpline [0 ]= 886 ;
    } 
    error () ;
    if ( eqtb [15205 ].cint <= 0 ) 
    {
      begindiagnostic () ;
      printnl ( 887 ) ;
      showbox ( p ) ;
      enddiagnostic ( true ) ;
    } 
    goto lab30 ;
  } 
  if ( mem [p + 3 ].cint + mem [p + 2 ].cint + eqtb [15782 ].cint > maxv 
  ) 
  maxv = mem [p + 3 ].cint + mem [p + 2 ].cint + eqtb [15782 ].cint ;
  if ( mem [p + 1 ].cint + eqtb [15781 ].cint > maxh ) 
  maxh = mem [p + 1 ].cint + eqtb [15781 ].cint ;
  tempptr = p ;
  preparemag () ;
  pdflastresources = pdfnewobjnum () ;
  pdffontlist = -268435455L ;
  pdfobjlist = -268435455L ;
  pdfxformlist = -268435455L ;
  pdfximagelist = -268435455L ;
  pdftextprocset = false ;
  pdfimageprocset = 0 ;
  if ( ! shippingpage ) 
  {
    pdfxformwidth = mem [p + 1 ].cint ;
    pdfxformheight = mem [p + 3 ].cint ;
    pdfxformdepth = mem [p + 2 ].cint ;
    pdfbegindict ( pdfcurform ) ;
    pdflaststream = pdfcurform ;
    curv = mem [p + 3 ].cint ;
    curh = 0 ;
    pdforiginh = 0 ;
    pdforiginv = pdfxformheight + pdfxformdepth ;
  } 
  else {
      
    curhoffset = eqtb [15784 ].cint + eqtb [15781 ].cint ;
    curvoffset = eqtb [15785 ].cint + eqtb [15782 ].cint ;
    if ( eqtb [15786 ].cint != 0 ) 
    curpagewidth = eqtb [15786 ].cint ;
    else curpagewidth = mem [p + 1 ].cint + 2 * curhoffset ;
    if ( eqtb [15787 ].cint != 0 ) 
    curpageheight = eqtb [15787 ].cint ;
    else curpageheight = mem [p + 3 ].cint + mem [p + 2 ].cint + 2 * 
    curvoffset ;
    pdflastpage = getobj ( 1 , totalpages + 1 , 0 ) ;
    objtab [pdflastpage ].int3 = 1 ;
    pdfnewdict ( 0 , 0 ) ;
    pdflaststream = objptr ;
    curh = curhoffset ;
    curv = mem [p + 3 ].cint + curvoffset ;
    pdforiginh = 0 ;
    pdforiginv = curpageheight ;
    pdfannotlist = -268435455L ;
    pdflinklist = -268435455L ;
    pdfdestlist = -268435455L ;
    pdfbeadlist = -268435455L ;
    lastlink = -268435455L ;
    lastthread = -268435455L ;
  } 
  if ( ! shippingpage ) 
  {
    {
      pdfprint ( 984 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    {
      pdfprint ( 985 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    if ( pdfmem [objtab [pdfcurform ].int3 + 4 ]!= -268435455L ) 
    {
      pdfprinttoksln ( pdfmem [objtab [pdfcurform ].int3 + 4 ]) ;
      {
	deletetokenref ( pdfmem [objtab [pdfcurform ].int3 + 4 ]) ;
	pdfmem [objtab [pdfcurform ].int3 + 4 ]= -268435455L ;
      } 
    } 
    pdfprint ( 986 ) ;
    pdfprint ( 987 ) ;
    pdfprintbp ( pdfxformwidth ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintbp ( pdfxformheight + pdfxformdepth ) ;
    {
      pdfprint ( 93 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    {
      pdfprint ( 988 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    {
      pdfprint ( 989 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    pdfindirectln ( 990 , pdflastresources ) ;
  } 
  pdfbeginstream () ;
  if ( shippingpage ) 
  {
    if ( ( eqtb [15188 ].cint != 1000 ) && ( eqtb [15188 ].cint != 0 ) ) 
    {
      pdfprintreal ( eqtb [15188 ].cint , 3 ) ;
      pdfprint ( 991 ) ;
      pdfprintreal ( eqtb [15188 ].cint , 3 ) ;
      {
	pdfprint ( 992 ) ;
	{
	  if ( pdfptr + 1 >= pdfbufsize ) 
	  pdfflush () ;
	  {
	    pdfbuf [pdfptr ]= 10 ;
	    incr ( pdfptr ) ;
	  } 
	} 
      } 
    } 
  } 
  if ( mem [p ].hh.b0 == 1 ) 
  pdfvlistout () ;
  else pdfhlistout () ;
  if ( shippingpage ) 
  incr ( totalpages ) ;
  curs = -1 ;
  pdfendtext () ;
  pdfendstream () ;
  if ( shippingpage ) 
  {
    pdfbegindict ( pdflastpage ) ;
    {
      pdfprint ( 1004 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    pdfindirectln ( 1005 , pdflaststream ) ;
    pdfindirectln ( 990 , pdflastresources ) ;
    pdfprint ( 1006 ) ;
    pdfprintmagbp ( curpagewidth ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 32 ;
	incr ( pdfptr ) ;
      } 
    } 
    pdfprintmagbp ( curpageheight ) ;
    {
      pdfprint ( 93 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    if ( eqtb [13071 ].hh .v.RH != -268435455L ) 
    pdfprinttoksln ( eqtb [13071 ].hh .v.RH ) ;
    if ( totalpages % 6 == 1 ) 
    {
      pdfcreateobj ( 2 , 6 ) ;
      pdflastpages = objptr ;
    } 
    pdfindirectln ( 1007 , pdflastpages ) ;
    if ( ( pdfannotlist != -268435455L ) || ( pdflinklist != -268435455L ) ) 
    {
      pdfprint ( 1008 ) ;
      k = pdfannotlist ;
      while ( k != -268435455L ) {
	  
	pdfprintint ( mem [k ].hh .v.LH ) ;
	pdfprint ( 994 ) ;
	k = mem [k ].hh .v.RH ;
      } 
      k = pdflinklist ;
      while ( k != -268435455L ) {
	  
	pdfprintint ( mem [k ].hh .v.LH ) ;
	pdfprint ( 994 ) ;
	k = mem [k ].hh .v.RH ;
      } 
      {
	pdfprint ( 93 ) ;
	{
	  if ( pdfptr + 1 >= pdfbufsize ) 
	  pdfflush () ;
	  {
	    pdfbuf [pdfptr ]= 10 ;
	    incr ( pdfptr ) ;
	  } 
	} 
      } 
    } 
    if ( pdfbeadlist != -268435455L ) 
    {
      k = pdfbeadlist ;
      pdfprint ( 1009 ) ;
      while ( k != -268435455L ) {
	  
	pdfprintint ( mem [k ].hh .v.LH ) ;
	pdfprint ( 994 ) ;
	k = mem [k ].hh .v.RH ;
      } 
      {
	pdfprint ( 93 ) ;
	{
	  if ( pdfptr + 1 >= pdfbufsize ) 
	  pdfflush () ;
	  {
	    pdfbuf [pdfptr ]= 10 ;
	    incr ( pdfptr ) ;
	  } 
	} 
      } 
    } 
    pdfenddict () ;
  } 
  if ( pdfobjlist != -268435455L ) 
  {
    k = pdfobjlist ;
    while ( k != -268435455L ) {
	
      if ( ! ( objtab [mem [k ].hh .v.LH ].int2 != 0 ) ) 
      pdfwriteobj ( mem [k ].hh .v.LH ) ;
      k = mem [k ].hh .v.RH ;
    } 
  } 
  if ( pdfxformlist != -268435455L ) 
  {
    k = pdfxformlist ;
    while ( k != -268435455L ) {
	
      if ( ! ( objtab [mem [k ].hh .v.LH ].int2 != 0 ) ) 
      {
	pdfcurform = mem [k ].hh .v.LH ;
	savefontlist = pdffontlist ;
	saveobjlist = pdfobjlist ;
	savexformlist = pdfxformlist ;
	saveximagelist = pdfximagelist ;
	savetextprocset = pdftextprocset ;
	saveimageprocset = pdfimageprocset ;
	pdffontlist = -268435455L ;
	pdfobjlist = -268435455L ;
	pdfxformlist = -268435455L ;
	pdfximagelist = -268435455L ;
	pdftextprocset = false ;
	pdfimageprocset = 0 ;
	pdfshipout ( pdfmem [objtab [pdfcurform ].int3 + 3 ], false ) ;
	pdffontlist = savefontlist ;
	pdfobjlist = saveobjlist ;
	pdfxformlist = savexformlist ;
	pdfximagelist = saveximagelist ;
	pdftextprocset = savetextprocset ;
	pdfimageprocset = saveimageprocset ;
      } 
      k = mem [k ].hh .v.RH ;
    } 
  } 
  if ( pdfximagelist != -268435455L ) 
  {
    k = pdfximagelist ;
    while ( k != -268435455L ) {
	
      if ( ! ( objtab [mem [k ].hh .v.LH ].int2 != 0 ) ) 
      pdfwriteimage ( mem [k ].hh .v.LH ) ;
      k = mem [k ].hh .v.RH ;
    } 
  } 
  if ( shippingpage ) 
  {
    pdforiginh = 0 ;
    pdforiginv = curpageheight ;
    if ( pdfannotlist != -268435455L ) 
    {
      k = pdfannotlist ;
      while ( k != -268435455L ) {
	  
	i = objtab [mem [k ].hh .v.LH ].int3 ;
	pdfbegindict ( mem [k ].hh .v.LH ) ;
	{
	  pdfprint ( 1015 ) ;
	  {
	    if ( pdfptr + 1 >= pdfbufsize ) 
	    pdfflush () ;
	    {
	      pdfbuf [pdfptr ]= 10 ;
	      incr ( pdfptr ) ;
	    } 
	  } 
	} 
	pdfprinttoksln ( mem [i + 5 ].hh .v.LH ) ;
	pdfrectangle ( mem [i + 1 ].cint , mem [i + 2 ].cint , mem [i + 3 
	].cint , mem [i + 4 ].cint ) ;
	pdfenddict () ;
	k = mem [k ].hh .v.RH ;
      } 
    } 
    if ( pdflinklist != -268435455L ) 
    {
      k = pdflinklist ;
      while ( k != -268435455L ) {
	  
	i = objtab [mem [k ].hh .v.LH ].int3 ;
	pdfbegindict ( mem [k ].hh .v.LH ) ;
	{
	  pdfprint ( 1015 ) ;
	  {
	    if ( pdfptr + 1 >= pdfbufsize ) 
	    pdfflush () ;
	    {
	      pdfbuf [pdfptr ]= 10 ;
	      incr ( pdfptr ) ;
	    } 
	  } 
	} 
	if ( mem [i + 5 ].hh .v.LH != -268435455L ) 
	pdfprinttoksln ( mem [i + 5 ].hh .v.LH ) ;
	pdfrectangle ( mem [i + 1 ].cint , mem [i + 2 ].cint , mem [i + 3 
	].cint , mem [i + 4 ].cint ) ;
	if ( mem [mem [i + 5 ].hh .v.RH ].hh.b0 != 3 ) 
	{
	  {
	    pdfprint ( 1016 ) ;
	    {
	      if ( pdfptr + 1 >= pdfbufsize ) 
	      pdfflush () ;
	      {
		pdfbuf [pdfptr ]= 10 ;
		incr ( pdfptr ) ;
	      } 
	    } 
	  } 
	  pdfprint ( 1017 ) ;
	} 
	writeaction ( mem [i + 5 ].hh .v.RH ) ;
	pdfenddict () ;
	k = mem [k ].hh .v.RH ;
      } 
      k = pdflinklist ;
      while ( k != -268435455L ) {
	  
	i = objtab [mem [k ].hh .v.LH ].int3 ;
	if ( mem [i ].hh .v.LH == 268435455L ) 
	flushwhatsitnode ( i , 14 ) ;
	k = mem [k ].hh .v.RH ;
      } 
    } 
    if ( pdfdestlist != -268435455L ) 
    {
      k = pdfdestlist ;
      while ( k != -268435455L ) {
	  
	if ( ( objtab [mem [k ].hh .v.LH ].int2 != 0 ) ) 
	pdferror ( 1010 , 1018 ) ;
	else {
	    
	  i = objtab [mem [k ].hh .v.LH ].int3 ;
	  if ( mem [i + 5 ].hh.b1 > 0 ) 
	  {
	    pdfbegindict ( mem [k ].hh .v.LH ) ;
	    pdfprint ( 1019 ) ;
	  } 
	  else pdfbeginobj ( mem [k ].hh .v.LH ) ;
	  {
	    if ( pdfptr + 1 >= pdfbufsize ) 
	    pdfflush () ;
	    {
	      pdfbuf [pdfptr ]= 91 ;
	      incr ( pdfptr ) ;
	    } 
	  } 
	  pdfprintint ( pdflastpage ) ;
	  pdfprint ( 994 ) ;
	  switch ( mem [i + 5 ].hh.b0 ) 
	  {case 0 : 
	    {
	      pdfprint ( 1020 ) ;
	      pdfprintmagbp ( ( ( mem [i + 1 ].cint ) - pdforiginh ) ) ;
	      {
		if ( pdfptr + 1 >= pdfbufsize ) 
		pdfflush () ;
		{
		  pdfbuf [pdfptr ]= 32 ;
		  incr ( pdfptr ) ;
		} 
	      } 
	      pdfprintmagbp ( ( pdforiginv - ( mem [i + 2 ].cint ) ) ) ;
	      {
		if ( pdfptr + 1 >= pdfbufsize ) 
		pdfflush () ;
		{
		  pdfbuf [pdfptr ]= 32 ;
		  incr ( pdfptr ) ;
		} 
	      } 
	      if ( mem [i + 6 ].hh .v.LH == -268435455L ) 
	      pdfprint ( 1021 ) ;
	      else {
		  
		pdfprintint ( mem [i + 6 ].hh .v.LH / 1000 ) ;
		{
		  if ( pdfptr + 1 >= pdfbufsize ) 
		  pdfflush () ;
		  {
		    pdfbuf [pdfptr ]= 46 ;
		    incr ( pdfptr ) ;
		  } 
		} 
		pdfprintint ( ( mem [i + 6 ].hh .v.LH % 1000 ) ) ;
	      } 
	    } 
	    break ;
	  case 1 : 
	    pdfprint ( 1022 ) ;
	    break ;
	  case 2 : 
	    {
	      pdfprint ( 1023 ) ;
	      pdfprintmagbp ( ( pdforiginv - ( mem [i + 2 ].cint ) ) ) ;
	    } 
	    break ;
	  case 3 : 
	    {
	      pdfprint ( 1024 ) ;
	      pdfprintmagbp ( ( ( mem [i + 1 ].cint ) - pdforiginh ) ) ;
	    } 
	    break ;
	  case 4 : 
	    pdfprint ( 1025 ) ;
	    break ;
	  case 5 : 
	    {
	      pdfprint ( 1026 ) ;
	      pdfprintmagbp ( ( pdforiginv - ( mem [i + 2 ].cint ) ) ) ;
	    } 
	    break ;
	  case 6 : 
	    {
	      pdfprint ( 1027 ) ;
	      pdfprintmagbp ( ( ( mem [i + 1 ].cint ) - pdforiginh ) ) ;
	    } 
	    break ;
	  case 7 : 
	    {
	      pdfprint ( 1028 ) ;
	      pdfprintrectspec ( i ) ;
	    } 
	    break ;
	    default: 
	    pdferror ( 1010 , 1029 ) ;
	    break ;
	  } 
	  {
	    pdfprint ( 93 ) ;
	    {
	      if ( pdfptr + 1 >= pdfbufsize ) 
	      pdfflush () ;
	      {
		pdfbuf [pdfptr ]= 10 ;
		incr ( pdfptr ) ;
	      } 
	    } 
	  } 
	  if ( mem [i + 5 ].hh.b1 > 0 ) 
	  pdfenddict () ;
	  else pdfendobj () ;
	} 
	k = mem [k ].hh .v.RH ;
      } 
    } 
    if ( pdfbeadlist != -268435455L ) 
    {
      k = pdfbeadlist ;
      while ( k != -268435455L ) {
	  
	pdfnewobj ( 0 , 0 ) ;
	{
	  if ( pdfptr + 1 >= pdfbufsize ) 
	  pdfflush () ;
	  {
	    pdfbuf [pdfptr ]= 91 ;
	    incr ( pdfptr ) ;
	  } 
	} 
	i = pdfmem [objtab [mem [k ].hh .v.LH ].int3 ];
	pdfprintrectspec ( i ) ;
	if ( mem [i ].hh .v.LH == 268435455L ) 
	flushwhatsitnode ( i , 19 ) ;
	{
	  pdfprint ( 93 ) ;
	  {
	    if ( pdfptr + 1 >= pdfbufsize ) 
	    pdfflush () ;
	    {
	      pdfbuf [pdfptr ]= 10 ;
	      incr ( pdfptr ) ;
	    } 
	  } 
	} 
	pdfmem [objtab [mem [k ].hh .v.LH ].int3 ]= objptr ;
	pdfendobj () ;
	k = mem [k ].hh .v.RH ;
      } 
    } 
  } 
  pdfbegindict ( pdflastresources ) ;
  if ( shippingpage ) 
  {
    if ( eqtb [13072 ].hh .v.RH != -268435455L ) 
    pdfprinttoksln ( eqtb [13072 ].hh .v.RH ) ;
  } 
  else {
      
    if ( pdfmem [objtab [pdfcurform ].int3 + 5 ]!= -268435455L ) 
    {
      pdfprinttoksln ( pdfmem [objtab [pdfcurform ].int3 + 5 ]) ;
      {
	deletetokenref ( pdfmem [objtab [pdfcurform ].int3 + 5 ]) ;
	pdfmem [objtab [pdfcurform ].int3 + 5 ]= -268435455L ;
      } 
    } 
  } 
  if ( pdffontlist != -268435455L ) 
  {
    pdfprint ( 993 ) ;
    k = pdffontlist ;
    while ( k != -268435455L ) {
	
      pdfprint ( 927 ) ;
      {
	if ( pdffontnum [mem [k ].hh .v.LH ]< 0 ) 
	ff = - (integer) pdffontnum [mem [k ].hh .v.LH ];
	else ff = mem [k ].hh .v.LH ;
      } 
      pdfprintint ( ff ) ;
      pdfprintfonttag ( mem [k ].hh .v.LH ) ;
      if ( pdfresnameprefix != 0 ) 
      pdfprint ( pdfresnameprefix ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 32 ;
	  incr ( pdfptr ) ;
	} 
      } 
      pdfprintint ( pdffontnum [ff ]) ;
      pdfprint ( 994 ) ;
      k = mem [k ].hh .v.RH ;
    } 
    {
      pdfprint ( 911 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
    pdftextprocset = true ;
  } 
  if ( ( pdfxformlist != -268435455L ) || ( pdfximagelist != -268435455L ) ) 
  {
    pdfprint ( 995 ) ;
    k = pdfxformlist ;
    while ( k != -268435455L ) {
	
      pdfprint ( 996 ) ;
      pdfprintint ( objtab [mem [k ].hh .v.LH ].int0 ) ;
      if ( pdfresnameprefix != 0 ) 
      pdfprint ( pdfresnameprefix ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 32 ;
	  incr ( pdfptr ) ;
	} 
      } 
      pdfprintint ( mem [k ].hh .v.LH ) ;
      pdfprint ( 994 ) ;
      k = mem [k ].hh .v.RH ;
    } 
    k = pdfximagelist ;
    while ( k != -268435455L ) {
	
      pdfprint ( 997 ) ;
      pdfprintint ( objtab [mem [k ].hh .v.LH ].int0 ) ;
      if ( pdfresnameprefix != 0 ) 
      pdfprint ( pdfresnameprefix ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 32 ;
	  incr ( pdfptr ) ;
	} 
      } 
      pdfprintint ( mem [k ].hh .v.LH ) ;
      pdfprint ( 994 ) ;
      updateimageprocset ( pdfmem [objtab [mem [k ].hh .v.LH ].int3 + 4 ]
      ) ;
      k = mem [k ].hh .v.RH ;
    } 
    {
      pdfprint ( 911 ) ;
      {
	if ( pdfptr + 1 >= pdfbufsize ) 
	pdfflush () ;
	{
	  pdfbuf [pdfptr ]= 10 ;
	  incr ( pdfptr ) ;
	} 
      } 
    } 
  } 
  pdfprint ( 998 ) ;
  if ( pdftextprocset ) 
  pdfprint ( 999 ) ;
  if ( checkimageb ( pdfimageprocset ) ) 
  pdfprint ( 1000 ) ;
  if ( checkimagec ( pdfimageprocset ) ) 
  pdfprint ( 1001 ) ;
  if ( checkimagei ( pdfimageprocset ) ) 
  pdfprint ( 1002 ) ;
  {
    pdfprint ( 1003 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  pdfenddict () ;
  flushlist ( pdffontlist ) ;
  flushlist ( pdfobjlist ) ;
  flushlist ( pdfxformlist ) ;
  flushlist ( pdfximagelist ) ;
  if ( shippingpage ) 
  {
    flushlist ( pdfannotlist ) ;
    flushlist ( pdflinklist ) ;
    flushlist ( pdfdestlist ) ;
    flushlist ( pdfbeadlist ) ;
  } 
  lab30: ;
  if ( ( eTeXmode == 1 ) ) 
  {
    if ( LRproblems > 0 ) 
    {
      {
	println () ;
	printnl ( 1774 ) ;
	printint ( LRproblems / 10000 ) ;
	print ( 1775 ) ;
	printint ( LRproblems % 10000 ) ;
	print ( 1776 ) ;
	LRproblems = 0 ;
      } 
      printchar ( 41 ) ;
      println () ;
    } 
    if ( ( LRptr != -268435455L ) || ( curdir != 0 ) ) 
    confusion ( 1778 ) ;
  } 
  if ( ( eqtb [15205 ].cint <= 0 ) && shippingpage ) 
  printchar ( 93 ) ;
  deadcycles = 0 ;
  fflush ( stdout ) ;
	;
#ifdef STAT
  if ( eqtb [15202 ].cint > 1 ) 
  {
    printnl ( 881 ) ;
    printint ( varused ) ;
    printchar ( 38 ) ;
    printint ( dynused ) ;
    printchar ( 59 ) ;
  } 
#endif /* STAT */
  flushnodelist ( p ) ;
	;
#ifdef STAT
  if ( eqtb [15202 ].cint > 1 ) 
  {
    print ( 882 ) ;
    printint ( varused ) ;
    printchar ( 38 ) ;
    printint ( dynused ) ;
    print ( 883 ) ;
    printint ( himemmin - lomemmax - 1 ) ;
    println () ;
  } 
#endif /* STAT */
} 
void 
#ifdef HAVE_PROTOTYPES
zshipout ( halfword p ) 
#else
zshipout ( p ) 
  halfword p ;
#endif
{
  shipout_regmem 
  if ( totalpages == 0 ) 
  fixedoutput = eqtb [15226 ].cint ;
  else if ( fixedoutput != eqtb [15226 ].cint ) 
  pdferror ( 1037 , 1038 ) ;
  if ( eqtb [15226 ].cint > 0 ) 
  pdfshipout ( p , true ) ;
  else dvishipout ( p ) ;
} 
boolean 
#ifdef HAVE_PROTOTYPES
zstrlessstr ( strnumber s1 , strnumber s2 ) 
#else
zstrlessstr ( s1 , s2 ) 
  strnumber s1 ;
  strnumber s2 ;
#endif
{
  register boolean Result; strlessstr_regmem 
  poolpointer j1, j2  ;
  integer l, i  ;
  j1 = strstart [s1 ];
  j2 = strstart [s2 ];
  if ( ( strstart [s1 + 1 ]- strstart [s1 ]) < ( strstart [s2 + 1 ]- 
  strstart [s2 ]) ) 
  l = ( strstart [s1 + 1 ]- strstart [s1 ]) ;
  else l = ( strstart [s2 + 1 ]- strstart [s2 ]) ;
  i = 0 ;
  while ( ( i < l ) && ( strpool [j1 + i ]== strpool [j2 + i ]) ) incr ( i 
  ) ;
  if ( ( ( i < l ) && ( strpool [j1 + i ]< strpool [j2 + i ]) ) || ( ( i 
  == l ) && ( ( strstart [s1 + 1 ]- strstart [s1 ]) < ( strstart [s2 + 1 
  ]- strstart [s2 ]) ) ) ) 
  Result = true ;
  else Result = false ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zsortdestnames ( integer l , integer r ) 
#else
zsortdestnames ( l , r ) 
  integer l ;
  integer r ;
#endif
{
  sortdestnames_regmem 
  integer i, j  ;
  strnumber s  ;
  integer x, y  ;
  destnameentry e  ;
  i = l ;
  j = r ;
  s = destnames [( l + r ) / 2 ].objname ;
  do {
      while ( strlessstr ( destnames [i ].objname , s ) ) incr ( i ) ;
    while ( strlessstr ( s , destnames [j ].objname ) ) decr ( j ) ;
    if ( i <= j ) 
    {
      e = destnames [i ];
      destnames [i ]= destnames [j ];
      destnames [j ]= e ;
      incr ( i ) ;
      decr ( j ) ;
    } 
  } while ( ! ( i > j ) ) ;
  if ( l < j ) 
  sortdestnames ( l , j ) ;
  if ( i < r ) 
  sortdestnames ( i , r ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
zpdffixdest ( integer k ) 
#else
zpdffixdest ( k ) 
  integer k ;
#endif
{
  pdffixdest_regmem 
  if ( objtab [k ].int3 != -268435455L ) 
  return ;
  pdfwarning ( 1039 , 263 , false ) ;
  if ( objtab [k ].int0 < 0 ) 
  {
    print ( 1040 ) ;
    print ( - (integer) objtab [k ].int0 ) ;
    print ( 125 ) ;
  } 
  else {
      
    print ( 1041 ) ;
    printint ( objtab [k ].int0 ) ;
  } 
  print ( 1042 ) ;
  println () ;
  println () ;
  pdfbeginobj ( k ) ;
  {
    if ( pdfptr + 1 >= pdfbufsize ) 
    pdfflush () ;
    {
      pdfbuf [pdfptr ]= 91 ;
      incr ( pdfptr ) ;
    } 
  } 
  pdfprintint ( headtab [1 ]) ;
  {
    pdfprint ( 1043 ) ;
    {
      if ( pdfptr + 1 >= pdfbufsize ) 
      pdfflush () ;
      {
	pdfbuf [pdfptr ]= 10 ;
	incr ( pdfptr ) ;
      } 
    } 
  } 
  pdfendobj () ;
} 
strnumber 
#ifdef HAVE_PROTOTYPES
getnullstr ( void ) 
#else
getnullstr ( ) 
#endif
{
  register strnumber Result; getnullstr_regmem 
  Result = 263 ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zscanspec ( groupcode c , boolean threecodes ) 
#else
zscanspec ( c , threecodes ) 
  groupcode c ;
  boolean threecodes ;
#endif
{
  /* 40 */ scanspec_regmem 
  integer s  ;
  char speccode  ;
  if ( threecodes ) 
  s = savestack [saveptr + 0 ].cint ;
  if ( scankeyword ( 1072 ) ) 
  speccode = 0 ;
  else if ( scankeyword ( 1073 ) ) 
  speccode = 1 ;
  else {
      
    speccode = 1 ;
    curval = 0 ;
    goto lab40 ;
  } 
  scandimen ( false , false , false ) ;
  lab40: if ( threecodes ) 
  {
    savestack [saveptr + 0 ].cint = s ;
    incr ( saveptr ) ;
  } 
  savestack [saveptr + 0 ].cint = speccode ;
  savestack [saveptr + 1 ].cint = curval ;
  saveptr = saveptr + 2 ;
  newsavelevel ( c ) ;
  scanleftbrace () ;
} 
boolean 
#ifdef HAVE_PROTOTYPES
zcheckexpandpars ( internalfontnumber f ) 
#else
zcheckexpandpars ( f ) 
  internalfontnumber f ;
#endif
{
  register boolean Result; checkexpandpars_regmem 
  internalfontnumber k  ;
  Result = false ;
  if ( ( pdffontstep [f ]== 0 ) || ( ( pdffontstretch [f ]== 0 ) && ( 
  pdffontshrink [f ]== 0 ) ) ) 
  return Result ;
  if ( curfontstep < 0 ) 
  curfontstep = pdffontstep [f ];
  else if ( curfontstep != pdffontstep [f ]) 
  pdferror ( 1074 , 1075 ) ;
  k = pdffontstretch [f ];
  if ( k != 0 ) 
  {
    if ( maxstretchratio < 0 ) 
    maxstretchratio = pdffontexpandratio [k ];
    else if ( maxstretchratio != pdffontexpandratio [k ]) 
    pdferror ( 1074 , 1076 ) ;
  } 
  k = pdffontshrink [f ];
  if ( k != 0 ) 
  {
    if ( maxshrinkratio < 0 ) 
    maxshrinkratio = pdffontexpandratio [k ];
    else if ( maxshrinkratio != pdffontexpandratio [k ]) 
    pdferror ( 1074 , 1076 ) ;
  } 
  Result = true ;
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zcharstretch ( internalfontnumber f , eightbits c ) 
#else
zcharstretch ( f , c ) 
  internalfontnumber f ;
  eightbits c ;
#endif
{
  register scaled Result; charstretch_regmem 
  internalfontnumber k  ;
  scaled dw  ;
  integer ef  ;
  Result = 0 ;
  k = pdffontstretch [f ];
  ef = getefcode ( f , c ) ;
  if ( ( k != 0 ) && ( ef > 0 ) ) 
  {
    dw = fontinfo [widthbase [k ]+ fontinfo [charbase [k ]+ 
    effectivechar ( true , k , c ) ].qqqq .b0 ].cint - fontinfo [widthbase 
    [f ]+ fontinfo [charbase [f ]+ effectivechar ( true , f , c ) ].qqqq 
    .b0 ].cint ;
    if ( dw > 0 ) 
    Result = roundxnoverd ( dw , ef , 1000 ) ;
  } 
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zcharshrink ( internalfontnumber f , eightbits c ) 
#else
zcharshrink ( f , c ) 
  internalfontnumber f ;
  eightbits c ;
#endif
{
  register scaled Result; charshrink_regmem 
  internalfontnumber k  ;
  scaled dw  ;
  integer ef  ;
  Result = 0 ;
  k = pdffontshrink [f ];
  ef = getefcode ( f , c ) ;
  if ( ( k != 0 ) && ( ef > 0 ) ) 
  {
    dw = fontinfo [widthbase [f ]+ fontinfo [charbase [f ]+ 
    effectivechar ( true , f , c ) ].qqqq .b0 ].cint - fontinfo [widthbase 
    [k ]+ fontinfo [charbase [k ]+ effectivechar ( true , k , c ) ].qqqq 
    .b0 ].cint ;
    if ( dw > 0 ) 
    Result = roundxnoverd ( dw , ef , 1000 ) ;
  } 
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zgetkern ( internalfontnumber f , eightbits lc , eightbits rc ) 
#else
zgetkern ( f , lc , rc ) 
  internalfontnumber f ;
  eightbits lc ;
  eightbits rc ;
#endif
{
  /* 22 */ register scaled Result; getkern_regmem 
  fourquarters i  ;
  fourquarters j  ;
  fontindex k  ;
  halfword p  ;
  integer s  ;
  Result = 0 ;
  i = fontinfo [charbase [f ]+ effectivechar ( true , f , lc ) ].qqqq ;
  if ( ( ( i .b2 ) % 4 ) != 1 ) 
  return Result ;
  k = ligkernbase [f ]+ i .b3 ;
  j = fontinfo [k ].qqqq ;
  if ( j .b0 <= 128 ) 
  goto lab23 ;
  k = ligkernbase [f ]+ 256 * j .b2 + j .b3 + 32768L - 256 * ( 128 ) ;
  lab22: j = fontinfo [k ].qqqq ;
  lab23: if ( ( j .b1 == rc ) && ( j .b0 <= 128 ) && ( j .b2 >= 128 ) ) 
  {
    Result = fontinfo [kernbase [f ]+ 256 * j .b2 + j .b3 ].cint ;
    return Result ;
  } 
  if ( j .b0 == 0 ) 
  incr ( k ) ;
  else {
      
    if ( j .b0 >= 128 ) 
    return Result ;
    k = k + j .b0 + 1 ;
  } 
  goto lab22 ;
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zkernstretch ( halfword p ) 
#else
zkernstretch ( p ) 
  halfword p ;
#endif
{
  register scaled Result; kernstretch_regmem 
  halfword l, r  ;
  scaled d  ;
  Result = 0 ;
  if ( ( prevcharp == -268435455L ) || ( mem [prevcharp ].hh .v.RH != p ) || 
  ( mem [p ].hh .v.RH == -268435455L ) ) 
  return Result ;
  l = prevcharp ;
  r = mem [p ].hh .v.RH ;
  if ( mem [l ].hh.b0 == 6 ) 
  l = l + 1 ;
  if ( mem [r ].hh.b0 == 6 ) 
  r = r + 1 ;
  if ( ! ( ( l >= himemmin ) && ( r >= himemmin ) && ( mem [l ].hh.b0 == mem 
  [r ].hh.b0 ) && ( pdffontstretch [mem [l ].hh.b0 ]!= 0 ) ) ) 
  return Result ;
  d = getkern ( pdffontstretch [mem [l ].hh.b0 ], mem [l ].hh.b1 , mem [
  r ].hh.b1 ) ;
  Result = roundxnoverd ( d - mem [p + 1 ].cint , getefcode ( mem [l ]
  .hh.b0 , mem [l ].hh.b1 ) , 1000 ) ;
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zkernshrink ( halfword p ) 
#else
zkernshrink ( p ) 
  halfword p ;
#endif
{
  register scaled Result; kernshrink_regmem 
  halfword l, r  ;
  scaled d  ;
  Result = 0 ;
  if ( ( prevcharp == -268435455L ) || ( mem [prevcharp ].hh .v.RH != p ) || 
  ( mem [p ].hh .v.RH == -268435455L ) ) 
  return Result ;
  l = prevcharp ;
  r = mem [p ].hh .v.RH ;
  if ( mem [l ].hh.b0 == 6 ) 
  l = l + 1 ;
  if ( mem [r ].hh.b0 == 6 ) 
  r = r + 1 ;
  if ( ! ( ( l >= himemmin ) && ( r >= himemmin ) && ( mem [l ].hh.b0 == mem 
  [r ].hh.b0 ) && ( pdffontshrink [mem [l ].hh.b0 ]!= 0 ) ) ) 
  return Result ;
  d = getkern ( pdffontshrink [mem [l ].hh.b0 ], mem [l ].hh.b1 , mem [
  r ].hh.b1 ) ;
  Result = roundxnoverd ( mem [p + 1 ].cint - d , getefcode ( mem [l ]
  .hh.b0 , mem [l ].hh.b1 ) , 1000 ) ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zdosubstfont ( halfword p , integer exratio ) 
#else
zdosubstfont ( p , exratio ) 
  halfword p ;
  integer exratio ;
#endif
{
  dosubstfont_regmem 
  internalfontnumber f, k  ;
  halfword r  ;
  integer ef  ;
  if ( ! ( p >= himemmin ) && ( mem [p ].hh.b0 == 7 ) ) 
  {
    r = mem [p + 1 ].hh .v.LH ;
    while ( r != -268435455L ) {
	
      if ( ( r >= himemmin ) || ( mem [r ].hh.b0 == 6 ) ) 
      dosubstfont ( r , exratio ) ;
      r = mem [r ].hh .v.RH ;
    } 
    r = mem [p + 1 ].hh .v.RH ;
    while ( r != -268435455L ) {
	
      if ( ( r >= himemmin ) || ( mem [r ].hh.b0 == 6 ) ) 
      dosubstfont ( r , exratio ) ;
      r = mem [r ].hh .v.RH ;
    } 
    return ;
  } 
  if ( ( p >= himemmin ) ) 
  r = p ;
  else if ( mem [p ].hh.b0 == 6 ) 
  r = p + 1 ;
  else {
      
    shortdisplayn ( p , 5 ) ;
    pdferror ( 1074 , 1077 ) ;
  } 
  f = mem [r ].hh.b0 ;
  ef = getefcode ( f , mem [r ].hh.b1 ) ;
  if ( ef == 0 ) 
  return ;
  if ( ( pdffontstretch [f ]!= 0 ) && ( exratio > 0 ) ) 
  k = expandfont ( f , dividescaled ( exratio * pdffontexpandratio [
  pdffontstretch [f ]]* ef , 1000000L , 0 ) ) ;
  else if ( ( pdffontshrink [f ]!= 0 ) && ( exratio < 0 ) ) 
  k = expandfont ( f , - (integer) dividescaled ( exratio * pdffontexpandratio 
  [pdffontshrink [f ]]* ef , 1000000L , 0 ) ) ;
  else k = f ;
  if ( k != f ) 
  {
    mem [r ].hh.b0 = k ;
    if ( ! ( p >= himemmin ) ) 
    {
      r = mem [p + 1 ].hh .v.RH ;
      while ( r != -268435455L ) {
	  
	mem [r ].hh.b0 = k ;
	r = mem [r ].hh .v.RH ;
      } 
    } 
  } 
} 
scaled 
#ifdef HAVE_PROTOTYPES
zcharpw ( halfword p , smallnumber side ) 
#else
zcharpw ( p , side ) 
  halfword p ;
  smallnumber side ;
#endif
{
  register scaled Result; charpw_regmem 
  internalfontnumber f  ;
  integer c  ;
  Result = 0 ;
  if ( side == 0 ) 
  lastleftmostchar = -268435455L ;
  else lastrightmostchar = -268435455L ;
  if ( p == -268435455L ) 
  return Result ;
  if ( mem [p ].hh.b0 == 6 ) 
  p = p + 1 ;
  else if ( ! ( p >= himemmin ) ) 
  return Result ;
  f = mem [p ].hh.b0 ;
  if ( side == 0 ) 
  {
    c = getlpcode ( f , mem [p ].hh.b1 ) ;
    lastleftmostchar = p ;
  } 
  else {
      
    c = getrpcode ( f , mem [p ].hh.b1 ) ;
    lastrightmostchar = p ;
  } 
  if ( c == 0 ) 
  return Result ;
  Result = roundxnoverd ( fontinfo [6 + parambase [f ]].cint , c , 1000 ) 
  ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
znewmarginkern ( scaled w , halfword p , smallnumber side ) 
#else
znewmarginkern ( w , p , side ) 
  scaled w ;
  halfword p ;
  smallnumber side ;
#endif
{
  register halfword Result; newmarginkern_regmem 
  halfword k  ;
  k = getnode ( 3 ) ;
  mem [k ].hh.b0 = 40 ;
  mem [k ].hh.b1 = side ;
  mem [k + 1 ].cint = w ;
  if ( p == -268435455L ) 
  pdferror ( 1078 , 1079 ) ;
  {
    mem [k + 2 ].hh .v.LH = avail ;
    if ( mem [k + 2 ].hh .v.LH == -268435455L ) 
    mem [k + 2 ].hh .v.LH = getavail () ;
    else {
	
      avail = mem [mem [k + 2 ].hh .v.LH ].hh .v.RH ;
      mem [mem [k + 2 ].hh .v.LH ].hh .v.RH = -268435455L ;
	;
#ifdef STAT
      incr ( dynused ) ;
#endif /* STAT */
    } 
  } 
  mem [mem [k + 2 ].hh .v.LH ].hh.b1 = mem [p ].hh.b1 ;
  mem [mem [k + 2 ].hh .v.LH ].hh.b0 = mem [p ].hh.b0 ;
  Result = k ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zhpack ( halfword p , scaled w , smallnumber m ) 
#else
zhpack ( p , w , m ) 
  halfword p ;
  scaled w ;
  smallnumber m ;
#endif
{
  /* 21 50 10 */ register halfword Result; hpack_regmem 
  halfword r  ;
  halfword q  ;
  scaled h, d, x  ;
  scaled s  ;
  halfword g  ;
  glueord o  ;
  internalfontnumber f  ;
  fourquarters i  ;
  eightbits hd  ;
  scaled fontstretch  ;
  scaled fontshrink  ;
  scaled k  ;
  lastbadness = 0 ;
  r = getnode ( 7 ) ;
  mem [r ].hh.b0 = 0 ;
  mem [r ].hh.b1 = 0 ;
  mem [r + 4 ].cint = 0 ;
  q = r + 5 ;
  mem [q ].hh .v.RH = p ;
  if ( m == 2 ) 
  {
    prevcharp = -268435455L ;
    fontstretch = 0 ;
    fontshrink = 0 ;
    fontexpandratio = 0 ;
  } 
  h = 0 ;
  d = 0 ;
  x = 0 ;
  totalstretch [0 ]= 0 ;
  totalshrink [0 ]= 0 ;
  totalstretch [1 ]= 0 ;
  totalshrink [1 ]= 0 ;
  totalstretch [2 ]= 0 ;
  totalshrink [2 ]= 0 ;
  totalstretch [3 ]= 0 ;
  totalshrink [3 ]= 0 ;
  if ( ( eqtb [15250 ].cint > 0 ) ) 
  {
    tempptr = getavail () ;
    mem [tempptr ].hh .v.LH = 0 ;
    mem [tempptr ].hh .v.RH = LRptr ;
    LRptr = tempptr ;
  } 
  while ( p != -268435455L ) {
      
    lab21: while ( ( p >= himemmin ) ) {
	
      if ( m >= 2 ) 
      {
	prevcharp = p ;
	switch ( m ) 
	{case 2 : 
	  {
	    f = mem [p ].hh.b0 ;
	    fontstretch = fontstretch + charstretch ( f , mem [p ].hh.b1 ) ;
	    fontshrink = fontshrink + charshrink ( f , mem [p ].hh.b1 ) ;
	  } 
	  break ;
	case 3 : 
	  dosubstfont ( p , fontexpandratio ) ;
	  break ;
	} 
      } 
      f = mem [p ].hh.b0 ;
      i = fontinfo [charbase [f ]+ effectivechar ( true , f , mem [p ]
      .hh.b1 ) ].qqqq ;
      hd = i .b1 ;
      x = x + fontinfo [widthbase [f ]+ i .b0 ].cint ;
      s = fontinfo [heightbase [f ]+ ( hd ) / 16 ].cint ;
      if ( s > h ) 
      h = s ;
      s = fontinfo [depthbase [f ]+ ( hd ) % 16 ].cint ;
      if ( s > d ) 
      d = s ;
      p = mem [p ].hh .v.RH ;
    } 
    if ( p != -268435455L ) 
    {
      switch ( mem [p ].hh.b0 ) 
      {case 0 : 
      case 1 : 
      case 2 : 
      case 13 : 
	{
	  x = x + mem [p + 1 ].cint ;
	  if ( mem [p ].hh.b0 >= 2 ) 
	  s = 0 ;
	  else s = mem [p + 4 ].cint ;
	  if ( mem [p + 3 ].cint - s > h ) 
	  h = mem [p + 3 ].cint - s ;
	  if ( mem [p + 2 ].cint + s > d ) 
	  d = mem [p + 2 ].cint + s ;
	} 
	break ;
      case 3 : 
      case 4 : 
      case 5 : 
	if ( adjusttail != -268435455L ) 
	{
	  while ( mem [q ].hh .v.RH != p ) q = mem [q ].hh .v.RH ;
	  if ( mem [p ].hh.b0 == 5 ) 
	  {
	    if ( mem [p ].hh.b1 != 0 ) 
	    {
	      mem [preadjusttail ].hh .v.RH = mem [p + 1 ].cint ;
	      while ( mem [preadjusttail ].hh .v.RH != -268435455L ) 
	      preadjusttail = mem [preadjusttail ].hh .v.RH ;
	    } 
	    else {
		
	      mem [adjusttail ].hh .v.RH = mem [p + 1 ].cint ;
	      while ( mem [adjusttail ].hh .v.RH != -268435455L ) adjusttail 
	      = mem [adjusttail ].hh .v.RH ;
	    } 
	    p = mem [p ].hh .v.RH ;
	    freenode ( mem [q ].hh .v.RH , 2 ) ;
	  } 
	  else {
	      
	    mem [adjusttail ].hh .v.RH = p ;
	    adjusttail = p ;
	    p = mem [p ].hh .v.RH ;
	  } 
	  mem [q ].hh .v.RH = p ;
	  p = q ;
	} 
	break ;
      case 8 : 
	if ( ( mem [p ].hh.b1 == 10 ) || ( mem [p ].hh.b1 == 12 ) ) 
	{
	  x = x + mem [p + 1 ].cint ;
	  s = 0 ;
	  if ( mem [p + 2 ].cint - s > h ) 
	  h = mem [p + 2 ].cint - s ;
	  if ( mem [p + 3 ].cint + s > d ) 
	  d = mem [p + 3 ].cint + s ;
	} 
	break ;
      case 10 : 
	{
	  g = mem [p + 1 ].hh .v.LH ;
	  x = x + mem [g + 1 ].cint ;
	  o = mem [g ].hh.b0 ;
	  totalstretch [o ]= totalstretch [o ]+ mem [g + 2 ].cint ;
	  o = mem [g ].hh.b1 ;
	  totalshrink [o ]= totalshrink [o ]+ mem [g + 3 ].cint ;
	  if ( mem [p ].hh.b1 >= 100 ) 
	  {
	    g = mem [p + 1 ].hh .v.RH ;
	    if ( mem [g + 3 ].cint > h ) 
	    h = mem [g + 3 ].cint ;
	    if ( mem [g + 2 ].cint > d ) 
	    d = mem [g + 2 ].cint ;
	  } 
	} 
	break ;
      case 9 : 
	{
	  x = x + mem [p + 1 ].cint ;
	  if ( ( eqtb [15250 ].cint > 0 ) ) 
	  if ( odd ( mem [p ].hh.b1 ) ) 
	  if ( mem [LRptr ].hh .v.LH == ( 4 * ( mem [p ].hh.b1 / 4 ) + 3 ) 
	  ) 
	  {
	    tempptr = LRptr ;
	    LRptr = mem [tempptr ].hh .v.RH ;
	    {
	      mem [tempptr ].hh .v.RH = avail ;
	      avail = tempptr ;
	;
#ifdef STAT
	      decr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	  else {
	      
	    incr ( LRproblems ) ;
	    mem [p ].hh.b0 = 11 ;
	    mem [p ].hh.b1 = 1 ;
	  } 
	  else {
	      
	    tempptr = getavail () ;
	    mem [tempptr ].hh .v.LH = ( 4 * ( mem [p ].hh.b1 / 4 ) + 3 ) ;
	    mem [tempptr ].hh .v.RH = LRptr ;
	    LRptr = tempptr ;
	  } 
	} 
	break ;
      case 40 : 
	{
	  if ( m == 2 ) 
	  {
	    f = mem [mem [p + 2 ].hh .v.LH ].hh.b0 ;
	    dosubstfont ( mem [p + 2 ].hh .v.LH , 1000 ) ;
	    if ( f != mem [mem [p + 2 ].hh .v.LH ].hh.b0 ) 
	    fontstretch = fontstretch - mem [p + 1 ].cint - charpw ( mem [p 
	    + 2 ].hh .v.LH , mem [p ].hh.b1 ) ;
	    mem [mem [p + 2 ].hh .v.LH ].hh.b0 = f ;
	    dosubstfont ( mem [p + 2 ].hh .v.LH , -1000 ) ;
	    if ( f != mem [mem [p + 2 ].hh .v.LH ].hh.b0 ) 
	    fontshrink = fontshrink - mem [p + 1 ].cint - charpw ( mem [p + 
	    2 ].hh .v.LH , mem [p ].hh.b1 ) ;
	    mem [mem [p + 2 ].hh .v.LH ].hh.b0 = f ;
	  } 
	  else if ( m == 3 ) 
	  {
	    dosubstfont ( mem [p + 2 ].hh .v.LH , fontexpandratio ) ;
	    mem [p + 1 ].cint = - (integer) charpw ( mem [p + 2 ].hh .v.LH 
	    , mem [p ].hh.b1 ) ;
	  } 
	  x = x + mem [p + 1 ].cint ;
	} 
	break ;
      case 11 : 
	{
	  if ( ( m == 2 ) && ( mem [p ].hh.b1 == 0 ) ) 
	  {
	    k = kernstretch ( p ) ;
	    if ( k != 0 ) 
	    {
	      mem [p ].hh.b1 = 3 ;
	      fontstretch = fontstretch + k ;
	    } 
	    k = kernshrink ( p ) ;
	    if ( k != 0 ) 
	    {
	      mem [p ].hh.b1 = 3 ;
	      fontshrink = fontshrink + k ;
	    } 
	  } 
	  else if ( ( m == 3 ) && ( mem [p ].hh.b1 == 3 ) ) 
	  {
	    if ( mem [mem [p ].hh .v.RH ].hh.b0 == 6 ) 
	    mem [p + 1 ].cint = getkern ( mem [prevcharp ].hh.b0 , mem [
	    prevcharp ].hh.b1 , mem [mem [p ].hh .v.RH + 1 ].hh.b1 ) ;
	    else mem [p + 1 ].cint = getkern ( mem [prevcharp ].hh.b0 , 
	    mem [prevcharp ].hh.b1 , mem [mem [p ].hh .v.RH ].hh.b1 ) ;
	  } 
	  x = x + mem [p + 1 ].cint ;
	} 
	break ;
      case 6 : 
	{
	  if ( m == 3 ) 
	  dosubstfont ( p , fontexpandratio ) ;
	  {
	    mem [memtop - 12 ]= mem [p + 1 ];
	    mem [memtop - 12 ].hh .v.RH = mem [p ].hh .v.RH ;
	    p = memtop - 12 ;
	    goto lab21 ;
	  } 
	} 
	break ;
      case 7 : 
	if ( m == 3 ) 
	dosubstfont ( p , fontexpandratio ) ;
	break ;
	default: 
	;
	break ;
      } 
      p = mem [p ].hh .v.RH ;
    } 
  } 
  if ( adjusttail != -268435455L ) 
  mem [adjusttail ].hh .v.RH = -268435455L ;
  if ( preadjusttail != -268435455L ) 
  mem [preadjusttail ].hh .v.RH = -268435455L ;
  mem [r + 3 ].cint = h ;
  mem [r + 2 ].cint = d ;
  if ( m == 1 ) 
  w = x + w ;
  mem [r + 1 ].cint = w ;
  x = w - x ;
  if ( x == 0 ) 
  {
    mem [r + 5 ].hh.b0 = 0 ;
    mem [r + 5 ].hh.b1 = 0 ;
    mem [r + 6 ].gr = 0.0 ;
    goto lab10 ;
  } 
  else if ( x > 0 ) 
  {
    if ( totalstretch [3 ]!= 0 ) 
    o = 3 ;
    else if ( totalstretch [2 ]!= 0 ) 
    o = 2 ;
    else if ( totalstretch [1 ]!= 0 ) 
    o = 1 ;
    else o = 0 ;
    if ( ( m == 2 ) && ( o == 0 ) && ( fontstretch > 0 ) ) 
    {
      fontexpandratio = dividescaled ( x , fontstretch , 3 ) ;
      goto lab10 ;
    } 
    mem [r + 5 ].hh.b1 = o ;
    mem [r + 5 ].hh.b0 = 1 ;
    if ( totalstretch [o ]!= 0 ) 
    mem [r + 6 ].gr = x / ((double) totalstretch [o ]) ;
    else {
	
      mem [r + 5 ].hh.b0 = 0 ;
      mem [r + 6 ].gr = 0.0 ;
    } 
    if ( o == 0 ) 
    if ( mem [r + 5 ].hh .v.RH != -268435455L ) 
    {
      lastbadness = badness ( x , totalstretch [0 ]) ;
      if ( lastbadness > eqtb [15197 ].cint ) 
      {
	println () ;
	if ( lastbadness > 100 ) 
	printnl ( 1080 ) ;
	else printnl ( 1081 ) ;
	print ( 1082 ) ;
	printint ( lastbadness ) ;
	goto lab50 ;
      } 
    } 
    goto lab10 ;
  } 
  else {
      
    if ( totalshrink [3 ]!= 0 ) 
    o = 3 ;
    else if ( totalshrink [2 ]!= 0 ) 
    o = 2 ;
    else if ( totalshrink [1 ]!= 0 ) 
    o = 1 ;
    else o = 0 ;
    if ( ( m == 2 ) && ( o == 0 ) && ( fontshrink > 0 ) ) 
    {
      fontexpandratio = dividescaled ( x , fontshrink , 3 ) ;
      goto lab10 ;
    } 
    mem [r + 5 ].hh.b1 = o ;
    mem [r + 5 ].hh.b0 = 2 ;
    if ( totalshrink [o ]!= 0 ) 
    mem [r + 6 ].gr = ( - (integer) x ) / ((double) totalshrink [o ]) ;
    else {
	
      mem [r + 5 ].hh.b0 = 0 ;
      mem [r + 6 ].gr = 0.0 ;
    } 
    if ( ( totalshrink [o ]< - (integer) x ) && ( o == 0 ) && ( mem [r + 5 
    ].hh .v.RH != -268435455L ) ) 
    {
      lastbadness = 1000000L ;
      mem [r + 6 ].gr = 1.0 ;
      if ( ( - (integer) x - totalshrink [0 ]> eqtb [15771 ].cint ) || ( 
      eqtb [15197 ].cint < 100 ) ) 
      {
	if ( ( eqtb [15779 ].cint > 0 ) && ( - (integer) x - totalshrink [0 
	]> eqtb [15771 ].cint ) ) 
	{
	  while ( mem [q ].hh .v.RH != -268435455L ) q = mem [q ].hh .v.RH 
	  ;
	  mem [q ].hh .v.RH = newrule () ;
	  mem [mem [q ].hh .v.RH + 1 ].cint = eqtb [15779 ].cint ;
	} 
	println () ;
	printnl ( 1088 ) ;
	printscaled ( - (integer) x - totalshrink [0 ]) ;
	print ( 1089 ) ;
	goto lab50 ;
      } 
    } 
    else if ( o == 0 ) 
    if ( mem [r + 5 ].hh .v.RH != -268435455L ) 
    {
      lastbadness = badness ( - (integer) x , totalshrink [0 ]) ;
      if ( lastbadness > eqtb [15197 ].cint ) 
      {
	println () ;
	printnl ( 1090 ) ;
	printint ( lastbadness ) ;
	goto lab50 ;
      } 
    } 
    goto lab10 ;
  } 
  lab50: if ( outputactive ) 
  print ( 1083 ) ;
  else {
      
    if ( packbeginline != 0 ) 
    {
      if ( packbeginline > 0 ) 
      print ( 1084 ) ;
      else print ( 1085 ) ;
      printint ( abs ( packbeginline ) ) ;
      print ( 1086 ) ;
    } 
    else print ( 1087 ) ;
    printint ( line ) ;
  } 
  println () ;
  fontinshortdisplay = 0 ;
  shortdisplay ( mem [r + 5 ].hh .v.RH ) ;
  println () ;
  begindiagnostic () ;
  showbox ( r ) ;
  enddiagnostic ( true ) ;
  lab10: if ( ( eqtb [15250 ].cint > 0 ) ) 
  {
    if ( mem [LRptr ].hh .v.LH != 0 ) 
    {
      while ( mem [q ].hh .v.RH != -268435455L ) q = mem [q ].hh .v.RH ;
      do {
	  tempptr = q ;
	q = newmath ( 0 , mem [LRptr ].hh .v.LH ) ;
	mem [tempptr ].hh .v.RH = q ;
	LRproblems = LRproblems + 10000 ;
	{
	  tempptr = LRptr ;
	  LRptr = mem [tempptr ].hh .v.RH ;
	  {
	    mem [tempptr ].hh .v.RH = avail ;
	    avail = tempptr ;
	;
#ifdef STAT
	    decr ( dynused ) ;
#endif /* STAT */
	  } 
	} 
      } while ( ! ( mem [LRptr ].hh .v.LH == 0 ) ) ;
    } 
    if ( LRproblems > 0 ) 
    {
      {
	println () ;
	printnl ( 1774 ) ;
	printint ( LRproblems / 10000 ) ;
	print ( 1775 ) ;
	printint ( LRproblems % 10000 ) ;
	print ( 1776 ) ;
	LRproblems = 0 ;
      } 
      goto lab50 ;
    } 
    {
      tempptr = LRptr ;
      LRptr = mem [tempptr ].hh .v.RH ;
      {
	mem [tempptr ].hh .v.RH = avail ;
	avail = tempptr ;
	;
#ifdef STAT
	decr ( dynused ) ;
#endif /* STAT */
      } 
    } 
    if ( LRptr != -268435455L ) 
    confusion ( 1773 ) ;
  } 
  if ( ( m == 2 ) && ( fontexpandratio != 0 ) ) 
  {
    fontexpandratio = fixint ( fontexpandratio , -1000 , 1000 ) ;
    q = mem [r + 5 ].hh .v.RH ;
    freenode ( r , 7 ) ;
    r = hpack ( q , w , 3 ) ;
  } 
  Result = r ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zvpackage ( halfword p , scaled h , smallnumber m , scaled l ) 
#else
zvpackage ( p , h , m , l ) 
  halfword p ;
  scaled h ;
  smallnumber m ;
  scaled l ;
#endif
{
  /* 50 10 */ register halfword Result; vpackage_regmem 
  halfword r  ;
  scaled w, d, x  ;
  scaled s  ;
  halfword g  ;
  glueord o  ;
  lastbadness = 0 ;
  r = getnode ( 7 ) ;
  mem [r ].hh.b0 = 1 ;
  mem [r ].hh.b1 = 0 ;
  mem [r + 4 ].cint = 0 ;
  mem [r + 5 ].hh .v.RH = p ;
  w = 0 ;
  d = 0 ;
  x = 0 ;
  totalstretch [0 ]= 0 ;
  totalshrink [0 ]= 0 ;
  totalstretch [1 ]= 0 ;
  totalshrink [1 ]= 0 ;
  totalstretch [2 ]= 0 ;
  totalshrink [2 ]= 0 ;
  totalstretch [3 ]= 0 ;
  totalshrink [3 ]= 0 ;
  while ( p != -268435455L ) {
      
    if ( ( p >= himemmin ) ) 
    confusion ( 1091 ) ;
    else switch ( mem [p ].hh.b0 ) 
    {case 0 : 
    case 1 : 
    case 2 : 
    case 13 : 
      {
	x = x + d + mem [p + 3 ].cint ;
	d = mem [p + 2 ].cint ;
	if ( mem [p ].hh.b0 >= 2 ) 
	s = 0 ;
	else s = mem [p + 4 ].cint ;
	if ( mem [p + 1 ].cint + s > w ) 
	w = mem [p + 1 ].cint + s ;
      } 
      break ;
    case 8 : 
      if ( ( mem [p ].hh.b1 == 10 ) || ( mem [p ].hh.b1 == 12 ) ) 
      {
	x = x + d + mem [p + 2 ].cint ;
	d = mem [p + 3 ].cint ;
	s = 0 ;
	if ( mem [p + 1 ].cint + s > w ) 
	w = mem [p + 1 ].cint + s ;
      } 
      break ;
    case 10 : 
      {
	x = x + d ;
	d = 0 ;
	g = mem [p + 1 ].hh .v.LH ;
	x = x + mem [g + 1 ].cint ;
	o = mem [g ].hh.b0 ;
	totalstretch [o ]= totalstretch [o ]+ mem [g + 2 ].cint ;
	o = mem [g ].hh.b1 ;
	totalshrink [o ]= totalshrink [o ]+ mem [g + 3 ].cint ;
	if ( mem [p ].hh.b1 >= 100 ) 
	{
	  g = mem [p + 1 ].hh .v.RH ;
	  if ( mem [g + 1 ].cint > w ) 
	  w = mem [g + 1 ].cint ;
	} 
      } 
      break ;
    case 11 : 
      {
	x = x + d + mem [p + 1 ].cint ;
	d = 0 ;
      } 
      break ;
      default: 
      ;
      break ;
    } 
    p = mem [p ].hh .v.RH ;
  } 
  mem [r + 1 ].cint = w ;
  if ( d > l ) 
  {
    x = x + d - l ;
    mem [r + 2 ].cint = l ;
  } 
  else mem [r + 2 ].cint = d ;
  if ( m == 1 ) 
  h = x + h ;
  mem [r + 3 ].cint = h ;
  x = h - x ;
  if ( x == 0 ) 
  {
    mem [r + 5 ].hh.b0 = 0 ;
    mem [r + 5 ].hh.b1 = 0 ;
    mem [r + 6 ].gr = 0.0 ;
    goto lab10 ;
  } 
  else if ( x > 0 ) 
  {
    if ( totalstretch [3 ]!= 0 ) 
    o = 3 ;
    else if ( totalstretch [2 ]!= 0 ) 
    o = 2 ;
    else if ( totalstretch [1 ]!= 0 ) 
    o = 1 ;
    else o = 0 ;
    mem [r + 5 ].hh.b1 = o ;
    mem [r + 5 ].hh.b0 = 1 ;
    if ( totalstretch [o ]!= 0 ) 
    mem [r + 6 ].gr = x / ((double) totalstretch [o ]) ;
    else {
	
      mem [r + 5 ].hh.b0 = 0 ;
      mem [r + 6 ].gr = 0.0 ;
    } 
    if ( o == 0 ) 
    if ( mem [r + 5 ].hh .v.RH != -268435455L ) 
    {
      lastbadness = badness ( x , totalstretch [0 ]) ;
      if ( lastbadness > eqtb [15198 ].cint ) 
      {
	println () ;
	if ( lastbadness > 100 ) 
	printnl ( 1080 ) ;
	else printnl ( 1081 ) ;
	print ( 1092 ) ;
	printint ( lastbadness ) ;
	goto lab50 ;
      } 
    } 
    goto lab10 ;
  } 
  else {
      
    if ( totalshrink [3 ]!= 0 ) 
    o = 3 ;
    else if ( totalshrink [2 ]!= 0 ) 
    o = 2 ;
    else if ( totalshrink [1 ]!= 0 ) 
    o = 1 ;
    else o = 0 ;
    mem [r + 5 ].hh.b1 = o ;
    mem [r + 5 ].hh.b0 = 2 ;
    if ( totalshrink [o ]!= 0 ) 
    mem [r + 6 ].gr = ( - (integer) x ) / ((double) totalshrink [o ]) ;
    else {
	
      mem [r + 5 ].hh.b0 = 0 ;
      mem [r + 6 ].gr = 0.0 ;
    } 
    if ( ( totalshrink [o ]< - (integer) x ) && ( o == 0 ) && ( mem [r + 5 
    ].hh .v.RH != -268435455L ) ) 
    {
      lastbadness = 1000000L ;
      mem [r + 6 ].gr = 1.0 ;
      if ( ( - (integer) x - totalshrink [0 ]> eqtb [15772 ].cint ) || ( 
      eqtb [15198 ].cint < 100 ) ) 
      {
	println () ;
	printnl ( 1093 ) ;
	printscaled ( - (integer) x - totalshrink [0 ]) ;
	print ( 1094 ) ;
	goto lab50 ;
      } 
    } 
    else if ( o == 0 ) 
    if ( mem [r + 5 ].hh .v.RH != -268435455L ) 
    {
      lastbadness = badness ( - (integer) x , totalshrink [0 ]) ;
      if ( lastbadness > eqtb [15198 ].cint ) 
      {
	println () ;
	printnl ( 1095 ) ;
	printint ( lastbadness ) ;
	goto lab50 ;
      } 
    } 
    goto lab10 ;
  } 
  lab50: if ( outputactive ) 
  print ( 1083 ) ;
  else {
      
    if ( packbeginline != 0 ) 
    {
      print ( 1085 ) ;
      printint ( abs ( packbeginline ) ) ;
      print ( 1086 ) ;
    } 
    else print ( 1087 ) ;
    printint ( line ) ;
    println () ;
  } 
  begindiagnostic () ;
  showbox ( r ) ;
  enddiagnostic ( true ) ;
  lab10: Result = r ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zappendtovlist ( halfword b ) 
#else
zappendtovlist ( b ) 
  halfword b ;
#endif
{
  appendtovlist_regmem 
  scaled d  ;
  halfword p  ;
  if ( curlist .auxfield .cint > -65536000L ) 
  {
    d = mem [eqtb [12527 ].hh .v.RH + 1 ].cint - curlist .auxfield .cint - 
    mem [b + 3 ].cint ;
    if ( d < eqtb [15765 ].cint ) 
    p = newparamglue ( 0 ) ;
    else {
	
      p = newskipparam ( 1 ) ;
      mem [tempptr + 1 ].cint = d ;
    } 
    mem [curlist .tailfield ].hh .v.RH = p ;
    curlist .tailfield = p ;
  } 
  mem [curlist .tailfield ].hh .v.RH = b ;
  curlist .tailfield = b ;
  curlist .auxfield .cint = mem [b + 2 ].cint ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
newnoad ( void ) 
#else
newnoad ( ) 
#endif
{
  register halfword Result; newnoad_regmem 
  halfword p  ;
  p = getnode ( 4 ) ;
  mem [p ].hh.b0 = 16 ;
  mem [p ].hh.b1 = 0 ;
  mem [p + 1 ].hh = emptyfield ;
  mem [p + 3 ].hh = emptyfield ;
  mem [p + 2 ].hh = emptyfield ;
  Result = p ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
znewstyle ( smallnumber s ) 
#else
znewstyle ( s ) 
  smallnumber s ;
#endif
{
  register halfword Result; newstyle_regmem 
  halfword p  ;
  p = getnode ( 3 ) ;
  mem [p ].hh.b0 = 14 ;
  mem [p ].hh.b1 = s ;
  mem [p + 1 ].cint = 0 ;
  mem [p + 2 ].cint = 0 ;
  Result = p ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
newchoice ( void ) 
#else
newchoice ( ) 
#endif
{
  register halfword Result; newchoice_regmem 
  halfword p  ;
  p = getnode ( 3 ) ;
  mem [p ].hh.b0 = 15 ;
  mem [p ].hh.b1 = 0 ;
  mem [p + 1 ].hh .v.LH = -268435455L ;
  mem [p + 1 ].hh .v.RH = -268435455L ;
  mem [p + 2 ].hh .v.LH = -268435455L ;
  mem [p + 2 ].hh .v.RH = -268435455L ;
  Result = p ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
showinfo ( void ) 
#else
showinfo ( ) 
#endif
{
  showinfo_regmem 
  shownodelist ( mem [tempptr ].hh .v.LH ) ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zfractionrule ( scaled t ) 
#else
zfractionrule ( t ) 
  scaled t ;
#endif
{
  register halfword Result; fractionrule_regmem 
  halfword p  ;
  p = newrule () ;
  mem [p + 3 ].cint = t ;
  mem [p + 2 ].cint = 0 ;
  Result = p ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zoverbar ( halfword b , scaled k , scaled t ) 
#else
zoverbar ( b , k , t ) 
  halfword b ;
  scaled k ;
  scaled t ;
#endif
{
  register halfword Result; overbar_regmem 
  halfword p, q  ;
  p = newkern ( k ) ;
  mem [p ].hh .v.RH = b ;
  q = fractionrule ( t ) ;
  mem [q ].hh .v.RH = p ;
  p = newkern ( t ) ;
  mem [p ].hh .v.RH = q ;
  Result = vpackage ( p , 0 , 1 , 1073741823L ) ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zcharbox ( internalfontnumber f , quarterword c ) 
#else
zcharbox ( f , c ) 
  internalfontnumber f ;
  quarterword c ;
#endif
{
  register halfword Result; charbox_regmem 
  fourquarters q  ;
  eightbits hd  ;
  halfword b, p  ;
  q = fontinfo [charbase [f ]+ effectivechar ( true , f , c ) ].qqqq ;
  hd = q .b1 ;
  b = newnullbox () ;
  mem [b + 1 ].cint = fontinfo [widthbase [f ]+ q .b0 ].cint + fontinfo 
  [italicbase [f ]+ ( q .b2 ) / 4 ].cint ;
  mem [b + 3 ].cint = fontinfo [heightbase [f ]+ ( hd ) / 16 ].cint ;
  mem [b + 2 ].cint = fontinfo [depthbase [f ]+ ( hd ) % 16 ].cint ;
  p = getavail () ;
  mem [p ].hh.b1 = c ;
  mem [p ].hh.b0 = f ;
  mem [b + 5 ].hh .v.RH = p ;
  Result = b ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zstackintobox ( halfword b , internalfontnumber f , quarterword c ) 
#else
zstackintobox ( b , f , c ) 
  halfword b ;
  internalfontnumber f ;
  quarterword c ;
#endif
{
  stackintobox_regmem 
  halfword p  ;
  p = charbox ( f , c ) ;
  mem [p ].hh .v.RH = mem [b + 5 ].hh .v.RH ;
  mem [b + 5 ].hh .v.RH = p ;
  mem [b + 3 ].cint = mem [p + 3 ].cint ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zheightplusdepth ( internalfontnumber f , quarterword c ) 
#else
zheightplusdepth ( f , c ) 
  internalfontnumber f ;
  quarterword c ;
#endif
{
  register scaled Result; heightplusdepth_regmem 
  fourquarters q  ;
  eightbits hd  ;
  q = fontinfo [charbase [f ]+ effectivechar ( true , f , c ) ].qqqq ;
  hd = q .b1 ;
  Result = fontinfo [heightbase [f ]+ ( hd ) / 16 ].cint + fontinfo [
  depthbase [f ]+ ( hd ) % 16 ].cint ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zvardelimiter ( halfword d , smallnumber s , scaled v ) 
#else
zvardelimiter ( d , s , v ) 
  halfword d ;
  smallnumber s ;
  scaled v ;
#endif
{
  /* 40 22 */ register halfword Result; vardelimiter_regmem 
  halfword b  ;
  internalfontnumber f, g  ;
  quarterword c, x, y  ;
  integer m, n  ;
  scaled u  ;
  scaled w  ;
  fourquarters q  ;
  eightbits hd  ;
  fourquarters r  ;
  smallnumber z  ;
  boolean largeattempt  ;
  f = 0 ;
  w = 0 ;
  largeattempt = false ;
  z = mem [d ].qqqq .b0 ;
  x = mem [d ].qqqq .b1 ;
  while ( true ) {
      
    if ( ( z != 0 ) || ( x != 0 ) ) 
    {
      z = z + s + 16 ;
      do {
	  z = z - 16 ;
	g = eqtb [13587 + z ].hh .v.RH ;
	if ( g != 0 ) 
	{
	  y = x ;
	  if ( ( y >= fontbc [g ]) && ( y <= fontec [g ]) ) 
	  {
	    lab22: q = fontinfo [charbase [g ]+ y ].qqqq ;
	    if ( ( q .b0 > 0 ) ) 
	    {
	      if ( ( ( q .b2 ) % 4 ) == 3 ) 
	      {
		f = g ;
		c = y ;
		goto lab40 ;
	      } 
	      hd = q .b1 ;
	      u = fontinfo [heightbase [g ]+ ( hd ) / 16 ].cint + fontinfo 
	      [depthbase [g ]+ ( hd ) % 16 ].cint ;
	      if ( u > w ) 
	      {
		f = g ;
		c = y ;
		w = u ;
		if ( u >= v ) 
		goto lab40 ;
	      } 
	      if ( ( ( q .b2 ) % 4 ) == 2 ) 
	      {
		y = q .b3 ;
		goto lab22 ;
	      } 
	    } 
	  } 
	} 
      } while ( ! ( z < 16 ) ) ;
    } 
    if ( largeattempt ) 
    goto lab40 ;
    largeattempt = true ;
    z = mem [d ].qqqq .b2 ;
    x = mem [d ].qqqq .b3 ;
  } 
  lab40: if ( f != 0 ) 
  if ( ( ( q .b2 ) % 4 ) == 3 ) 
  {
    b = newnullbox () ;
    mem [b ].hh.b0 = 1 ;
    r = fontinfo [extenbase [f ]+ q .b3 ].qqqq ;
    c = r .b3 ;
    u = heightplusdepth ( f , c ) ;
    w = 0 ;
    q = fontinfo [charbase [f ]+ effectivechar ( true , f , c ) ].qqqq ;
    mem [b + 1 ].cint = fontinfo [widthbase [f ]+ q .b0 ].cint + 
    fontinfo [italicbase [f ]+ ( q .b2 ) / 4 ].cint ;
    c = r .b2 ;
    if ( c != 0 ) 
    w = w + heightplusdepth ( f , c ) ;
    c = r .b1 ;
    if ( c != 0 ) 
    w = w + heightplusdepth ( f , c ) ;
    c = r .b0 ;
    if ( c != 0 ) 
    w = w + heightplusdepth ( f , c ) ;
    n = 0 ;
    if ( u > 0 ) 
    while ( w < v ) {
	
      w = w + u ;
      incr ( n ) ;
      if ( r .b1 != 0 ) 
      w = w + u ;
    } 
    c = r .b2 ;
    if ( c != 0 ) 
    stackintobox ( b , f , c ) ;
    c = r .b3 ;
    {register integer for_end; m = 1 ;for_end = n ; if ( m <= for_end) do 
      stackintobox ( b , f , c ) ;
    while ( m++ < for_end ) ;} 
    c = r .b1 ;
    if ( c != 0 ) 
    {
      stackintobox ( b , f , c ) ;
      c = r .b3 ;
      {register integer for_end; m = 1 ;for_end = n ; if ( m <= for_end) do 
	stackintobox ( b , f , c ) ;
      while ( m++ < for_end ) ;} 
    } 
    c = r .b0 ;
    if ( c != 0 ) 
    stackintobox ( b , f , c ) ;
    mem [b + 2 ].cint = w - mem [b + 3 ].cint ;
  } 
  else b = charbox ( f , c ) ;
  else {
      
    b = newnullbox () ;
    mem [b + 1 ].cint = eqtb [15774 ].cint ;
  } 
  mem [b + 4 ].cint = half ( mem [b + 3 ].cint - mem [b + 2 ].cint ) - 
  fontinfo [22 + parambase [eqtb [13589 + s ].hh .v.RH ]].cint ;
  Result = b ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zrebox ( halfword b , scaled w ) 
#else
zrebox ( b , w ) 
  halfword b ;
  scaled w ;
#endif
{
  register halfword Result; rebox_regmem 
  halfword p  ;
  internalfontnumber f  ;
  scaled v  ;
  if ( ( mem [b + 1 ].cint != w ) && ( mem [b + 5 ].hh .v.RH != 
  -268435455L ) ) 
  {
    if ( mem [b ].hh.b0 == 1 ) 
    b = hpack ( b , 0 , 1 ) ;
    p = mem [b + 5 ].hh .v.RH ;
    if ( ( ( p >= himemmin ) ) && ( mem [p ].hh .v.RH == -268435455L ) ) 
    {
      f = mem [p ].hh.b0 ;
      v = fontinfo [widthbase [f ]+ fontinfo [charbase [f ]+ 
      effectivechar ( true , f , mem [p ].hh.b1 ) ].qqqq .b0 ].cint ;
      if ( v != mem [b + 1 ].cint ) 
      mem [p ].hh .v.RH = newkern ( mem [b + 1 ].cint - v ) ;
    } 
    freenode ( b , 7 ) ;
    b = newglue ( membot + 12 ) ;
    mem [b ].hh .v.RH = p ;
    while ( mem [p ].hh .v.RH != -268435455L ) p = mem [p ].hh .v.RH ;
    mem [p ].hh .v.RH = newglue ( membot + 12 ) ;
    Result = hpack ( b , w , 0 ) ;
  } 
  else {
      
    mem [b + 1 ].cint = w ;
    Result = b ;
  } 
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zmathglue ( halfword g , scaled m ) 
#else
zmathglue ( g , m ) 
  halfword g ;
  scaled m ;
#endif
{
  register halfword Result; mathglue_regmem 
  halfword p  ;
  integer n  ;
  scaled f  ;
  n = xovern ( m , 65536L ) ;
  f = texremainder ;
  if ( f < 0 ) 
  {
    decr ( n ) ;
    f = f + 65536L ;
  } 
  p = getnode ( 4 ) ;
  mem [p + 1 ].cint = multandadd ( n , mem [g + 1 ].cint , xnoverd ( mem [
  g + 1 ].cint , f , 65536L ) , 1073741823L ) ;
  mem [p ].hh.b0 = mem [g ].hh.b0 ;
  if ( mem [p ].hh.b0 == 0 ) 
  mem [p + 2 ].cint = multandadd ( n , mem [g + 2 ].cint , xnoverd ( mem [
  g + 2 ].cint , f , 65536L ) , 1073741823L ) ;
  else mem [p + 2 ].cint = mem [g + 2 ].cint ;
  mem [p ].hh.b1 = mem [g ].hh.b1 ;
  if ( mem [p ].hh.b1 == 0 ) 
  mem [p + 3 ].cint = multandadd ( n , mem [g + 3 ].cint , xnoverd ( mem [
  g + 3 ].cint , f , 65536L ) , 1073741823L ) ;
  else mem [p + 3 ].cint = mem [g + 3 ].cint ;
  Result = p ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmathkern ( halfword p , scaled m ) 
#else
zmathkern ( p , m ) 
  halfword p ;
  scaled m ;
#endif
{
  mathkern_regmem 
  integer n  ;
  scaled f  ;
  if ( mem [p ].hh.b1 == 99 ) 
  {
    n = xovern ( m , 65536L ) ;
    f = texremainder ;
    if ( f < 0 ) 
    {
      decr ( n ) ;
      f = f + 65536L ;
    } 
    mem [p + 1 ].cint = multandadd ( n , mem [p + 1 ].cint , xnoverd ( mem 
    [p + 1 ].cint , f , 65536L ) , 1073741823L ) ;
    mem [p ].hh.b1 = 1 ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
flushmath ( void ) 
#else
flushmath ( ) 
#endif
{
  flushmath_regmem 
  flushnodelist ( mem [curlist .headfield ].hh .v.RH ) ;
  flushnodelist ( curlist .auxfield .cint ) ;
  mem [curlist .headfield ].hh .v.RH = -268435455L ;
  curlist .tailfield = curlist .headfield ;
  curlist .auxfield .cint = -268435455L ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zcleanbox ( halfword p , smallnumber s ) 
#else
zcleanbox ( p , s ) 
  halfword p ;
  smallnumber s ;
#endif
{
  /* 40 */ register halfword Result; cleanbox_regmem 
  halfword q  ;
  smallnumber savestyle  ;
  halfword x  ;
  halfword r  ;
  switch ( mem [p ].hh .v.RH ) 
  {case 1 : 
    {
      curmlist = newnoad () ;
      mem [curmlist + 1 ]= mem [p ];
    } 
    break ;
  case 2 : 
    {
      q = mem [p ].hh .v.LH ;
      goto lab40 ;
    } 
    break ;
  case 3 : 
    curmlist = mem [p ].hh .v.LH ;
    break ;
    default: 
    {
      q = newnullbox () ;
      goto lab40 ;
    } 
    break ;
  } 
  savestyle = curstyle ;
  curstyle = s ;
  mlistpenalties = false ;
  mlisttohlist () ;
  q = mem [memtop - 3 ].hh .v.RH ;
  curstyle = savestyle ;
  {
    if ( curstyle < 4 ) 
    cursize = 0 ;
    else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
    curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint , 18 ) ;
  } 
  lab40: if ( ( q >= himemmin ) || ( q == -268435455L ) ) 
  x = hpack ( q , 0 , 1 ) ;
  else if ( ( mem [q ].hh .v.RH == -268435455L ) && ( mem [q ].hh.b0 <= 1 
  ) && ( mem [q + 4 ].cint == 0 ) ) 
  x = q ;
  else x = hpack ( q , 0 , 1 ) ;
  q = mem [x + 5 ].hh .v.RH ;
  if ( ( q >= himemmin ) ) 
  {
    r = mem [q ].hh .v.RH ;
    if ( r != -268435455L ) 
    if ( mem [r ].hh .v.RH == -268435455L ) 
    if ( ! ( r >= himemmin ) ) 
    if ( mem [r ].hh.b0 == 11 ) 
    {
      freenode ( r , 2 ) ;
      mem [q ].hh .v.RH = -268435455L ;
    } 
  } 
  Result = x ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zfetch ( halfword a ) 
#else
zfetch ( a ) 
  halfword a ;
#endif
{
  fetch_regmem 
  curc = mem [a ].hh.b1 ;
  curf = eqtb [13587 + mem [a ].hh.b0 + cursize ].hh .v.RH ;
  if ( curf == 0 ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 263 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 263 ) ;
      } 
    } 
    printsize ( cursize ) ;
    printchar ( 32 ) ;
    printint ( mem [a ].hh.b0 ) ;
    print ( 1121 ) ;
    print ( curc ) ;
    printchar ( 41 ) ;
    {
      helpptr = 4 ;
      helpline [3 ]= 1122 ;
      helpline [2 ]= 1123 ;
      helpline [1 ]= 1124 ;
      helpline [0 ]= 1125 ;
    } 
    error () ;
    curi = nullcharacter ;
    mem [a ].hh .v.RH = 0 ;
  } 
  else {
      
    if ( ( curc >= fontbc [curf ]) && ( curc <= fontec [curf ]) ) 
    curi = fontinfo [charbase [curf ]+ curc ].qqqq ;
    else curi = nullcharacter ;
    if ( ! ( ( curi .b0 > 0 ) ) ) 
    {
      charwarning ( curf , curc ) ;
      mem [a ].hh .v.RH = 0 ;
    } 
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zmakeover ( halfword q ) 
#else
zmakeover ( q ) 
  halfword q ;
#endif
{
  makeover_regmem 
  mem [q + 1 ].hh .v.LH = overbar ( cleanbox ( q + 1 , 2 * ( curstyle / 2 ) 
  + 1 ) , 3 * fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH ]
  ].cint , fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH ]]
  .cint ) ;
  mem [q + 1 ].hh .v.RH = 2 ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmakeunder ( halfword q ) 
#else
zmakeunder ( q ) 
  halfword q ;
#endif
{
  makeunder_regmem 
  halfword p, x, y  ;
  scaled delta  ;
  x = cleanbox ( q + 1 , curstyle ) ;
  p = newkern ( 3 * fontinfo [8 + parambase [eqtb [13590 + cursize ].hh 
  .v.RH ]].cint ) ;
  mem [x ].hh .v.RH = p ;
  mem [p ].hh .v.RH = fractionrule ( fontinfo [8 + parambase [eqtb [13590 
  + cursize ].hh .v.RH ]].cint ) ;
  y = vpackage ( x , 0 , 1 , 1073741823L ) ;
  delta = mem [y + 3 ].cint + mem [y + 2 ].cint + fontinfo [8 + parambase 
  [eqtb [13590 + cursize ].hh .v.RH ]].cint ;
  mem [y + 3 ].cint = mem [x + 3 ].cint ;
  mem [y + 2 ].cint = delta - mem [y + 3 ].cint ;
  mem [q + 1 ].hh .v.LH = y ;
  mem [q + 1 ].hh .v.RH = 2 ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmakevcenter ( halfword q ) 
#else
zmakevcenter ( q ) 
  halfword q ;
#endif
{
  makevcenter_regmem 
  halfword v  ;
  scaled delta  ;
  v = mem [q + 1 ].hh .v.LH ;
  if ( mem [v ].hh.b0 != 1 ) 
  confusion ( 570 ) ;
  delta = mem [v + 3 ].cint + mem [v + 2 ].cint ;
  mem [v + 3 ].cint = fontinfo [22 + parambase [eqtb [13589 + cursize ]
  .hh .v.RH ]].cint + half ( delta ) ;
  mem [v + 2 ].cint = delta - mem [v + 3 ].cint ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmakeradical ( halfword q ) 
#else
zmakeradical ( q ) 
  halfword q ;
#endif
{
  makeradical_regmem 
  halfword x, y  ;
  scaled delta, clr  ;
  x = cleanbox ( q + 1 , 2 * ( curstyle / 2 ) + 1 ) ;
  if ( curstyle < 2 ) 
  clr = fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH ]]
  .cint + ( abs ( fontinfo [5 + parambase [eqtb [13589 + cursize ].hh 
  .v.RH ]].cint ) / 4 ) ;
  else {
      
    clr = fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH ]]
    .cint ;
    clr = clr + ( abs ( clr ) / 4 ) ;
  } 
  y = vardelimiter ( q + 4 , cursize , mem [x + 3 ].cint + mem [x + 2 ]
  .cint + clr + fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH 
  ]].cint ) ;
  delta = mem [y + 2 ].cint - ( mem [x + 3 ].cint + mem [x + 2 ].cint + 
  clr ) ;
  if ( delta > 0 ) 
  clr = clr + half ( delta ) ;
  mem [y + 4 ].cint = - (integer) ( mem [x + 3 ].cint + clr ) ;
  mem [y ].hh .v.RH = overbar ( x , clr , mem [y + 3 ].cint ) ;
  mem [q + 1 ].hh .v.LH = hpack ( y , 0 , 1 ) ;
  mem [q + 1 ].hh .v.RH = 2 ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmakemathaccent ( halfword q ) 
#else
zmakemathaccent ( q ) 
  halfword q ;
#endif
{
  /* 30 31 */ makemathaccent_regmem 
  halfword p, x, y  ;
  integer a  ;
  quarterword c  ;
  internalfontnumber f  ;
  fourquarters i  ;
  scaled s  ;
  scaled h  ;
  scaled delta  ;
  scaled w  ;
  fetch ( q + 4 ) ;
  if ( ( curi .b0 > 0 ) ) 
  {
    i = curi ;
    c = curc ;
    f = curf ;
    s = 0 ;
    if ( mem [q + 1 ].hh .v.RH == 1 ) 
    {
      fetch ( q + 1 ) ;
      if ( ( ( curi .b2 ) % 4 ) == 1 ) 
      {
	a = ligkernbase [curf ]+ curi .b3 ;
	curi = fontinfo [a ].qqqq ;
	if ( curi .b0 > 128 ) 
	{
	  a = ligkernbase [curf ]+ 256 * curi .b2 + curi .b3 + 32768L - 256 
	  * ( 128 ) ;
	  curi = fontinfo [a ].qqqq ;
	} 
	while ( true ) {
	    
	  if ( curi .b1 == skewchar [curf ]) 
	  {
	    if ( curi .b2 >= 128 ) 
	    if ( curi .b0 <= 128 ) 
	    s = fontinfo [kernbase [curf ]+ 256 * curi .b2 + curi .b3 ]
	    .cint ;
	    goto lab31 ;
	  } 
	  if ( curi .b0 >= 128 ) 
	  goto lab31 ;
	  a = a + curi .b0 + 1 ;
	  curi = fontinfo [a ].qqqq ;
	} 
      } 
    } 
    lab31: ;
    x = cleanbox ( q + 1 , 2 * ( curstyle / 2 ) + 1 ) ;
    w = mem [x + 1 ].cint ;
    h = mem [x + 3 ].cint ;
    while ( true ) {
	
      if ( ( ( i .b2 ) % 4 ) != 2 ) 
      goto lab30 ;
      y = i .b3 ;
      i = fontinfo [charbase [f ]+ y ].qqqq ;
      if ( ! ( i .b0 > 0 ) ) 
      goto lab30 ;
      if ( fontinfo [widthbase [f ]+ i .b0 ].cint > w ) 
      goto lab30 ;
      c = y ;
    } 
    lab30: ;
    if ( h < fontinfo [5 + parambase [f ]].cint ) 
    delta = h ;
    else delta = fontinfo [5 + parambase [f ]].cint ;
    if ( ( mem [q + 2 ].hh .v.RH != 0 ) || ( mem [q + 3 ].hh .v.RH != 0 ) 
    ) 
    if ( mem [q + 1 ].hh .v.RH == 1 ) 
    {
      flushnodelist ( x ) ;
      x = newnoad () ;
      mem [x + 1 ]= mem [q + 1 ];
      mem [x + 2 ]= mem [q + 2 ];
      mem [x + 3 ]= mem [q + 3 ];
      mem [q + 2 ].hh = emptyfield ;
      mem [q + 3 ].hh = emptyfield ;
      mem [q + 1 ].hh .v.RH = 3 ;
      mem [q + 1 ].hh .v.LH = x ;
      x = cleanbox ( q + 1 , curstyle ) ;
      delta = delta + mem [x + 3 ].cint - h ;
      h = mem [x + 3 ].cint ;
    } 
    y = charbox ( f , c ) ;
    mem [y + 4 ].cint = s + half ( w - mem [y + 1 ].cint ) ;
    mem [y + 1 ].cint = 0 ;
    p = newkern ( - (integer) delta ) ;
    mem [p ].hh .v.RH = x ;
    mem [y ].hh .v.RH = p ;
    y = vpackage ( y , 0 , 1 , 1073741823L ) ;
    mem [y + 1 ].cint = mem [x + 1 ].cint ;
    if ( mem [y + 3 ].cint < h ) 
    {
      p = newkern ( h - mem [y + 3 ].cint ) ;
      mem [p ].hh .v.RH = mem [y + 5 ].hh .v.RH ;
      mem [y + 5 ].hh .v.RH = p ;
      mem [y + 3 ].cint = h ;
    } 
    mem [q + 1 ].hh .v.LH = y ;
    mem [q + 1 ].hh .v.RH = 2 ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zmakefraction ( halfword q ) 
#else
zmakefraction ( q ) 
  halfword q ;
#endif
{
  makefraction_regmem 
  halfword p, v, x, y, z  ;
  scaled delta, delta1, delta2, shiftup, shiftdown, clr  ;
  if ( mem [q + 1 ].cint == 1073741824L ) 
  mem [q + 1 ].cint = fontinfo [8 + parambase [eqtb [13590 + cursize ]
  .hh .v.RH ]].cint ;
  x = cleanbox ( q + 2 , curstyle + 2 - 2 * ( curstyle / 6 ) ) ;
  z = cleanbox ( q + 3 , 2 * ( curstyle / 2 ) + 3 - 2 * ( curstyle / 6 ) ) ;
  if ( mem [x + 1 ].cint < mem [z + 1 ].cint ) 
  x = rebox ( x , mem [z + 1 ].cint ) ;
  else z = rebox ( z , mem [x + 1 ].cint ) ;
  if ( curstyle < 2 ) 
  {
    shiftup = fontinfo [8 + parambase [eqtb [13589 + cursize ].hh .v.RH ]
    ].cint ;
    shiftdown = fontinfo [11 + parambase [eqtb [13589 + cursize ].hh .v.RH 
    ]].cint ;
  } 
  else {
      
    shiftdown = fontinfo [12 + parambase [eqtb [13589 + cursize ].hh .v.RH 
    ]].cint ;
    if ( mem [q + 1 ].cint != 0 ) 
    shiftup = fontinfo [9 + parambase [eqtb [13589 + cursize ].hh .v.RH ]
    ].cint ;
    else shiftup = fontinfo [10 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint ;
  } 
  if ( mem [q + 1 ].cint == 0 ) 
  {
    if ( curstyle < 2 ) 
    clr = 7 * fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH ]
    ].cint ;
    else clr = 3 * fontinfo [8 + parambase [eqtb [13590 + cursize ].hh 
    .v.RH ]].cint ;
    delta = half ( clr - ( ( shiftup - mem [x + 2 ].cint ) - ( mem [z + 3 ]
    .cint - shiftdown ) ) ) ;
    if ( delta > 0 ) 
    {
      shiftup = shiftup + delta ;
      shiftdown = shiftdown + delta ;
    } 
  } 
  else {
      
    if ( curstyle < 2 ) 
    clr = 3 * mem [q + 1 ].cint ;
    else clr = mem [q + 1 ].cint ;
    delta = half ( mem [q + 1 ].cint ) ;
    delta1 = clr - ( ( shiftup - mem [x + 2 ].cint ) - ( fontinfo [22 + 
    parambase [eqtb [13589 + cursize ].hh .v.RH ]].cint + delta ) ) ;
    delta2 = clr - ( ( fontinfo [22 + parambase [eqtb [13589 + cursize ]
    .hh .v.RH ]].cint - delta ) - ( mem [z + 3 ].cint - shiftdown ) ) ;
    if ( delta1 > 0 ) 
    shiftup = shiftup + delta1 ;
    if ( delta2 > 0 ) 
    shiftdown = shiftdown + delta2 ;
  } 
  v = newnullbox () ;
  mem [v ].hh.b0 = 1 ;
  mem [v + 3 ].cint = shiftup + mem [x + 3 ].cint ;
  mem [v + 2 ].cint = mem [z + 2 ].cint + shiftdown ;
  mem [v + 1 ].cint = mem [x + 1 ].cint ;
  if ( mem [q + 1 ].cint == 0 ) 
  {
    p = newkern ( ( shiftup - mem [x + 2 ].cint ) - ( mem [z + 3 ].cint - 
    shiftdown ) ) ;
    mem [p ].hh .v.RH = z ;
  } 
  else {
      
    y = fractionrule ( mem [q + 1 ].cint ) ;
    p = newkern ( ( fontinfo [22 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint - delta ) - ( mem [z + 3 ].cint - shiftdown ) ) ;
    mem [y ].hh .v.RH = p ;
    mem [p ].hh .v.RH = z ;
    p = newkern ( ( shiftup - mem [x + 2 ].cint ) - ( fontinfo [22 + 
    parambase [eqtb [13589 + cursize ].hh .v.RH ]].cint + delta ) ) ;
    mem [p ].hh .v.RH = y ;
  } 
  mem [x ].hh .v.RH = p ;
  mem [v + 5 ].hh .v.RH = x ;
  if ( curstyle < 2 ) 
  delta = fontinfo [20 + parambase [eqtb [13589 + cursize ].hh .v.RH ]]
  .cint ;
  else delta = fontinfo [21 + parambase [eqtb [13589 + cursize ].hh .v.RH 
  ]].cint ;
  x = vardelimiter ( q + 4 , cursize , delta ) ;
  mem [x ].hh .v.RH = v ;
  z = vardelimiter ( q + 5 , cursize , delta ) ;
  mem [v ].hh .v.RH = z ;
  mem [q + 1 ].cint = hpack ( x , 0 , 1 ) ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
zmakeop ( halfword q ) 
#else
zmakeop ( q ) 
  halfword q ;
#endif
{
  register scaled Result; makeop_regmem 
  scaled delta  ;
  halfword p, v, x, y, z  ;
  quarterword c  ;
  fourquarters i  ;
  scaled shiftup, shiftdown  ;
  if ( ( mem [q ].hh.b1 == 0 ) && ( curstyle < 2 ) ) 
  mem [q ].hh.b1 = 1 ;
  if ( mem [q + 1 ].hh .v.RH == 1 ) 
  {
    fetch ( q + 1 ) ;
    if ( ( curstyle < 2 ) && ( ( ( curi .b2 ) % 4 ) == 2 ) ) 
    {
      c = curi .b3 ;
      i = fontinfo [charbase [curf ]+ c ].qqqq ;
      if ( ( i .b0 > 0 ) ) 
      {
	curc = c ;
	curi = i ;
	mem [q + 1 ].hh.b1 = c ;
      } 
    } 
    delta = fontinfo [italicbase [curf ]+ ( curi .b2 ) / 4 ].cint ;
    x = cleanbox ( q + 1 , curstyle ) ;
    if ( ( mem [q + 3 ].hh .v.RH != 0 ) && ( mem [q ].hh.b1 != 1 ) ) 
    mem [x + 1 ].cint = mem [x + 1 ].cint - delta ;
    mem [x + 4 ].cint = half ( mem [x + 3 ].cint - mem [x + 2 ].cint ) - 
    fontinfo [22 + parambase [eqtb [13589 + cursize ].hh .v.RH ]].cint ;
    mem [q + 1 ].hh .v.RH = 2 ;
    mem [q + 1 ].hh .v.LH = x ;
  } 
  else delta = 0 ;
  if ( mem [q ].hh.b1 == 1 ) 
  {
    x = cleanbox ( q + 2 , 2 * ( curstyle / 4 ) + 4 + ( curstyle % 2 ) ) ;
    y = cleanbox ( q + 1 , curstyle ) ;
    z = cleanbox ( q + 3 , 2 * ( curstyle / 4 ) + 5 ) ;
    v = newnullbox () ;
    mem [v ].hh.b0 = 1 ;
    mem [v + 1 ].cint = mem [y + 1 ].cint ;
    if ( mem [x + 1 ].cint > mem [v + 1 ].cint ) 
    mem [v + 1 ].cint = mem [x + 1 ].cint ;
    if ( mem [z + 1 ].cint > mem [v + 1 ].cint ) 
    mem [v + 1 ].cint = mem [z + 1 ].cint ;
    x = rebox ( x , mem [v + 1 ].cint ) ;
    y = rebox ( y , mem [v + 1 ].cint ) ;
    z = rebox ( z , mem [v + 1 ].cint ) ;
    mem [x + 4 ].cint = half ( delta ) ;
    mem [z + 4 ].cint = - (integer) mem [x + 4 ].cint ;
    mem [v + 3 ].cint = mem [y + 3 ].cint ;
    mem [v + 2 ].cint = mem [y + 2 ].cint ;
    if ( mem [q + 2 ].hh .v.RH == 0 ) 
    {
      freenode ( x , 7 ) ;
      mem [v + 5 ].hh .v.RH = y ;
    } 
    else {
	
      shiftup = fontinfo [11 + parambase [eqtb [13590 + cursize ].hh .v.RH 
      ]].cint - mem [x + 2 ].cint ;
      if ( shiftup < fontinfo [9 + parambase [eqtb [13590 + cursize ].hh 
      .v.RH ]].cint ) 
      shiftup = fontinfo [9 + parambase [eqtb [13590 + cursize ].hh .v.RH 
      ]].cint ;
      p = newkern ( shiftup ) ;
      mem [p ].hh .v.RH = y ;
      mem [x ].hh .v.RH = p ;
      p = newkern ( fontinfo [13 + parambase [eqtb [13590 + cursize ].hh 
      .v.RH ]].cint ) ;
      mem [p ].hh .v.RH = x ;
      mem [v + 5 ].hh .v.RH = p ;
      mem [v + 3 ].cint = mem [v + 3 ].cint + fontinfo [13 + parambase [
      eqtb [13590 + cursize ].hh .v.RH ]].cint + mem [x + 3 ].cint + mem 
      [x + 2 ].cint + shiftup ;
    } 
    if ( mem [q + 3 ].hh .v.RH == 0 ) 
    freenode ( z , 7 ) ;
    else {
	
      shiftdown = fontinfo [12 + parambase [eqtb [13590 + cursize ].hh 
      .v.RH ]].cint - mem [z + 3 ].cint ;
      if ( shiftdown < fontinfo [10 + parambase [eqtb [13590 + cursize ]
      .hh .v.RH ]].cint ) 
      shiftdown = fontinfo [10 + parambase [eqtb [13590 + cursize ].hh 
      .v.RH ]].cint ;
      p = newkern ( shiftdown ) ;
      mem [y ].hh .v.RH = p ;
      mem [p ].hh .v.RH = z ;
      p = newkern ( fontinfo [13 + parambase [eqtb [13590 + cursize ].hh 
      .v.RH ]].cint ) ;
      mem [z ].hh .v.RH = p ;
      mem [v + 2 ].cint = mem [v + 2 ].cint + fontinfo [13 + parambase [
      eqtb [13590 + cursize ].hh .v.RH ]].cint + mem [z + 3 ].cint + mem 
      [z + 2 ].cint + shiftdown ;
    } 
    mem [q + 1 ].cint = v ;
  } 
  Result = delta ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
zmakeord ( halfword q ) 
#else
zmakeord ( q ) 
  halfword q ;
#endif
{
  /* 20 10 */ makeord_regmem 
  integer a  ;
  halfword p, r  ;
  lab20: if ( mem [q + 3 ].hh .v.RH == 0 ) 
  if ( mem [q + 2 ].hh .v.RH == 0 ) 
  if ( mem [q + 1 ].hh .v.RH == 1 ) 
  {
    p = mem [q ].hh .v.RH ;
    if ( p != -268435455L ) 
    if ( ( mem [p ].hh.b0 >= 16 ) && ( mem [p ].hh.b0 <= 22 ) ) 
    if ( mem [p + 1 ].hh .v.RH == 1 ) 
    if ( mem [p + 1 ].hh.b0 == mem [q + 1 ].hh.b0 ) 
    {
      mem [q + 1 ].hh .v.RH = 4 ;
      fetch ( q + 1 ) ;
      if ( ( ( curi .b2 ) % 4 ) == 1 ) 
      {
	a = ligkernbase [curf ]+ curi .b3 ;
	curc = mem [p + 1 ].hh.b1 ;
	curi = fontinfo [a ].qqqq ;
	if ( curi .b0 > 128 ) 
	{
	  a = ligkernbase [curf ]+ 256 * curi .b2 + curi .b3 + 32768L - 256 
	  * ( 128 ) ;
	  curi = fontinfo [a ].qqqq ;
	} 
	while ( true ) {
	    
	  if ( curi .b1 == curc ) 
	  if ( curi .b0 <= 128 ) 
	  if ( curi .b2 >= 128 ) 
	  {
	    p = newkern ( fontinfo [kernbase [curf ]+ 256 * curi .b2 + curi 
	    .b3 ].cint ) ;
	    mem [p ].hh .v.RH = mem [q ].hh .v.RH ;
	    mem [q ].hh .v.RH = p ;
	    return ;
	  } 
	  else {
	      
	    {
	      if ( interrupt != 0 ) 
	      pauseforinstructions () ;
	    } 
	    switch ( curi .b2 ) 
	    {case 1 : 
	    case 5 : 
	      mem [q + 1 ].hh.b1 = curi .b3 ;
	      break ;
	    case 2 : 
	    case 6 : 
	      mem [p + 1 ].hh.b1 = curi .b3 ;
	      break ;
	    case 3 : 
	    case 7 : 
	    case 11 : 
	      {
		r = newnoad () ;
		mem [r + 1 ].hh.b1 = curi .b3 ;
		mem [r + 1 ].hh.b0 = mem [q + 1 ].hh.b0 ;
		mem [q ].hh .v.RH = r ;
		mem [r ].hh .v.RH = p ;
		if ( curi .b2 < 11 ) 
		mem [r + 1 ].hh .v.RH = 1 ;
		else mem [r + 1 ].hh .v.RH = 4 ;
	      } 
	      break ;
	      default: 
	      {
		mem [q ].hh .v.RH = mem [p ].hh .v.RH ;
		mem [q + 1 ].hh.b1 = curi .b3 ;
		mem [q + 3 ]= mem [p + 3 ];
		mem [q + 2 ]= mem [p + 2 ];
		freenode ( p , 4 ) ;
	      } 
	      break ;
	    } 
	    if ( curi .b2 > 3 ) 
	    return ;
	    mem [q + 1 ].hh .v.RH = 1 ;
	    goto lab20 ;
	  } 
	  if ( curi .b0 >= 128 ) 
	  return ;
	  a = a + curi .b0 + 1 ;
	  curi = fontinfo [a ].qqqq ;
	} 
      } 
    } 
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zmakescripts ( halfword q , scaled delta ) 
#else
zmakescripts ( q , delta ) 
  halfword q ;
  scaled delta ;
#endif
{
  makescripts_regmem 
  halfword p, x, y, z  ;
  scaled shiftup, shiftdown, clr  ;
  smallnumber t  ;
  p = mem [q + 1 ].cint ;
  if ( ( p >= himemmin ) ) 
  {
    shiftup = 0 ;
    shiftdown = 0 ;
  } 
  else {
      
    z = hpack ( p , 0 , 1 ) ;
    if ( curstyle < 4 ) 
    t = 16 ;
    else t = 32 ;
    shiftup = mem [z + 3 ].cint - fontinfo [18 + parambase [eqtb [13589 + 
    t ].hh .v.RH ]].cint ;
    shiftdown = mem [z + 2 ].cint + fontinfo [19 + parambase [eqtb [13589 
    + t ].hh .v.RH ]].cint ;
    freenode ( z , 7 ) ;
  } 
  if ( mem [q + 2 ].hh .v.RH == 0 ) 
  {
    x = cleanbox ( q + 3 , 2 * ( curstyle / 4 ) + 5 ) ;
    mem [x + 1 ].cint = mem [x + 1 ].cint + eqtb [15775 ].cint ;
    if ( shiftdown < fontinfo [16 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint ) 
    shiftdown = fontinfo [16 + parambase [eqtb [13589 + cursize ].hh .v.RH 
    ]].cint ;
    clr = mem [x + 3 ].cint - ( abs ( fontinfo [5 + parambase [eqtb [
    13589 + cursize ].hh .v.RH ]].cint * 4 ) / 5 ) ;
    if ( shiftdown < clr ) 
    shiftdown = clr ;
    mem [x + 4 ].cint = shiftdown ;
  } 
  else {
      
    {
      x = cleanbox ( q + 2 , 2 * ( curstyle / 4 ) + 4 + ( curstyle % 2 ) ) ;
      mem [x + 1 ].cint = mem [x + 1 ].cint + eqtb [15775 ].cint ;
      if ( odd ( curstyle ) ) 
      clr = fontinfo [15 + parambase [eqtb [13589 + cursize ].hh .v.RH ]]
      .cint ;
      else if ( curstyle < 2 ) 
      clr = fontinfo [13 + parambase [eqtb [13589 + cursize ].hh .v.RH ]]
      .cint ;
      else clr = fontinfo [14 + parambase [eqtb [13589 + cursize ].hh 
      .v.RH ]].cint ;
      if ( shiftup < clr ) 
      shiftup = clr ;
      clr = mem [x + 2 ].cint + ( abs ( fontinfo [5 + parambase [eqtb [
      13589 + cursize ].hh .v.RH ]].cint ) / 4 ) ;
      if ( shiftup < clr ) 
      shiftup = clr ;
    } 
    if ( mem [q + 3 ].hh .v.RH == 0 ) 
    mem [x + 4 ].cint = - (integer) shiftup ;
    else {
	
      y = cleanbox ( q + 3 , 2 * ( curstyle / 4 ) + 5 ) ;
      mem [y + 1 ].cint = mem [y + 1 ].cint + eqtb [15775 ].cint ;
      if ( shiftdown < fontinfo [17 + parambase [eqtb [13589 + cursize ]
      .hh .v.RH ]].cint ) 
      shiftdown = fontinfo [17 + parambase [eqtb [13589 + cursize ].hh 
      .v.RH ]].cint ;
      clr = 4 * fontinfo [8 + parambase [eqtb [13590 + cursize ].hh .v.RH 
      ]].cint - ( ( shiftup - mem [x + 2 ].cint ) - ( mem [y + 3 ].cint 
      - shiftdown ) ) ;
      if ( clr > 0 ) 
      {
	shiftdown = shiftdown + clr ;
	clr = ( abs ( fontinfo [5 + parambase [eqtb [13589 + cursize ].hh 
	.v.RH ]].cint * 4 ) / 5 ) - ( shiftup - mem [x + 2 ].cint ) ;
	if ( clr > 0 ) 
	{
	  shiftup = shiftup + clr ;
	  shiftdown = shiftdown - clr ;
	} 
      } 
      mem [x + 4 ].cint = delta ;
      p = newkern ( ( shiftup - mem [x + 2 ].cint ) - ( mem [y + 3 ].cint 
      - shiftdown ) ) ;
      mem [x ].hh .v.RH = p ;
      mem [p ].hh .v.RH = y ;
      x = vpackage ( x , 0 , 1 , 1073741823L ) ;
      mem [x + 4 ].cint = shiftdown ;
    } 
  } 
  if ( mem [q + 1 ].cint == -268435455L ) 
  mem [q + 1 ].cint = x ;
  else {
      
    p = mem [q + 1 ].cint ;
    while ( mem [p ].hh .v.RH != -268435455L ) p = mem [p ].hh .v.RH ;
    mem [p ].hh .v.RH = x ;
  } 
} 
smallnumber 
#ifdef HAVE_PROTOTYPES
zmakeleftright ( halfword q , smallnumber style , scaled maxd , scaled maxh ) 
#else
zmakeleftright ( q , style , maxd , maxh ) 
  halfword q ;
  smallnumber style ;
  scaled maxd ;
  scaled maxh ;
#endif
{
  register smallnumber Result; makeleftright_regmem 
  scaled delta, delta1, delta2  ;
  curstyle = style ;
  {
    if ( curstyle < 4 ) 
    cursize = 0 ;
    else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
    curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint , 18 ) ;
  } 
  delta2 = maxd + fontinfo [22 + parambase [eqtb [13589 + cursize ].hh 
  .v.RH ]].cint ;
  delta1 = maxh + maxd - delta2 ;
  if ( delta2 > delta1 ) 
  delta1 = delta2 ;
  delta = ( delta1 / 500 ) * eqtb [15189 ].cint ;
  delta2 = delta1 + delta1 - eqtb [15773 ].cint ;
  if ( delta < delta2 ) 
  delta = delta2 ;
  mem [q + 1 ].cint = vardelimiter ( q + 1 , cursize , delta ) ;
  Result = mem [q ].hh.b0 - ( 10 ) ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
mlisttohlist ( void ) 
#else
mlisttohlist ( ) 
#endif
{
  /* 21 82 80 81 83 30 */ mlisttohlist_regmem 
  halfword mlist  ;
  boolean penalties  ;
  smallnumber style  ;
  smallnumber savestyle  ;
  halfword q  ;
  halfword r  ;
  smallnumber rtype  ;
  smallnumber t  ;
  halfword p, x, y, z  ;
  integer pen  ;
  smallnumber s  ;
  scaled maxh, maxd  ;
  scaled delta  ;
  mlist = curmlist ;
  penalties = mlistpenalties ;
  style = curstyle ;
  q = mlist ;
  r = -268435455L ;
  rtype = 17 ;
  maxh = 0 ;
  maxd = 0 ;
  {
    if ( curstyle < 4 ) 
    cursize = 0 ;
    else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
    curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint , 18 ) ;
  } 
  while ( q != -268435455L ) {
      
    lab21: delta = 0 ;
    switch ( mem [q ].hh.b0 ) 
    {case 18 : 
      switch ( rtype ) 
      {case 18 : 
      case 17 : 
      case 19 : 
      case 20 : 
      case 22 : 
      case 30 : 
	{
	  mem [q ].hh.b0 = 16 ;
	  goto lab21 ;
	} 
	break ;
	default: 
	;
	break ;
      } 
      break ;
    case 19 : 
    case 21 : 
    case 22 : 
    case 31 : 
      {
	if ( rtype == 18 ) 
	mem [r ].hh.b0 = 16 ;
	if ( mem [q ].hh.b0 == 31 ) 
	goto lab80 ;
      } 
      break ;
    case 30 : 
      goto lab80 ;
      break ;
    case 25 : 
      {
	makefraction ( q ) ;
	goto lab82 ;
      } 
      break ;
    case 17 : 
      {
	delta = makeop ( q ) ;
	if ( mem [q ].hh.b1 == 1 ) 
	goto lab82 ;
      } 
      break ;
    case 16 : 
      makeord ( q ) ;
      break ;
    case 20 : 
    case 23 : 
      ;
      break ;
    case 24 : 
      makeradical ( q ) ;
      break ;
    case 27 : 
      makeover ( q ) ;
      break ;
    case 26 : 
      makeunder ( q ) ;
      break ;
    case 28 : 
      makemathaccent ( q ) ;
      break ;
    case 29 : 
      makevcenter ( q ) ;
      break ;
    case 14 : 
      {
	curstyle = mem [q ].hh.b1 ;
	{
	  if ( curstyle < 4 ) 
	  cursize = 0 ;
	  else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
	  curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ]
	  .hh .v.RH ]].cint , 18 ) ;
	} 
	goto lab81 ;
      } 
      break ;
    case 15 : 
      {
	switch ( curstyle / 2 ) 
	{case 0 : 
	  {
	    p = mem [q + 1 ].hh .v.LH ;
	    mem [q + 1 ].hh .v.LH = -268435455L ;
	  } 
	  break ;
	case 1 : 
	  {
	    p = mem [q + 1 ].hh .v.RH ;
	    mem [q + 1 ].hh .v.RH = -268435455L ;
	  } 
	  break ;
	case 2 : 
	  {
	    p = mem [q + 2 ].hh .v.LH ;
	    mem [q + 2 ].hh .v.LH = -268435455L ;
	  } 
	  break ;
	case 3 : 
	  {
	    p = mem [q + 2 ].hh .v.RH ;
	    mem [q + 2 ].hh .v.RH = -268435455L ;
	  } 
	  break ;
	} 
	flushnodelist ( mem [q + 1 ].hh .v.LH ) ;
	flushnodelist ( mem [q + 1 ].hh .v.RH ) ;
	flushnodelist ( mem [q + 2 ].hh .v.LH ) ;
	flushnodelist ( mem [q + 2 ].hh .v.RH ) ;
	mem [q ].hh.b0 = 14 ;
	mem [q ].hh.b1 = curstyle ;
	mem [q + 1 ].cint = 0 ;
	mem [q + 2 ].cint = 0 ;
	if ( p != -268435455L ) 
	{
	  z = mem [q ].hh .v.RH ;
	  mem [q ].hh .v.RH = p ;
	  while ( mem [p ].hh .v.RH != -268435455L ) p = mem [p ].hh .v.RH 
	  ;
	  mem [p ].hh .v.RH = z ;
	} 
	goto lab81 ;
      } 
      break ;
    case 3 : 
    case 4 : 
    case 5 : 
    case 8 : 
    case 12 : 
    case 7 : 
      goto lab81 ;
      break ;
    case 2 : 
      {
	if ( mem [q + 3 ].cint > maxh ) 
	maxh = mem [q + 3 ].cint ;
	if ( mem [q + 2 ].cint > maxd ) 
	maxd = mem [q + 2 ].cint ;
	goto lab81 ;
      } 
      break ;
    case 10 : 
      {
	if ( mem [q ].hh.b1 == 99 ) 
	{
	  x = mem [q + 1 ].hh .v.LH ;
	  y = mathglue ( x , curmu ) ;
	  deleteglueref ( x ) ;
	  mem [q + 1 ].hh .v.LH = y ;
	  mem [q ].hh.b1 = 0 ;
	} 
	else if ( ( cursize != 0 ) && ( mem [q ].hh.b1 == 98 ) ) 
	{
	  p = mem [q ].hh .v.RH ;
	  if ( p != -268435455L ) 
	  if ( ( mem [p ].hh.b0 == 10 ) || ( mem [p ].hh.b0 == 11 ) ) 
	  {
	    mem [q ].hh .v.RH = mem [p ].hh .v.RH ;
	    mem [p ].hh .v.RH = -268435455L ;
	    flushnodelist ( p ) ;
	  } 
	} 
	goto lab81 ;
      } 
      break ;
    case 11 : 
      {
	mathkern ( q , curmu ) ;
	goto lab81 ;
      } 
      break ;
      default: 
      confusion ( 1126 ) ;
      break ;
    } 
    switch ( mem [q + 1 ].hh .v.RH ) 
    {case 1 : 
    case 4 : 
      {
	fetch ( q + 1 ) ;
	if ( ( curi .b0 > 0 ) ) 
	{
	  delta = fontinfo [italicbase [curf ]+ ( curi .b2 ) / 4 ].cint ;
	  p = newcharacter ( curf , curc ) ;
	  if ( ( mem [q + 1 ].hh .v.RH == 4 ) && ( fontinfo [2 + parambase 
	  [curf ]].cint != 0 ) ) 
	  delta = 0 ;
	  if ( ( mem [q + 3 ].hh .v.RH == 0 ) && ( delta != 0 ) ) 
	  {
	    mem [p ].hh .v.RH = newkern ( delta ) ;
	    delta = 0 ;
	  } 
	} 
	else p = -268435455L ;
      } 
      break ;
    case 0 : 
      p = -268435455L ;
      break ;
    case 2 : 
      p = mem [q + 1 ].hh .v.LH ;
      break ;
    case 3 : 
      {
	curmlist = mem [q + 1 ].hh .v.LH ;
	savestyle = curstyle ;
	mlistpenalties = false ;
	mlisttohlist () ;
	curstyle = savestyle ;
	{
	  if ( curstyle < 4 ) 
	  cursize = 0 ;
	  else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
	  curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ]
	  .hh .v.RH ]].cint , 18 ) ;
	} 
	p = hpack ( mem [memtop - 3 ].hh .v.RH , 0 , 1 ) ;
      } 
      break ;
      default: 
      confusion ( 1127 ) ;
      break ;
    } 
    mem [q + 1 ].cint = p ;
    if ( ( mem [q + 3 ].hh .v.RH == 0 ) && ( mem [q + 2 ].hh .v.RH == 0 ) 
    ) 
    goto lab82 ;
    makescripts ( q , delta ) ;
    lab82: z = hpack ( mem [q + 1 ].cint , 0 , 1 ) ;
    if ( mem [z + 3 ].cint > maxh ) 
    maxh = mem [z + 3 ].cint ;
    if ( mem [z + 2 ].cint > maxd ) 
    maxd = mem [z + 2 ].cint ;
    freenode ( z , 7 ) ;
    lab80: r = q ;
    rtype = mem [r ].hh.b0 ;
    if ( rtype == 31 ) 
    {
      rtype = 30 ;
      curstyle = style ;
      {
	if ( curstyle < 4 ) 
	cursize = 0 ;
	else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
	curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ]
	.hh .v.RH ]].cint , 18 ) ;
      } 
    } 
    lab81: q = mem [q ].hh .v.RH ;
  } 
  if ( rtype == 18 ) 
  mem [r ].hh.b0 = 16 ;
  p = memtop - 3 ;
  mem [p ].hh .v.RH = -268435455L ;
  q = mlist ;
  rtype = 0 ;
  curstyle = style ;
  {
    if ( curstyle < 4 ) 
    cursize = 0 ;
    else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
    curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ].hh 
    .v.RH ]].cint , 18 ) ;
  } 
  while ( q != -268435455L ) {
      
    t = 16 ;
    s = 4 ;
    pen = 10000 ;
    switch ( mem [q ].hh.b0 ) 
    {case 17 : 
    case 20 : 
    case 21 : 
    case 22 : 
    case 23 : 
      t = mem [q ].hh.b0 ;
      break ;
    case 18 : 
      {
	t = 18 ;
	pen = eqtb [15180 ].cint ;
      } 
      break ;
    case 19 : 
      {
	t = 19 ;
	pen = eqtb [15181 ].cint ;
      } 
      break ;
    case 16 : 
    case 29 : 
    case 27 : 
    case 26 : 
      ;
      break ;
    case 24 : 
      s = 5 ;
      break ;
    case 28 : 
      s = 5 ;
      break ;
    case 25 : 
      {
	t = 23 ;
	s = 6 ;
      } 
      break ;
    case 30 : 
    case 31 : 
      t = makeleftright ( q , style , maxd , maxh ) ;
      break ;
    case 14 : 
      {
	curstyle = mem [q ].hh.b1 ;
	s = 3 ;
	{
	  if ( curstyle < 4 ) 
	  cursize = 0 ;
	  else cursize = 16 * ( ( curstyle - 2 ) / 2 ) ;
	  curmu = xovern ( fontinfo [6 + parambase [eqtb [13589 + cursize ]
	  .hh .v.RH ]].cint , 18 ) ;
	} 
	goto lab83 ;
      } 
      break ;
    case 8 : 
    case 12 : 
    case 2 : 
    case 7 : 
    case 5 : 
    case 3 : 
    case 4 : 
    case 10 : 
    case 11 : 
      {
	mem [p ].hh .v.RH = q ;
	p = q ;
	q = mem [q ].hh .v.RH ;
	mem [p ].hh .v.RH = -268435455L ;
	goto lab30 ;
      } 
      break ;
      default: 
      confusion ( 1128 ) ;
      break ;
    } 
    if ( rtype > 0 ) 
    {
      switch ( strpool [rtype * 8 + t + magicoffset ]) 
      {case 48 : 
	x = 0 ;
	break ;
      case 49 : 
	if ( curstyle < 4 ) 
	x = 15 ;
	else x = 0 ;
	break ;
      case 50 : 
	x = 15 ;
	break ;
      case 51 : 
	if ( curstyle < 4 ) 
	x = 16 ;
	else x = 0 ;
	break ;
      case 52 : 
	if ( curstyle < 4 ) 
	x = 17 ;
	else x = 0 ;
	break ;
	default: 
	confusion ( 1130 ) ;
	break ;
      } 
      if ( x != 0 ) 
      {
	y = mathglue ( eqtb [12526 + x ].hh .v.RH , curmu ) ;
	z = newglue ( y ) ;
	mem [y ].hh .v.RH = -268435455L ;
	mem [p ].hh .v.RH = z ;
	p = z ;
	mem [z ].hh.b1 = x + 1 ;
      } 
    } 
    if ( mem [q + 1 ].cint != -268435455L ) 
    {
      mem [p ].hh .v.RH = mem [q + 1 ].cint ;
      do {
	  p = mem [p ].hh .v.RH ;
      } while ( ! ( mem [p ].hh .v.RH == -268435455L ) ) ;
    } 
    if ( penalties ) 
    if ( mem [q ].hh .v.RH != -268435455L ) 
    if ( pen < 10000 ) 
    {
      rtype = mem [mem [q ].hh .v.RH ].hh.b0 ;
      if ( rtype != 12 ) 
      if ( rtype != 19 ) 
      {
	z = newpenalty ( pen ) ;
	mem [p ].hh .v.RH = z ;
	p = z ;
      } 
    } 
    if ( mem [q ].hh.b0 == 31 ) 
    t = 20 ;
    rtype = t ;
    lab83: r = q ;
    q = mem [q ].hh .v.RH ;
    freenode ( r , s ) ;
    lab30: ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
pushalignment ( void ) 
#else
pushalignment ( ) 
#endif
{
  pushalignment_regmem 
  halfword p  ;
  p = getnode ( 6 ) ;
  mem [p ].hh .v.RH = alignptr ;
  mem [p ].hh .v.LH = curalign ;
  mem [p + 1 ].hh .v.LH = mem [memtop - 8 ].hh .v.RH ;
  mem [p + 1 ].hh .v.RH = curspan ;
  mem [p + 2 ].cint = curloop ;
  mem [p + 3 ].cint = alignstate ;
  mem [p + 4 ].hh .v.LH = curhead ;
  mem [p + 4 ].hh .v.RH = curtail ;
  mem [p + 5 ].hh .v.LH = curprehead ;
  mem [p + 5 ].hh .v.RH = curpretail ;
  alignptr = p ;
  curhead = getavail () ;
} 
void 
#ifdef HAVE_PROTOTYPES
popalignment ( void ) 
#else
popalignment ( ) 
#endif
{
  popalignment_regmem 
  halfword p  ;
  {
    mem [curhead ].hh .v.RH = avail ;
    avail = curhead ;
	;
#ifdef STAT
    decr ( dynused ) ;
#endif /* STAT */
  } 
  p = alignptr ;
  curtail = mem [p + 4 ].hh .v.RH ;
  curhead = mem [p + 4 ].hh .v.LH ;
  curpretail = mem [p + 5 ].hh .v.RH ;
  curprehead = mem [p + 5 ].hh .v.LH ;
  alignstate = mem [p + 3 ].cint ;
  curloop = mem [p + 2 ].cint ;
  curspan = mem [p + 1 ].hh .v.RH ;
  mem [memtop - 8 ].hh .v.RH = mem [p + 1 ].hh .v.LH ;
  curalign = mem [p ].hh .v.LH ;
  alignptr = mem [p ].hh .v.RH ;
  freenode ( p , 6 ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
getpreambletoken ( void ) 
#else
getpreambletoken ( ) 
#endif
{
  /* 20 */ getpreambletoken_regmem 
  lab20: gettoken () ;
  while ( ( curchr == 256 ) && ( curcmd == 4 ) ) {
      
    gettoken () ;
    if ( curcmd > 100 ) 
    {
      expand () ;
      gettoken () ;
    } 
  } 
  if ( curcmd == 9 ) 
  fatalerror ( 632 ) ;
  if ( ( curcmd == 75 ) && ( curchr == 12537 ) ) 
  {
    scanoptionalequals () ;
    scanglue ( 2 ) ;
    if ( eqtb [15214 ].cint > 0 ) 
    geqdefine ( 12537 , 117 , curval ) ;
    else eqdefine ( 12537 , 117 , curval ) ;
    goto lab20 ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
initalign ( void ) 
#else
initalign ( ) 
#endif
{
  /* 30 31 32 22 */ initalign_regmem 
  halfword savecsptr  ;
  halfword p  ;
  savecsptr = curcs ;
  pushalignment () ;
  alignstate = -1000000L ;
  if ( ( curlist .modefield == 203 ) && ( ( curlist .tailfield != curlist 
  .headfield ) || ( curlist .auxfield .cint != -268435455L ) ) ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 733 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 733 ) ;
      } 
    } 
    printesc ( 550 ) ;
    print ( 1131 ) ;
    {
      helpptr = 3 ;
      helpline [2 ]= 1132 ;
      helpline [1 ]= 1133 ;
      helpline [0 ]= 1134 ;
    } 
    error () ;
    flushmath () ;
  } 
  pushnest () ;
  if ( curlist .modefield == 203 ) 
  {
    curlist .modefield = -1 ;
    curlist .auxfield .cint = nest [nestptr - 2 ].auxfield .cint ;
  } 
  else if ( curlist .modefield > 0 ) 
  curlist .modefield = - (integer) curlist .modefield ;
  scanspec ( 6 , false ) ;
  mem [memtop - 8 ].hh .v.RH = -268435455L ;
  curalign = memtop - 8 ;
  curloop = -268435455L ;
  scannerstatus = 4 ;
  warningindex = savecsptr ;
  alignstate = -1000000L ;
  while ( true ) {
      
    mem [curalign ].hh .v.RH = newparamglue ( 11 ) ;
    curalign = mem [curalign ].hh .v.RH ;
    if ( curcmd == 5 ) 
    goto lab30 ;
    p = memtop - 4 ;
    mem [p ].hh .v.RH = -268435455L ;
    while ( true ) {
	
      getpreambletoken () ;
      if ( curcmd == 6 ) 
      goto lab31 ;
      if ( ( curcmd <= 5 ) && ( curcmd >= 4 ) && ( alignstate == -1000000L ) ) 
      if ( ( p == memtop - 4 ) && ( curloop == -268435455L ) && ( curcmd == 4 
      ) ) 
      curloop = curalign ;
      else {
	  
	{
	  if ( interaction == 3 ) 
	  ;
	  if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) 
	  ) ) 
	  {
	    printnl ( 263 ) ;
	    print ( fullsourcefilenamestack [inopen ]) ;
	    print ( 58 ) ;
	    printint ( line ) ;
	    print ( 264 ) ;
	    print ( 1140 ) ;
	  } 
	  else {
	      
	    printnl ( 265 ) ;
	    print ( 1140 ) ;
	  } 
	} 
	{
	  helpptr = 3 ;
	  helpline [2 ]= 1141 ;
	  helpline [1 ]= 1142 ;
	  helpline [0 ]= 1143 ;
	} 
	backerror () ;
	goto lab31 ;
      } 
      else if ( ( curcmd != 10 ) || ( p != memtop - 4 ) ) 
      {
	mem [p ].hh .v.RH = getavail () ;
	p = mem [p ].hh .v.RH ;
	mem [p ].hh .v.LH = curtok ;
      } 
    } 
    lab31: ;
    mem [curalign ].hh .v.RH = newnullbox () ;
    curalign = mem [curalign ].hh .v.RH ;
    mem [curalign ].hh .v.LH = memtop - 9 ;
    mem [curalign + 1 ].cint = -1073741824L ;
    mem [curalign + 3 ].cint = mem [memtop - 4 ].hh .v.RH ;
    p = memtop - 4 ;
    mem [p ].hh .v.RH = -268435455L ;
    while ( true ) {
	
      lab22: getpreambletoken () ;
      if ( ( curcmd <= 5 ) && ( curcmd >= 4 ) && ( alignstate == -1000000L ) ) 
      goto lab32 ;
      if ( curcmd == 6 ) 
      {
	{
	  if ( interaction == 3 ) 
	  ;
	  if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) 
	  ) ) 
	  {
	    printnl ( 263 ) ;
	    print ( fullsourcefilenamestack [inopen ]) ;
	    print ( 58 ) ;
	    printint ( line ) ;
	    print ( 264 ) ;
	    print ( 1144 ) ;
	  } 
	  else {
	      
	    printnl ( 265 ) ;
	    print ( 1144 ) ;
	  } 
	} 
	{
	  helpptr = 3 ;
	  helpline [2 ]= 1141 ;
	  helpline [1 ]= 1142 ;
	  helpline [0 ]= 1145 ;
	} 
	error () ;
	goto lab22 ;
      } 
      mem [p ].hh .v.RH = getavail () ;
      p = mem [p ].hh .v.RH ;
      mem [p ].hh .v.LH = curtok ;
    } 
    lab32: mem [p ].hh .v.RH = getavail () ;
    p = mem [p ].hh .v.RH ;
    mem [p ].hh .v.LH = 14614 ;
    mem [curalign + 2 ].cint = mem [memtop - 4 ].hh .v.RH ;
  } 
  lab30: scannerstatus = 0 ;
  newsavelevel ( 6 ) ;
  if ( eqtb [13068 ].hh .v.RH != -268435455L ) 
  begintokenlist ( eqtb [13068 ].hh .v.RH , 13 ) ;
  alignpeek () ;
} 
void 
#ifdef HAVE_PROTOTYPES
zinitspan ( halfword p ) 
#else
zinitspan ( p ) 
  halfword p ;
#endif
{
  initspan_regmem 
  pushnest () ;
  if ( curlist .modefield == -102 ) 
  curlist .auxfield .hh .v.LH = 1000 ;
  else {
      
    curlist .auxfield .cint = -65536000L ;
    normalparagraph () ;
  } 
  curspan = p ;
} 
void 
#ifdef HAVE_PROTOTYPES
initrow ( void ) 
#else
initrow ( ) 
#endif
{
  initrow_regmem 
  pushnest () ;
  curlist .modefield = ( -103 ) - curlist .modefield ;
  if ( curlist .modefield == -102 ) 
  curlist .auxfield .hh .v.LH = 0 ;
  else curlist .auxfield .cint = 0 ;
  {
    mem [curlist .tailfield ].hh .v.RH = newglue ( mem [mem [memtop - 8 ]
    .hh .v.RH + 1 ].hh .v.LH ) ;
    curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
  } 
  mem [curlist .tailfield ].hh.b1 = 12 ;
  curalign = mem [mem [memtop - 8 ].hh .v.RH ].hh .v.RH ;
  curtail = curhead ;
  curpretail = curprehead ;
  initspan ( curalign ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
initcol ( void ) 
#else
initcol ( ) 
#endif
{
  initcol_regmem 
  mem [curalign + 5 ].hh .v.LH = curcmd ;
  if ( curcmd == 63 ) 
  alignstate = 0 ;
  else {
      
    backinput () ;
    begintokenlist ( mem [curalign + 3 ].cint , 1 ) ;
  } 
} 
boolean 
#ifdef HAVE_PROTOTYPES
fincol ( void ) 
#else
fincol ( ) 
#endif
{
  /* 10 */ register boolean Result; fincol_regmem 
  halfword p  ;
  halfword q, r  ;
  halfword s  ;
  halfword u  ;
  scaled w  ;
  glueord o  ;
  halfword n  ;
  if ( curalign == -268435455L ) 
  confusion ( 1146 ) ;
  q = mem [curalign ].hh .v.RH ;
  if ( q == -268435455L ) 
  confusion ( 1146 ) ;
  if ( alignstate < 500000L ) 
  fatalerror ( 632 ) ;
  p = mem [q ].hh .v.RH ;
  if ( ( p == -268435455L ) && ( mem [curalign + 5 ].hh .v.LH < 257 ) ) 
  if ( curloop != -268435455L ) 
  {
    mem [q ].hh .v.RH = newnullbox () ;
    p = mem [q ].hh .v.RH ;
    mem [p ].hh .v.LH = memtop - 9 ;
    mem [p + 1 ].cint = -1073741824L ;
    curloop = mem [curloop ].hh .v.RH ;
    q = memtop - 4 ;
    r = mem [curloop + 3 ].cint ;
    while ( r != -268435455L ) {
	
      mem [q ].hh .v.RH = getavail () ;
      q = mem [q ].hh .v.RH ;
      mem [q ].hh .v.LH = mem [r ].hh .v.LH ;
      r = mem [r ].hh .v.RH ;
    } 
    mem [q ].hh .v.RH = -268435455L ;
    mem [p + 3 ].cint = mem [memtop - 4 ].hh .v.RH ;
    q = memtop - 4 ;
    r = mem [curloop + 2 ].cint ;
    while ( r != -268435455L ) {
	
      mem [q ].hh .v.RH = getavail () ;
      q = mem [q ].hh .v.RH ;
      mem [q ].hh .v.LH = mem [r ].hh .v.LH ;
      r = mem [r ].hh .v.RH ;
    } 
    mem [q ].hh .v.RH = -268435455L ;
    mem [p + 2 ].cint = mem [memtop - 4 ].hh .v.RH ;
    curloop = mem [curloop ].hh .v.RH ;
    mem [p ].hh .v.RH = newglue ( mem [curloop + 1 ].hh .v.LH ) ;
  } 
  else {
      
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 1147 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 1147 ) ;
      } 
    } 
    printesc ( 1136 ) ;
    {
      helpptr = 3 ;
      helpline [2 ]= 1148 ;
      helpline [1 ]= 1149 ;
      helpline [0 ]= 1150 ;
    } 
    mem [curalign + 5 ].hh .v.LH = 257 ;
    error () ;
  } 
  if ( mem [curalign + 5 ].hh .v.LH != 256 ) 
  {
    unsave () ;
    newsavelevel ( 6 ) ;
    {
      if ( curlist .modefield == -102 ) 
      {
	adjusttail = curtail ;
	preadjusttail = curpretail ;
	u = hpack ( mem [curlist .headfield ].hh .v.RH , 0 , 1 ) ;
	w = mem [u + 1 ].cint ;
	curtail = adjusttail ;
	adjusttail = -268435455L ;
	curpretail = preadjusttail ;
	preadjusttail = -268435455L ;
      } 
      else {
	  
	u = vpackage ( mem [curlist .headfield ].hh .v.RH , 0 , 1 , 0 ) ;
	w = mem [u + 3 ].cint ;
      } 
      n = 0 ;
      if ( curspan != curalign ) 
      {
	q = curspan ;
	do {
	    incr ( n ) ;
	  q = mem [mem [q ].hh .v.RH ].hh .v.RH ;
	} while ( ! ( q == curalign ) ) ;
	if ( n > 255 ) 
	confusion ( 1151 ) ;
	q = curspan ;
	while ( mem [mem [q ].hh .v.LH ].hh .v.RH < n ) q = mem [q ].hh 
	.v.LH ;
	if ( mem [mem [q ].hh .v.LH ].hh .v.RH > n ) 
	{
	  s = getnode ( 2 ) ;
	  mem [s ].hh .v.LH = mem [q ].hh .v.LH ;
	  mem [s ].hh .v.RH = n ;
	  mem [q ].hh .v.LH = s ;
	  mem [s + 1 ].cint = w ;
	} 
	else if ( mem [mem [q ].hh .v.LH + 1 ].cint < w ) 
	mem [mem [q ].hh .v.LH + 1 ].cint = w ;
      } 
      else if ( w > mem [curalign + 1 ].cint ) 
      mem [curalign + 1 ].cint = w ;
      mem [u ].hh.b0 = 13 ;
      mem [u ].hh.b1 = n ;
      if ( totalstretch [3 ]!= 0 ) 
      o = 3 ;
      else if ( totalstretch [2 ]!= 0 ) 
      o = 2 ;
      else if ( totalstretch [1 ]!= 0 ) 
      o = 1 ;
      else o = 0 ;
      mem [u + 5 ].hh.b1 = o ;
      mem [u + 6 ].cint = totalstretch [o ];
      if ( totalshrink [3 ]!= 0 ) 
      o = 3 ;
      else if ( totalshrink [2 ]!= 0 ) 
      o = 2 ;
      else if ( totalshrink [1 ]!= 0 ) 
      o = 1 ;
      else o = 0 ;
      mem [u + 5 ].hh.b0 = o ;
      mem [u + 4 ].cint = totalshrink [o ];
      popnest () ;
      mem [curlist .tailfield ].hh .v.RH = u ;
      curlist .tailfield = u ;
    } 
    {
      mem [curlist .tailfield ].hh .v.RH = newglue ( mem [mem [curalign ]
      .hh .v.RH + 1 ].hh .v.LH ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    mem [curlist .tailfield ].hh.b1 = 12 ;
    if ( mem [curalign + 5 ].hh .v.LH >= 257 ) 
    {
      Result = true ;
      return Result ;
    } 
    initspan ( p ) ;
  } 
  alignstate = 1000000L ;
  do {
      getxorprotected () ;
  } while ( ! ( curcmd != 10 ) ) ;
  curalign = p ;
  initcol () ;
  Result = false ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
finrow ( void ) 
#else
finrow ( ) 
#endif
{
  finrow_regmem 
  halfword p  ;
  if ( curlist .modefield == -102 ) 
  {
    p = hpack ( mem [curlist .headfield ].hh .v.RH , 0 , 1 ) ;
    popnest () ;
    if ( curprehead != curpretail ) 
    {
      mem [curlist .tailfield ].hh .v.RH = mem [curprehead ].hh .v.RH ;
      curlist .tailfield = curpretail ;
    } 
    appendtovlist ( p ) ;
    if ( curhead != curtail ) 
    {
      mem [curlist .tailfield ].hh .v.RH = mem [curhead ].hh .v.RH ;
      curlist .tailfield = curtail ;
    } 
  } 
  else {
      
    p = vpackage ( mem [curlist .headfield ].hh .v.RH , 0 , 1 , 1073741823L 
    ) ;
    popnest () ;
    mem [curlist .tailfield ].hh .v.RH = p ;
    curlist .tailfield = p ;
    curlist .auxfield .hh .v.LH = 1000 ;
  } 
  mem [p ].hh.b0 = 13 ;
  mem [p + 6 ].cint = 0 ;
  if ( eqtb [13068 ].hh .v.RH != -268435455L ) 
  begintokenlist ( eqtb [13068 ].hh .v.RH , 13 ) ;
  alignpeek () ;
} 
void 
#ifdef HAVE_PROTOTYPES
finalign ( void ) 
#else
finalign ( ) 
#endif
{
  finalign_regmem 
  halfword p, q, r, s, u, v  ;
  scaled t, w  ;
  scaled o  ;
  halfword n  ;
  scaled rulesave  ;
  memoryword auxsave  ;
  if ( curgroup != 6 ) 
  confusion ( 1152 ) ;
  unsave () ;
  if ( curgroup != 6 ) 
  confusion ( 1153 ) ;
  unsave () ;
  if ( nest [nestptr - 1 ].modefield == 203 ) 
  o = eqtb [15778 ].cint ;
  else o = 0 ;
  q = mem [mem [memtop - 8 ].hh .v.RH ].hh .v.RH ;
  do {
      flushlist ( mem [q + 3 ].cint ) ;
    flushlist ( mem [q + 2 ].cint ) ;
    p = mem [mem [q ].hh .v.RH ].hh .v.RH ;
    if ( mem [q + 1 ].cint == -1073741824L ) 
    {
      mem [q + 1 ].cint = 0 ;
      r = mem [q ].hh .v.RH ;
      s = mem [r + 1 ].hh .v.LH ;
      if ( s != membot ) 
      {
	incr ( mem [membot ].hh .v.RH ) ;
	deleteglueref ( s ) ;
	mem [r + 1 ].hh .v.LH = membot ;
      } 
    } 
    if ( mem [q ].hh .v.LH != memtop - 9 ) 
    {
      t = mem [q + 1 ].cint + mem [mem [mem [q ].hh .v.RH + 1 ].hh 
      .v.LH + 1 ].cint ;
      r = mem [q ].hh .v.LH ;
      s = memtop - 9 ;
      mem [s ].hh .v.LH = p ;
      n = 1 ;
      do {
	  mem [r + 1 ].cint = mem [r + 1 ].cint - t ;
	u = mem [r ].hh .v.LH ;
	while ( mem [r ].hh .v.RH > n ) {
	    
	  s = mem [s ].hh .v.LH ;
	  n = mem [mem [s ].hh .v.LH ].hh .v.RH + 1 ;
	} 
	if ( mem [r ].hh .v.RH < n ) 
	{
	  mem [r ].hh .v.LH = mem [s ].hh .v.LH ;
	  mem [s ].hh .v.LH = r ;
	  decr ( mem [r ].hh .v.RH ) ;
	  s = r ;
	} 
	else {
	    
	  if ( mem [r + 1 ].cint > mem [mem [s ].hh .v.LH + 1 ].cint ) 
	  mem [mem [s ].hh .v.LH + 1 ].cint = mem [r + 1 ].cint ;
	  freenode ( r , 2 ) ;
	} 
	r = u ;
      } while ( ! ( r == memtop - 9 ) ) ;
    } 
    mem [q ].hh.b0 = 13 ;
    mem [q ].hh.b1 = 0 ;
    mem [q + 3 ].cint = 0 ;
    mem [q + 2 ].cint = 0 ;
    mem [q + 5 ].hh.b1 = 0 ;
    mem [q + 5 ].hh.b0 = 0 ;
    mem [q + 6 ].cint = 0 ;
    mem [q + 4 ].cint = 0 ;
    q = p ;
  } while ( ! ( q == -268435455L ) ) ;
  saveptr = saveptr - 2 ;
  packbeginline = - (integer) curlist .mlfield ;
  if ( curlist .modefield == -1 ) 
  {
    rulesave = eqtb [15779 ].cint ;
    eqtb [15779 ].cint = 0 ;
    p = hpack ( mem [memtop - 8 ].hh .v.RH , savestack [saveptr + 1 ].cint 
    , savestack [saveptr + 0 ].cint ) ;
    eqtb [15779 ].cint = rulesave ;
  } 
  else {
      
    q = mem [mem [memtop - 8 ].hh .v.RH ].hh .v.RH ;
    do {
	mem [q + 3 ].cint = mem [q + 1 ].cint ;
      mem [q + 1 ].cint = 0 ;
      q = mem [mem [q ].hh .v.RH ].hh .v.RH ;
    } while ( ! ( q == -268435455L ) ) ;
    p = vpackage ( mem [memtop - 8 ].hh .v.RH , savestack [saveptr + 1 ]
    .cint , savestack [saveptr + 0 ].cint , 1073741823L ) ;
    q = mem [mem [memtop - 8 ].hh .v.RH ].hh .v.RH ;
    do {
	mem [q + 1 ].cint = mem [q + 3 ].cint ;
      mem [q + 3 ].cint = 0 ;
      q = mem [mem [q ].hh .v.RH ].hh .v.RH ;
    } while ( ! ( q == -268435455L ) ) ;
  } 
  packbeginline = 0 ;
  q = mem [curlist .headfield ].hh .v.RH ;
  s = curlist .headfield ;
  while ( q != -268435455L ) {
      
    if ( ! ( q >= himemmin ) ) 
    if ( mem [q ].hh.b0 == 13 ) 
    {
      if ( curlist .modefield == -1 ) 
      {
	mem [q ].hh.b0 = 0 ;
	mem [q + 1 ].cint = mem [p + 1 ].cint ;
	if ( nest [nestptr - 1 ].modefield == 203 ) 
	mem [q ].hh.b1 = 2 ;
      } 
      else {
	  
	mem [q ].hh.b0 = 1 ;
	mem [q + 3 ].cint = mem [p + 3 ].cint ;
      } 
      mem [q + 5 ].hh.b1 = mem [p + 5 ].hh.b1 ;
      mem [q + 5 ].hh.b0 = mem [p + 5 ].hh.b0 ;
      mem [q + 6 ].gr = mem [p + 6 ].gr ;
      mem [q + 4 ].cint = o ;
      r = mem [mem [q + 5 ].hh .v.RH ].hh .v.RH ;
      s = mem [mem [p + 5 ].hh .v.RH ].hh .v.RH ;
      do {
	  n = mem [r ].hh.b1 ;
	t = mem [s + 1 ].cint ;
	w = t ;
	u = memtop - 4 ;
	mem [r ].hh.b1 = 0 ;
	while ( n > 0 ) {
	    
	  decr ( n ) ;
	  s = mem [s ].hh .v.RH ;
	  v = mem [s + 1 ].hh .v.LH ;
	  mem [u ].hh .v.RH = newglue ( v ) ;
	  u = mem [u ].hh .v.RH ;
	  mem [u ].hh.b1 = 12 ;
	  t = t + mem [v + 1 ].cint ;
	  if ( mem [p + 5 ].hh.b0 == 1 ) 
	  {
	    if ( mem [v ].hh.b0 == mem [p + 5 ].hh.b1 ) 
	    t = t + round ( mem [p + 6 ].gr * mem [v + 2 ].cint ) ;
	  } 
	  else if ( mem [p + 5 ].hh.b0 == 2 ) 
	  {
	    if ( mem [v ].hh.b1 == mem [p + 5 ].hh.b1 ) 
	    t = t - round ( mem [p + 6 ].gr * mem [v + 3 ].cint ) ;
	  } 
	  s = mem [s ].hh .v.RH ;
	  mem [u ].hh .v.RH = newnullbox () ;
	  u = mem [u ].hh .v.RH ;
	  t = t + mem [s + 1 ].cint ;
	  if ( curlist .modefield == -1 ) 
	  mem [u + 1 ].cint = mem [s + 1 ].cint ;
	  else {
	      
	    mem [u ].hh.b0 = 1 ;
	    mem [u + 3 ].cint = mem [s + 1 ].cint ;
	  } 
	} 
	if ( curlist .modefield == -1 ) 
	{
	  mem [r + 3 ].cint = mem [q + 3 ].cint ;
	  mem [r + 2 ].cint = mem [q + 2 ].cint ;
	  if ( t == mem [r + 1 ].cint ) 
	  {
	    mem [r + 5 ].hh.b0 = 0 ;
	    mem [r + 5 ].hh.b1 = 0 ;
	    mem [r + 6 ].gr = 0.0 ;
	  } 
	  else if ( t > mem [r + 1 ].cint ) 
	  {
	    mem [r + 5 ].hh.b0 = 1 ;
	    if ( mem [r + 6 ].cint == 0 ) 
	    mem [r + 6 ].gr = 0.0 ;
	    else mem [r + 6 ].gr = ( t - mem [r + 1 ].cint ) / ((double) 
	    mem [r + 6 ].cint ) ;
	  } 
	  else {
	      
	    mem [r + 5 ].hh.b1 = mem [r + 5 ].hh.b0 ;
	    mem [r + 5 ].hh.b0 = 2 ;
	    if ( mem [r + 4 ].cint == 0 ) 
	    mem [r + 6 ].gr = 0.0 ;
	    else if ( ( mem [r + 5 ].hh.b1 == 0 ) && ( mem [r + 1 ].cint - 
	    t > mem [r + 4 ].cint ) ) 
	    mem [r + 6 ].gr = 1.0 ;
	    else mem [r + 6 ].gr = ( mem [r + 1 ].cint - t ) / ((double) 
	    mem [r + 4 ].cint ) ;
	  } 
	  mem [r + 1 ].cint = w ;
	  mem [r ].hh.b0 = 0 ;
	} 
	else {
	    
	  mem [r + 1 ].cint = mem [q + 1 ].cint ;
	  if ( t == mem [r + 3 ].cint ) 
	  {
	    mem [r + 5 ].hh.b0 = 0 ;
	    mem [r + 5 ].hh.b1 = 0 ;
	    mem [r + 6 ].gr = 0.0 ;
	  } 
	  else if ( t > mem [r + 3 ].cint ) 
	  {
	    mem [r + 5 ].hh.b0 = 1 ;
	    if ( mem [r + 6 ].cint == 0 ) 
	    mem [r + 6 ].gr = 0.0 ;
	    else mem [r + 6 ].gr = ( t - mem [r + 3 ].cint ) / ((double) 
	    mem [r + 6 ].cint ) ;
	  } 
	  else {
	      
	    mem [r + 5 ].hh.b1 = mem [r + 5 ].hh.b0 ;
	    mem [r + 5 ].hh.b0 = 2 ;
	    if ( mem [r + 4 ].cint == 0 ) 
	    mem [r + 6 ].gr = 0.0 ;
	    else if ( ( mem [r + 5 ].hh.b1 == 0 ) && ( mem [r + 3 ].cint - 
	    t > mem [r + 4 ].cint ) ) 
	    mem [r + 6 ].gr = 1.0 ;
	    else mem [r + 6 ].gr = ( mem [r + 3 ].cint - t ) / ((double) 
	    mem [r + 4 ].cint ) ;
	  } 
	  mem [r + 3 ].cint = w ;
	  mem [r ].hh.b0 = 1 ;
	} 
	mem [r + 4 ].cint = 0 ;
	if ( u != memtop - 4 ) 
	{
	  mem [u ].hh .v.RH = mem [r ].hh .v.RH ;
	  mem [r ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
	  r = u ;
	} 
	r = mem [mem [r ].hh .v.RH ].hh .v.RH ;
	s = mem [mem [s ].hh .v.RH ].hh .v.RH ;
      } while ( ! ( r == -268435455L ) ) ;
    } 
    else if ( mem [q ].hh.b0 == 2 ) 
    {
      if ( ( mem [q + 1 ].cint == -1073741824L ) ) 
      mem [q + 1 ].cint = mem [p + 1 ].cint ;
      if ( ( mem [q + 3 ].cint == -1073741824L ) ) 
      mem [q + 3 ].cint = mem [p + 3 ].cint ;
      if ( ( mem [q + 2 ].cint == -1073741824L ) ) 
      mem [q + 2 ].cint = mem [p + 2 ].cint ;
      if ( o != 0 ) 
      {
	r = mem [q ].hh .v.RH ;
	mem [q ].hh .v.RH = -268435455L ;
	q = hpack ( q , 0 , 1 ) ;
	mem [q + 4 ].cint = o ;
	mem [q ].hh .v.RH = r ;
	mem [s ].hh .v.RH = q ;
      } 
    } 
    s = q ;
    q = mem [q ].hh .v.RH ;
  } 
  flushnodelist ( p ) ;
  popalignment () ;
  auxsave = curlist .auxfield ;
  p = mem [curlist .headfield ].hh .v.RH ;
  q = curlist .tailfield ;
  popnest () ;
  if ( curlist .modefield == 203 ) 
  {
    doassignments () ;
    if ( curcmd != 3 ) 
    {
      {
	if ( interaction == 3 ) 
	;
	if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) 
	) 
	{
	  printnl ( 263 ) ;
	  print ( fullsourcefilenamestack [inopen ]) ;
	  print ( 58 ) ;
	  printint ( line ) ;
	  print ( 264 ) ;
	  print ( 1411 ) ;
	} 
	else {
	    
	  printnl ( 265 ) ;
	  print ( 1411 ) ;
	} 
      } 
      {
	helpptr = 2 ;
	helpline [1 ]= 1132 ;
	helpline [0 ]= 1133 ;
      } 
      backerror () ;
    } 
    else {
	
      getxtoken () ;
      if ( curcmd != 3 ) 
      {
	{
	  if ( interaction == 3 ) 
	  ;
	  if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) 
	  ) ) 
	  {
	    printnl ( 263 ) ;
	    print ( fullsourcefilenamestack [inopen ]) ;
	    print ( 58 ) ;
	    printint ( line ) ;
	    print ( 264 ) ;
	    print ( 1407 ) ;
	  } 
	  else {
	      
	    printnl ( 265 ) ;
	    print ( 1407 ) ;
	  } 
	} 
	{
	  helpptr = 2 ;
	  helpline [1 ]= 1408 ;
	  helpline [0 ]= 1409 ;
	} 
	backerror () ;
      } 
    } 
    flushnodelist ( curlist .eTeXauxfield ) ;
    popnest () ;
    {
      mem [curlist .tailfield ].hh .v.RH = newpenalty ( eqtb [15182 ].cint 
      ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    {
      mem [curlist .tailfield ].hh .v.RH = newparamglue ( 3 ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    mem [curlist .tailfield ].hh .v.RH = p ;
    if ( p != -268435455L ) 
    curlist .tailfield = q ;
    {
      mem [curlist .tailfield ].hh .v.RH = newpenalty ( eqtb [15183 ].cint 
      ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    {
      mem [curlist .tailfield ].hh .v.RH = newparamglue ( 4 ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    curlist .auxfield .cint = auxsave .cint ;
    resumeafterdisplay () ;
  } 
  else {
      
    curlist .auxfield = auxsave ;
    mem [curlist .tailfield ].hh .v.RH = p ;
    if ( p != -268435455L ) 
    curlist .tailfield = q ;
    if ( curlist .modefield == 1 ) 
    buildpage () ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
alignpeek ( void ) 
#else
alignpeek ( ) 
#endif
{
  /* 20 */ alignpeek_regmem 
  lab20: alignstate = 1000000L ;
  do {
      getxorprotected () ;
  } while ( ! ( curcmd != 10 ) ) ;
  if ( curcmd == 34 ) 
  {
    scanleftbrace () ;
    newsavelevel ( 7 ) ;
    if ( curlist .modefield == -1 ) 
    normalparagraph () ;
  } 
  else if ( curcmd == 2 ) 
  finalign () ;
  else if ( ( curcmd == 5 ) && ( curchr == 258 ) ) 
  goto lab20 ;
  else {
      
    initrow () ;
    initcol () ;
  } 
} 
halfword 
#ifdef HAVE_PROTOTYPES
zfiniteshrink ( halfword p ) 
#else
zfiniteshrink ( p ) 
  halfword p ;
#endif
{
  register halfword Result; finiteshrink_regmem 
  halfword q  ;
  if ( noshrinkerroryet ) 
  {
    noshrinkerroryet = false ;
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 1154 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 1154 ) ;
      } 
    } 
    {
      helpptr = 5 ;
      helpline [4 ]= 1155 ;
      helpline [3 ]= 1156 ;
      helpline [2 ]= 1157 ;
      helpline [1 ]= 1158 ;
      helpline [0 ]= 1159 ;
    } 
    error () ;
  } 
  q = newspec ( p ) ;
  mem [q ].hh.b1 = 0 ;
  deleteglueref ( p ) ;
  Result = q ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zprevrightmost ( halfword s , halfword e ) 
#else
zprevrightmost ( s , e ) 
  halfword s ;
  halfword e ;
#endif
{
  register halfword Result; prevrightmost_regmem 
  halfword p  ;
  Result = -268435455L ;
  p = s ;
  if ( p == -268435455L ) 
  return Result ;
  while ( mem [p ].hh .v.RH != e ) {
      
    p = mem [p ].hh .v.RH ;
    if ( p == -268435455L ) 
    return Result ;
  } 
  Result = p ;
  return Result ;
} 
scaled 
#ifdef HAVE_PROTOTYPES
ztotalpw ( halfword q , halfword p ) 
#else
ztotalpw ( q , p ) 
  halfword q ;
  halfword p ;
#endif
{
  /* 21 */ register scaled Result; totalpw_regmem 
  halfword l, r, s  ;
  integer n  ;
  if ( mem [q + 1 ].hh .v.RH == -268435455L ) 
  l = firstp ;
  else l = mem [mem [q + 1 ].hh .v.RH + 1 ].hh .v.RH ;
  r = prevrightmost ( prevp , p ) ;
  if ( r != -268435455L ) 
  {
    if ( ( mem [r ].hh.b0 == 7 ) && ( mem [p ].hh.b0 == 7 ) && ( mem [p + 
    1 ].hh .v.LH == -268435455L ) ) 
    {
      if ( r == prevp ) 
      {
	r = prevrightmost ( l , p ) ;
      } 
      else r = prevrightmost ( prevp , p ) ;
    } 
    else if ( ( p != -268435455L ) && ( mem [p ].hh.b0 == 7 ) && ( mem [p + 
    1 ].hh .v.LH != -268435455L ) ) 
    {
      r = mem [p + 1 ].hh .v.LH ;
      while ( mem [r ].hh .v.RH != -268435455L ) r = mem [r ].hh .v.RH ;
    } 
  } 
  lab21: while ( ( l != -268435455L ) && ! ( ( l >= himemmin ) || ( mem [l ]
  .hh.b0 < 9 ) || ( ( mem [l ].hh.b0 == 11 ) && ( mem [l ].hh.b1 != 1 ) ) 
  || ( mem [l ].hh.b0 == 40 ) ) ) l = mem [l ].hh .v.RH ;
  if ( ( l != -268435455L ) && ( mem [l ].hh.b0 == 7 ) ) 
  {
    if ( mem [l + 1 ].hh .v.RH != -268435455L ) 
    l = mem [l + 1 ].hh .v.RH ;
    else {
	
      n = mem [l ].hh.b1 ;
      l = mem [l ].hh .v.RH ;
      while ( n > 0 ) {
	  
	if ( mem [l ].hh .v.RH != -268435455L ) 
	l = mem [l ].hh .v.RH ;
	decr ( n ) ;
      } 
    } 
    goto lab21 ;
  } 
  Result = charpw ( l , 0 ) + charpw ( r , 1 ) ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
ztrybreak ( integer pi , smallnumber breaktype ) 
#else
ztrybreak ( pi , breaktype ) 
  integer pi ;
  smallnumber breaktype ;
#endif
{
  /* 10 30 31 22 60 40 45 */ trybreak_regmem 
  halfword r  ;
  halfword prevr  ;
  halfword oldl  ;
  boolean nobreakyet  ;
  boolean cantryprevbreak  ;
  scaled marginkernstretch  ;
  scaled marginkernshrink  ;
  halfword lp, rp, cp  ;
  halfword prevprevr  ;
  halfword s  ;
  halfword q  ;
  halfword v  ;
  integer t  ;
  internalfontnumber f  ;
  halfword l  ;
  boolean noderstaysactive  ;
  scaled linewidth  ;
  char fitclass  ;
  halfword b  ;
  integer d  ;
  boolean artificialdemerits  ;
  halfword savelink  ;
  scaled shortfall  ;
  scaled g  ;
  if ( tryprevbreak && ( pi <= 10000 ) ) 
  pi = -10000 ;
  cantryprevbreak = false ;
  if ( abs ( pi ) >= 10000 ) 
  if ( pi > 0 ) 
  goto lab10 ;
  else pi = -10000 ;
  nobreakyet = true ;
  prevr = memtop - 7 ;
  oldl = 0 ;
  curactivewidth [1 ]= activewidth [1 ];
  curactivewidth [2 ]= activewidth [2 ];
  curactivewidth [3 ]= activewidth [3 ];
  curactivewidth [4 ]= activewidth [4 ];
  curactivewidth [5 ]= activewidth [5 ];
  curactivewidth [6 ]= activewidth [6 ];
  if ( eqtb [15227 ].cint > 1 ) 
  {
    curactivewidth [7 ]= activewidth [7 ];
    curactivewidth [8 ]= activewidth [8 ];
  } 
  while ( true ) {
      
    lab22: r = mem [prevr ].hh .v.RH ;
    if ( mem [r ].hh.b0 == 2 ) 
    {
      curactivewidth [1 ]= curactivewidth [1 ]+ mem [r + 1 ].cint ;
      curactivewidth [2 ]= curactivewidth [2 ]+ mem [r + 2 ].cint ;
      curactivewidth [3 ]= curactivewidth [3 ]+ mem [r + 3 ].cint ;
      curactivewidth [4 ]= curactivewidth [4 ]+ mem [r + 4 ].cint ;
      curactivewidth [5 ]= curactivewidth [5 ]+ mem [r + 5 ].cint ;
      curactivewidth [6 ]= curactivewidth [6 ]+ mem [r + 6 ].cint ;
      if ( eqtb [15227 ].cint > 1 ) 
      {
	curactivewidth [7 ]= curactivewidth [7 ]+ mem [r + 7 ].cint ;
	curactivewidth [8 ]= curactivewidth [8 ]+ mem [r + 8 ].cint ;
      } 
      prevprevr = prevr ;
      prevr = r ;
      goto lab22 ;
    } 
    {
      l = mem [r + 1 ].hh .v.LH ;
      if ( l > oldl ) 
      {
	if ( ( minimumdemerits < 1073741823L ) && ( ( oldl != easyline ) || ( 
	r == memtop - 7 ) ) ) 
	{
	  if ( nobreakyet ) 
	  {
	    nobreakyet = false ;
	    breakwidth [1 ]= background [1 ];
	    breakwidth [2 ]= background [2 ];
	    breakwidth [3 ]= background [3 ];
	    breakwidth [4 ]= background [4 ];
	    breakwidth [5 ]= background [5 ];
	    breakwidth [6 ]= background [6 ];
	    if ( eqtb [15227 ].cint > 1 ) 
	    {
	      breakwidth [7 ]= background [7 ];
	      breakwidth [8 ]= background [8 ];
	    } 
	    s = curp ;
	    if ( breaktype > 0 ) 
	    if ( curp != -268435455L ) 
	    {
	      t = mem [curp ].hh.b1 ;
	      v = curp ;
	      s = mem [curp + 1 ].hh .v.RH ;
	      while ( t > 0 ) {
		  
		decr ( t ) ;
		v = mem [v ].hh .v.RH ;
		if ( ( v >= himemmin ) ) 
		{
		  f = mem [v ].hh.b0 ;
		  breakwidth [1 ]= breakwidth [1 ]- fontinfo [widthbase [
		  f ]+ fontinfo [charbase [f ]+ effectivechar ( true , f , 
		  mem [v ].hh.b1 ) ].qqqq .b0 ].cint ;
		  if ( ( eqtb [15227 ].cint > 1 ) && checkexpandpars ( f ) ) 
		  {
		    prevcharp = v ;
		    breakwidth [7 ]= breakwidth [7 ]- charstretch ( f , 
		    mem [v ].hh.b1 ) ;
		    breakwidth [8 ]= breakwidth [8 ]- charshrink ( f , mem 
		    [v ].hh.b1 ) ;
		  } 
		} 
		else switch ( mem [v ].hh.b0 ) 
		{case 6 : 
		  {
		    f = mem [v + 1 ].hh.b0 ;
		    breakwidth [1 ]= breakwidth [1 ]- fontinfo [widthbase 
		    [f ]+ fontinfo [charbase [f ]+ effectivechar ( true , 
		    f , mem [v + 1 ].hh.b1 ) ].qqqq .b0 ].cint ;
		    if ( ( eqtb [15227 ].cint > 1 ) && checkexpandpars ( f ) 
		    ) 
		    {
		      prevcharp = v ;
		      breakwidth [7 ]= breakwidth [7 ]- charstretch ( f , 
		      mem [v + 1 ].hh.b1 ) ;
		      breakwidth [8 ]= breakwidth [8 ]- charshrink ( f , 
		      mem [v + 1 ].hh.b1 ) ;
		    } 
		  } 
		  break ;
		case 0 : 
		case 1 : 
		case 2 : 
		case 11 : 
		  {
		    breakwidth [1 ]= breakwidth [1 ]- mem [v + 1 ].cint 
		    ;
		    if ( ( mem [v ].hh.b0 == 11 ) && ( eqtb [15227 ].cint 
		    > 1 ) && ( mem [v ].hh.b1 == 0 ) ) 
		    {
		      breakwidth [7 ]= breakwidth [7 ]- kernstretch ( v ) 
		      ;
		      breakwidth [8 ]= breakwidth [8 ]- kernshrink ( v ) ;
		    } 
		  } 
		  break ;
		  default: 
		  confusion ( 1160 ) ;
		  break ;
		} 
	      } 
	      while ( s != -268435455L ) {
		  
		if ( ( s >= himemmin ) ) 
		{
		  f = mem [s ].hh.b0 ;
		  breakwidth [1 ]= breakwidth [1 ]+ fontinfo [widthbase [
		  f ]+ fontinfo [charbase [f ]+ effectivechar ( true , f , 
		  mem [s ].hh.b1 ) ].qqqq .b0 ].cint ;
		  if ( ( eqtb [15227 ].cint > 1 ) && checkexpandpars ( f ) ) 
		  {
		    prevcharp = s ;
		    breakwidth [7 ]= breakwidth [7 ]+ charstretch ( f , 
		    mem [s ].hh.b1 ) ;
		    breakwidth [8 ]= breakwidth [8 ]+ charshrink ( f , mem 
		    [s ].hh.b1 ) ;
		  } 
		} 
		else switch ( mem [s ].hh.b0 ) 
		{case 6 : 
		  {
		    f = mem [s + 1 ].hh.b0 ;
		    breakwidth [1 ]= breakwidth [1 ]+ fontinfo [widthbase 
		    [f ]+ fontinfo [charbase [f ]+ effectivechar ( true , 
		    f , mem [s + 1 ].hh.b1 ) ].qqqq .b0 ].cint ;
		    if ( ( eqtb [15227 ].cint > 1 ) && checkexpandpars ( f ) 
		    ) 
		    {
		      prevcharp = s ;
		      breakwidth [7 ]= breakwidth [7 ]+ charstretch ( f , 
		      mem [s + 1 ].hh.b1 ) ;
		      breakwidth [8 ]= breakwidth [8 ]+ charshrink ( f , 
		      mem [s + 1 ].hh.b1 ) ;
		    } 
		  } 
		  break ;
		case 0 : 
		case 1 : 
		case 2 : 
		case 11 : 
		  {
		    breakwidth [1 ]= breakwidth [1 ]+ mem [s + 1 ].cint 
		    ;
		    if ( ( mem [s ].hh.b0 == 11 ) && ( eqtb [15227 ].cint 
		    > 1 ) && ( mem [s ].hh.b1 == 0 ) ) 
		    {
		      breakwidth [7 ]= breakwidth [7 ]+ kernstretch ( s ) 
		      ;
		      breakwidth [8 ]= breakwidth [8 ]+ kernshrink ( s ) ;
		    } 
		  } 
		  break ;
		  default: 
		  confusion ( 1161 ) ;
		  break ;
		} 
		s = mem [s ].hh .v.RH ;
	      } 
	      breakwidth [1 ]= breakwidth [1 ]+ discwidth [1 ];
	      if ( eqtb [15227 ].cint > 1 ) 
	      {
		breakwidth [7 ]= breakwidth [7 ]+ discwidth [7 ];
		breakwidth [8 ]= breakwidth [8 ]+ discwidth [8 ];
	      } 
	      if ( mem [curp + 1 ].hh .v.RH == -268435455L ) 
	      s = mem [v ].hh .v.RH ;
	    } 
	    while ( s != -268435455L ) {
		
	      if ( ( s >= himemmin ) ) 
	      goto lab30 ;
	      switch ( mem [s ].hh.b0 ) 
	      {case 10 : 
		{
		  v = mem [s + 1 ].hh .v.LH ;
		  breakwidth [1 ]= breakwidth [1 ]- mem [v + 1 ].cint ;
		  breakwidth [2 + mem [v ].hh.b0 ]= breakwidth [2 + mem [
		  v ].hh.b0 ]- mem [v + 2 ].cint ;
		  breakwidth [6 ]= breakwidth [6 ]- mem [v + 3 ].cint ;
		} 
		break ;
	      case 12 : 
		;
		break ;
	      case 9 : 
		breakwidth [1 ]= breakwidth [1 ]- mem [s + 1 ].cint ;
		break ;
	      case 11 : 
		if ( mem [s ].hh.b1 != 1 ) 
		goto lab30 ;
		else breakwidth [1 ]= breakwidth [1 ]- mem [s + 1 ].cint 
		;
		break ;
		default: 
		goto lab30 ;
		break ;
	      } 
	      s = mem [s ].hh .v.RH ;
	    } 
	    lab30: ;
	  } 
	  if ( mem [prevr ].hh.b0 == 2 ) 
	  {
	    mem [prevr + 1 ].cint = mem [prevr + 1 ].cint - curactivewidth 
	    [1 ]+ breakwidth [1 ];
	    mem [prevr + 2 ].cint = mem [prevr + 2 ].cint - curactivewidth 
	    [2 ]+ breakwidth [2 ];
	    mem [prevr + 3 ].cint = mem [prevr + 3 ].cint - curactivewidth 
	    [3 ]+ breakwidth [3 ];
	    mem [prevr + 4 ].cint = mem [prevr + 4 ].cint - curactivewidth 
	    [4 ]+ breakwidth [4 ];
	    mem [prevr + 5 ].cint = mem [prevr + 5 ].cint - curactivewidth 
	    [5 ]+ breakwidth [5 ];
	    mem [prevr + 6 ].cint = mem [prevr + 6 ].cint - curactivewidth 
	    [6 ]+ breakwidth [6 ];
	    if ( eqtb [15227 ].cint > 1 ) 
	    {
	      mem [prevr + 7 ].cint = mem [prevr + 7 ].cint - 
	      curactivewidth [7 ]+ breakwidth [7 ];
	      mem [prevr + 8 ].cint = mem [prevr + 8 ].cint - 
	      curactivewidth [8 ]+ breakwidth [8 ];
	    } 
	  } 
	  else if ( prevr == memtop - 7 ) 
	  {
	    activewidth [1 ]= breakwidth [1 ];
	    activewidth [2 ]= breakwidth [2 ];
	    activewidth [3 ]= breakwidth [3 ];
	    activewidth [4 ]= breakwidth [4 ];
	    activewidth [5 ]= breakwidth [5 ];
	    activewidth [6 ]= breakwidth [6 ];
	    if ( eqtb [15227 ].cint > 1 ) 
	    {
	      activewidth [7 ]= breakwidth [7 ];
	      activewidth [8 ]= breakwidth [8 ];
	    } 
	  } 
	  else {
	      
	    q = getnode ( 9 ) ;
	    mem [q ].hh .v.RH = r ;
	    mem [q ].hh.b0 = 2 ;
	    mem [q ].hh.b1 = 0 ;
	    mem [q + 1 ].cint = breakwidth [1 ]- curactivewidth [1 ];
	    mem [q + 2 ].cint = breakwidth [2 ]- curactivewidth [2 ];
	    mem [q + 3 ].cint = breakwidth [3 ]- curactivewidth [3 ];
	    mem [q + 4 ].cint = breakwidth [4 ]- curactivewidth [4 ];
	    mem [q + 5 ].cint = breakwidth [5 ]- curactivewidth [5 ];
	    mem [q + 6 ].cint = breakwidth [6 ]- curactivewidth [6 ];
	    if ( eqtb [15227 ].cint > 1 ) 
	    {
	      mem [q + 7 ].cint = breakwidth [7 ]- curactivewidth [7 ];
	      mem [q + 8 ].cint = breakwidth [8 ]- curactivewidth [8 ];
	    } 
	    mem [prevr ].hh .v.RH = q ;
	    prevprevr = prevr ;
	    prevr = q ;
	  } 
	  if ( abs ( eqtb [15187 ].cint ) >= 1073741823L - minimumdemerits ) 
	  minimumdemerits = 1073741822L ;
	  else minimumdemerits = minimumdemerits + abs ( eqtb [15187 ].cint 
	  ) ;
	  {register integer for_end; fitclass = 0 ;for_end = 3 ; if ( 
	  fitclass <= for_end) do 
	    {
	      if ( minimaldemerits [fitclass ]<= minimumdemerits ) 
	      {
		q = getnode ( 2 ) ;
		mem [q ].hh .v.RH = passive ;
		passive = q ;
		mem [q + 1 ].hh .v.RH = curp ;
	;
#ifdef STAT
		incr ( passnumber ) ;
		mem [q ].hh .v.LH = passnumber ;
#endif /* STAT */
		mem [q + 1 ].hh .v.LH = bestplace [fitclass ];
		q = getnode ( activenodesize ) ;
		mem [q + 1 ].hh .v.RH = passive ;
		mem [q + 1 ].hh .v.LH = bestplline [fitclass ]+ 1 ;
		mem [q ].hh.b1 = fitclass ;
		mem [q ].hh.b0 = breaktype ;
		mem [q + 2 ].cint = minimaldemerits [fitclass ];
		if ( dolastlinefit ) 
		{
		  mem [q + 3 ].cint = bestplshort [fitclass ];
		  mem [q + 4 ].cint = bestplglue [fitclass ];
		} 
		mem [q ].hh .v.RH = r ;
		mem [prevr ].hh .v.RH = q ;
		prevr = q ;
	;
#ifdef STAT
		if ( eqtb [15203 ].cint > 0 ) 
		{
		  printnl ( 1162 ) ;
		  printint ( mem [passive ].hh .v.LH ) ;
		  print ( 1163 ) ;
		  printint ( mem [q + 1 ].hh .v.LH - 1 ) ;
		  printchar ( 46 ) ;
		  printint ( fitclass ) ;
		  if ( breaktype == 1 ) 
		  printchar ( 45 ) ;
		  print ( 1164 ) ;
		  printint ( mem [q + 2 ].cint ) ;
		  if ( dolastlinefit ) 
		  {
		    print ( 1811 ) ;
		    printscaled ( mem [q + 3 ].cint ) ;
		    if ( curp == -268435455L ) 
		    print ( 1812 ) ;
		    else print ( 1236 ) ;
		    printscaled ( mem [q + 4 ].cint ) ;
		  } 
		  print ( 1165 ) ;
		  if ( mem [passive + 1 ].hh .v.LH == -268435455L ) 
		  printchar ( 48 ) ;
		  else printint ( mem [mem [passive + 1 ].hh .v.LH ].hh 
		  .v.LH ) ;
		} 
#endif /* STAT */
	      } 
	      minimaldemerits [fitclass ]= 1073741823L ;
	    } 
	  while ( fitclass++ < for_end ) ;} 
	  minimumdemerits = 1073741823L ;
	  if ( r != memtop - 7 ) 
	  {
	    q = getnode ( 9 ) ;
	    mem [q ].hh .v.RH = r ;
	    mem [q ].hh.b0 = 2 ;
	    mem [q ].hh.b1 = 0 ;
	    mem [q + 1 ].cint = curactivewidth [1 ]- breakwidth [1 ];
	    mem [q + 2 ].cint = curactivewidth [2 ]- breakwidth [2 ];
	    mem [q + 3 ].cint = curactivewidth [3 ]- breakwidth [3 ];
	    mem [q + 4 ].cint = curactivewidth [4 ]- breakwidth [4 ];
	    mem [q + 5 ].cint = curactivewidth [5 ]- breakwidth [5 ];
	    mem [q + 6 ].cint = curactivewidth [6 ]- breakwidth [6 ];
	    if ( eqtb [15227 ].cint > 1 ) 
	    {
	      mem [q + 7 ].cint = curactivewidth [7 ]- breakwidth [7 ];
	      mem [q + 8 ].cint = curactivewidth [8 ]- breakwidth [8 ];
	    } 
	    mem [prevr ].hh .v.RH = q ;
	    prevprevr = prevr ;
	    prevr = q ;
	  } 
	} 
	if ( r == memtop - 7 ) 
	goto lab10 ;
	if ( l > easyline ) 
	{
	  linewidth = secondwidth ;
	  oldl = 268435454L ;
	} 
	else {
	    
	  oldl = l ;
	  if ( l > lastspecialline ) 
	  linewidth = secondwidth ;
	  else if ( eqtb [13056 ].hh .v.RH == -268435455L ) 
	  linewidth = firstwidth ;
	  else linewidth = mem [eqtb [13056 ].hh .v.RH + 2 * l ].cint ;
	} 
      } 
    } 
    {
      artificialdemerits = false ;
      shortfall = linewidth - curactivewidth [1 ];
      if ( eqtb [15234 ].cint > 1 ) 
      shortfall = shortfall + totalpw ( r , curp ) ;
      if ( ( eqtb [15227 ].cint > 1 ) && ( shortfall != 0 ) ) 
      {
	marginkernstretch = 0 ;
	marginkernshrink = 0 ;
	if ( eqtb [15234 ].cint > 1 ) 
	{
	  lp = lastleftmostchar ;
	  rp = lastrightmostchar ;
	  {
	    cp = avail ;
	    if ( cp == -268435455L ) 
	    cp = getavail () ;
	    else {
		
	      avail = mem [cp ].hh .v.RH ;
	      mem [cp ].hh .v.RH = -268435455L ;
	;
#ifdef STAT
	      incr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	  if ( lp != -268435455L ) 
	  {
	    mem [cp ].hh.b1 = mem [lp ].hh.b1 ;
	    mem [cp ].hh.b0 = mem [lp ].hh.b0 ;
	    dosubstfont ( cp , 1000 ) ;
	    if ( mem [cp ].hh.b0 != mem [lp ].hh.b0 ) 
	    marginkernstretch = marginkernstretch + charpw ( lp , 0 ) - charpw 
	    ( cp , 0 ) ;
	    mem [cp ].hh.b0 = mem [lp ].hh.b0 ;
	    dosubstfont ( cp , -1000 ) ;
	    if ( mem [cp ].hh.b0 != mem [lp ].hh.b0 ) 
	    marginkernshrink = marginkernshrink + charpw ( cp , 0 ) - charpw ( 
	    lp , 0 ) ;
	  } 
	  if ( rp != -268435455L ) 
	  {
	    mem [cp ].hh.b1 = mem [rp ].hh.b1 ;
	    mem [cp ].hh.b0 = mem [rp ].hh.b0 ;
	    dosubstfont ( cp , 1000 ) ;
	    if ( mem [cp ].hh.b0 != mem [rp ].hh.b0 ) 
	    marginkernstretch = marginkernstretch + charpw ( rp , 0 ) - charpw 
	    ( cp , 0 ) ;
	    mem [cp ].hh.b0 = mem [rp ].hh.b0 ;
	    dosubstfont ( cp , -1000 ) ;
	    if ( mem [cp ].hh.b0 != mem [rp ].hh.b0 ) 
	    marginkernshrink = marginkernshrink + charpw ( cp , 0 ) - charpw ( 
	    rp , 0 ) ;
	  } 
	  {
	    mem [cp ].hh .v.RH = avail ;
	    avail = cp ;
	;
#ifdef STAT
	    decr ( dynused ) ;
#endif /* STAT */
	  } 
	} 
	if ( ( shortfall > 0 ) && ( ( curactivewidth [7 ]+ marginkernstretch 
	) > 0 ) ) 
	{
	  if ( ( curactivewidth [7 ]+ marginkernstretch ) > shortfall ) 
	  shortfall = ( ( curactivewidth [7 ]+ marginkernstretch ) / ( 
	  maxstretchratio / curfontstep ) ) / 2 ;
	  else shortfall = shortfall - ( curactivewidth [7 ]+ 
	  marginkernstretch ) ;
	} 
	else if ( ( shortfall < 0 ) && ( ( curactivewidth [8 ]+ 
	marginkernshrink ) > 0 ) ) 
	{
	  if ( ( curactivewidth [8 ]+ marginkernshrink ) > - (integer) 
	  shortfall ) 
	  shortfall = - (integer) ( ( curactivewidth [8 ]+ marginkernshrink 
	  ) / ( maxshrinkratio / curfontstep ) ) / 2 ;
	  else shortfall = shortfall + ( curactivewidth [8 ]+ 
	  marginkernshrink ) ;
	} 
      } 
      if ( shortfall > 0 ) 
      if ( ( curactivewidth [3 ]!= 0 ) || ( curactivewidth [4 ]!= 0 ) || ( 
      curactivewidth [5 ]!= 0 ) ) 
      {
	if ( dolastlinefit ) 
	{
	  if ( curp == -268435455L ) 
	  {
	    if ( ( mem [r + 3 ].cint == 0 ) || ( mem [r + 4 ].cint <= 0 ) 
	    ) 
	    goto lab45 ;
	    if ( ( curactivewidth [3 ]!= fillwidth [0 ]) || ( 
	    curactivewidth [4 ]!= fillwidth [1 ]) || ( curactivewidth [5 
	    ]!= fillwidth [2 ]) ) 
	    goto lab45 ;
	    if ( mem [r + 3 ].cint > 0 ) 
	    g = curactivewidth [2 ];
	    else g = curactivewidth [6 ];
	    if ( g <= 0 ) 
	    goto lab45 ;
	    aritherror = false ;
	    g = fract ( g , mem [r + 3 ].cint , mem [r + 4 ].cint , 
	    1073741823L ) ;
	    if ( eqtb [15247 ].cint < 1000 ) 
	    g = fract ( g , eqtb [15247 ].cint , 1000 , 1073741823L ) ;
	    if ( aritherror ) 
	    if ( mem [r + 3 ].cint > 0 ) 
	    g = 1073741823L ;
	    else g = -1073741823L ;
	    if ( g > 0 ) 
	    {
	      if ( g > shortfall ) 
	      g = shortfall ;
	      if ( g > 7230584L ) 
	      if ( curactivewidth [2 ]< 1663497L ) 
	      {
		b = 10000 ;
		fitclass = 0 ;
		goto lab40 ;
	      } 
	      b = badness ( g , curactivewidth [2 ]) ;
	      if ( b > 12 ) 
	      if ( b > 99 ) 
	      fitclass = 0 ;
	      else fitclass = 1 ;
	      else fitclass = 2 ;
	      goto lab40 ;
	    } 
	    else if ( g < 0 ) 
	    {
	      if ( - (integer) g > curactivewidth [6 ]) 
	      g = - (integer) curactivewidth [6 ];
	      b = badness ( - (integer) g , curactivewidth [6 ]) ;
	      if ( b > 12 ) 
	      fitclass = 3 ;
	      else fitclass = 2 ;
	      goto lab40 ;
	    } 
	    lab45: ;
	  } 
	  shortfall = 0 ;
	} 
	b = 0 ;
	fitclass = 2 ;
      } 
      else {
	  
	if ( shortfall > 7230584L ) 
	if ( curactivewidth [2 ]< 1663497L ) 
	{
	  b = 10000 ;
	  fitclass = 0 ;
	  goto lab31 ;
	} 
	b = badness ( shortfall , curactivewidth [2 ]) ;
	if ( b > 12 ) 
	if ( b > 99 ) 
	fitclass = 0 ;
	else fitclass = 1 ;
	else fitclass = 2 ;
	lab31: ;
      } 
      else {
	  
	if ( - (integer) shortfall > curactivewidth [6 ]) 
	b = 10001 ;
	else b = badness ( - (integer) shortfall , curactivewidth [6 ]) ;
	if ( b > 12 ) 
	fitclass = 3 ;
	else fitclass = 2 ;
      } 
      if ( dolastlinefit ) 
      {
	if ( curp == -268435455L ) 
	shortfall = 0 ;
	if ( shortfall > 0 ) 
	g = curactivewidth [2 ];
	else if ( shortfall < 0 ) 
	g = curactivewidth [6 ];
	else g = 0 ;
      } 
      lab40: if ( ( b > 10000 ) || ( pi == -10000 ) ) 
      {
	if ( finalpass && ( minimumdemerits == 1073741823L ) && ( mem [r ]
	.hh .v.RH == memtop - 7 ) && ( prevr == memtop - 7 ) ) 
	{
	  if ( ( eqtb [15235 ].cint > 0 ) && ( b > 10000 ) && ( prevlegal != 
	  -268435455L ) && ( prevlegal != curp ) ) 
	  {
	    if ( tryprevbreak ) 
	    confusion ( 1166 ) ;
	    rejectedcurp = curp ;
	    cantryprevbreak = true ;
	    goto lab10 ;
	  } 
	  artificialdemerits = true ;
	} 
	else if ( b > threshold ) 
	goto lab60 ;
	noderstaysactive = false ;
      } 
      else {
	  
	prevr = r ;
	if ( b > threshold ) 
	goto lab22 ;
	noderstaysactive = true ;
      } 
      if ( artificialdemerits ) 
      d = 0 ;
      else {
	  
	d = eqtb [15173 ].cint + b ;
	if ( abs ( d ) >= 10000 ) 
	d = 100000000L ;
	else d = d * d ;
	if ( pi != 0 ) 
	if ( pi > 0 ) 
	d = d + pi * pi ;
	else if ( pi > -10000 ) 
	d = d - pi * pi ;
	if ( ( breaktype == 1 ) && ( mem [r ].hh.b0 == 1 ) ) 
	if ( curp != -268435455L ) 
	d = d + eqtb [15185 ].cint ;
	else d = d + eqtb [15186 ].cint ;
	if ( abs ( intcast ( fitclass ) - intcast ( mem [r ].hh.b1 ) ) > 1 ) 
	d = d + eqtb [15187 ].cint ;
      } 
	;
#ifdef STAT
      if ( eqtb [15203 ].cint > 0 ) 
      {
	if ( printednode != curp ) 
	{
	  printnl ( 263 ) ;
	  if ( curp == -268435455L ) 
	  shortdisplay ( mem [printednode ].hh .v.RH ) ;
	  else {
	      
	    savelink = mem [curp ].hh .v.RH ;
	    mem [curp ].hh .v.RH = -268435455L ;
	    printnl ( 263 ) ;
	    shortdisplay ( mem [printednode ].hh .v.RH ) ;
	    mem [curp ].hh .v.RH = savelink ;
	  } 
	  printednode = curp ;
	} 
	printnl ( 64 ) ;
	if ( curp == -268435455L ) 
	printesc ( 634 ) ;
	else if ( mem [curp ].hh.b0 != 10 ) 
	{
	  if ( mem [curp ].hh.b0 == 12 ) 
	  printesc ( 562 ) ;
	  else if ( mem [curp ].hh.b0 == 7 ) 
	  printesc ( 352 ) ;
	  else if ( mem [curp ].hh.b0 == 11 ) 
	  printesc ( 318 ) ;
	  else printesc ( 346 ) ;
	} 
	print ( 1167 ) ;
	if ( mem [r + 1 ].hh .v.RH == -268435455L ) 
	printchar ( 48 ) ;
	else printint ( mem [mem [r + 1 ].hh .v.RH ].hh .v.LH ) ;
	print ( 1168 ) ;
	if ( b > 10000 ) 
	printchar ( 42 ) ;
	else printint ( b ) ;
	print ( 1169 ) ;
	printint ( pi ) ;
	print ( 1170 ) ;
	if ( artificialdemerits ) 
	printchar ( 42 ) ;
	else printint ( d ) ;
      } 
#endif /* STAT */
      d = d + mem [r + 2 ].cint ;
      if ( d <= minimaldemerits [fitclass ]) 
      {
	minimaldemerits [fitclass ]= d ;
	bestplace [fitclass ]= mem [r + 1 ].hh .v.RH ;
	bestplline [fitclass ]= l ;
	if ( dolastlinefit ) 
	{
	  bestplshort [fitclass ]= shortfall ;
	  bestplglue [fitclass ]= g ;
	} 
	if ( d < minimumdemerits ) 
	minimumdemerits = d ;
      } 
      if ( noderstaysactive ) 
      goto lab22 ;
      lab60: mem [prevr ].hh .v.RH = mem [r ].hh .v.RH ;
      freenode ( r , activenodesize ) ;
      if ( prevr == memtop - 7 ) 
      {
	r = mem [memtop - 7 ].hh .v.RH ;
	if ( mem [r ].hh.b0 == 2 ) 
	{
	  activewidth [1 ]= activewidth [1 ]+ mem [r + 1 ].cint ;
	  activewidth [2 ]= activewidth [2 ]+ mem [r + 2 ].cint ;
	  activewidth [3 ]= activewidth [3 ]+ mem [r + 3 ].cint ;
	  activewidth [4 ]= activewidth [4 ]+ mem [r + 4 ].cint ;
	  activewidth [5 ]= activewidth [5 ]+ mem [r + 5 ].cint ;
	  activewidth [6 ]= activewidth [6 ]+ mem [r + 6 ].cint ;
	  if ( eqtb [15227 ].cint > 1 ) 
	  {
	    activewidth [7 ]= activewidth [7 ]+ mem [r + 7 ].cint ;
	    activewidth [8 ]= activewidth [8 ]+ mem [r + 8 ].cint ;
	  } 
	  curactivewidth [1 ]= activewidth [1 ];
	  curactivewidth [2 ]= activewidth [2 ];
	  curactivewidth [3 ]= activewidth [3 ];
	  curactivewidth [4 ]= activewidth [4 ];
	  curactivewidth [5 ]= activewidth [5 ];
	  curactivewidth [6 ]= activewidth [6 ];
	  if ( eqtb [15227 ].cint > 1 ) 
	  {
	    curactivewidth [7 ]= activewidth [7 ];
	    curactivewidth [8 ]= activewidth [8 ];
	  } 
	  mem [memtop - 7 ].hh .v.RH = mem [r ].hh .v.RH ;
	  freenode ( r , 9 ) ;
	} 
      } 
      else if ( mem [prevr ].hh.b0 == 2 ) 
      {
	r = mem [prevr ].hh .v.RH ;
	if ( r == memtop - 7 ) 
	{
	  curactivewidth [1 ]= curactivewidth [1 ]- mem [prevr + 1 ]
	  .cint ;
	  curactivewidth [2 ]= curactivewidth [2 ]- mem [prevr + 2 ]
	  .cint ;
	  curactivewidth [3 ]= curactivewidth [3 ]- mem [prevr + 3 ]
	  .cint ;
	  curactivewidth [4 ]= curactivewidth [4 ]- mem [prevr + 4 ]
	  .cint ;
	  curactivewidth [5 ]= curactivewidth [5 ]- mem [prevr + 5 ]
	  .cint ;
	  curactivewidth [6 ]= curactivewidth [6 ]- mem [prevr + 6 ]
	  .cint ;
	  if ( eqtb [15227 ].cint > 1 ) 
	  {
	    curactivewidth [7 ]= curactivewidth [7 ]- mem [prevr + 7 ]
	    .cint ;
	    curactivewidth [8 ]= curactivewidth [8 ]- mem [prevr + 8 ]
	    .cint ;
	  } 
	  mem [prevprevr ].hh .v.RH = memtop - 7 ;
	  freenode ( prevr , 9 ) ;
	  prevr = prevprevr ;
	} 
	else if ( mem [r ].hh.b0 == 2 ) 
	{
	  curactivewidth [1 ]= curactivewidth [1 ]+ mem [r + 1 ].cint ;
	  curactivewidth [2 ]= curactivewidth [2 ]+ mem [r + 2 ].cint ;
	  curactivewidth [3 ]= curactivewidth [3 ]+ mem [r + 3 ].cint ;
	  curactivewidth [4 ]= curactivewidth [4 ]+ mem [r + 4 ].cint ;
	  curactivewidth [5 ]= curactivewidth [5 ]+ mem [r + 5 ].cint ;
	  curactivewidth [6 ]= curactivewidth [6 ]+ mem [r + 6 ].cint ;
	  if ( eqtb [15227 ].cint > 1 ) 
	  {
	    curactivewidth [7 ]= curactivewidth [7 ]+ mem [r + 7 ].cint 
	    ;
	    curactivewidth [8 ]= curactivewidth [8 ]+ mem [r + 8 ].cint 
	    ;
	  } 
	  mem [prevr + 1 ].cint = mem [prevr + 1 ].cint + mem [r + 1 ]
	  .cint ;
	  mem [prevr + 2 ].cint = mem [prevr + 2 ].cint + mem [r + 2 ]
	  .cint ;
	  mem [prevr + 3 ].cint = mem [prevr + 3 ].cint + mem [r + 3 ]
	  .cint ;
	  mem [prevr + 4 ].cint = mem [prevr + 4 ].cint + mem [r + 4 ]
	  .cint ;
	  mem [prevr + 5 ].cint = mem [prevr + 5 ].cint + mem [r + 5 ]
	  .cint ;
	  mem [prevr + 6 ].cint = mem [prevr + 6 ].cint + mem [r + 6 ]
	  .cint ;
	  if ( eqtb [15227 ].cint > 1 ) 
	  {
	    mem [prevr + 7 ].cint = mem [prevr + 7 ].cint + mem [r + 7 ]
	    .cint ;
	    mem [prevr + 8 ].cint = mem [prevr + 8 ].cint + mem [r + 8 ]
	    .cint ;
	  } 
	  mem [prevr ].hh .v.RH = mem [r ].hh .v.RH ;
	  freenode ( r , 9 ) ;
	} 
      } 
    } 
  } 
  lab10: if ( cantryprevbreak ) 
  tryprevbreak = true ;
  else {
      
    ;
	;
#ifdef STAT
    if ( curp == printednode ) 
    if ( curp != -268435455L ) 
    if ( mem [curp ].hh.b0 == 7 ) 
    {
      t = mem [curp ].hh.b1 ;
      while ( t > 0 ) {
	  
	decr ( t ) ;
	printednode = mem [printednode ].hh .v.RH ;
      } 
    } 
#endif /* STAT */
    if ( tryprevbreak ) 
    {
      prevlegal = -268435455L ;
      tryprevbreak = false ;
    } 
    else {
	
      if ( pi < 10000 ) 
      {
	prevlegal = curp ;
	prevprevlegal = prevp ;
	prevautobreaking = autobreaking ;
	prevactivewidth [1 ]= activewidth [1 ];
	prevactivewidth [2 ]= activewidth [2 ];
	prevactivewidth [3 ]= activewidth [3 ];
	prevactivewidth [4 ]= activewidth [4 ];
	prevactivewidth [5 ]= activewidth [5 ];
	prevactivewidth [6 ]= activewidth [6 ];
	if ( eqtb [15227 ].cint > 1 ) 
	{
	  prevactivewidth [7 ]= activewidth [7 ];
	  prevactivewidth [8 ]= activewidth [8 ];
	} 
      } 
      if ( beforerejectedcurp && ( curp == rejectedcurp ) ) 
      beforerejectedcurp = false ;
    } 
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zpostlinebreak ( boolean d ) 
#else
zpostlinebreak ( d ) 
  boolean d ;
#endif
{
  /* 30 31 */ postlinebreak_regmem 
  halfword q, r, s  ;
  halfword p, k  ;
  scaled w  ;
  boolean discbreak  ;
  boolean postdiscbreak  ;
  scaled curwidth  ;
  scaled curindent  ;
  quarterword t  ;
  integer pen  ;
  halfword curline  ;
  halfword LRptr  ;
  LRptr = curlist .eTeXauxfield ;
  q = mem [bestbet + 1 ].hh .v.RH ;
  curp = -268435455L ;
  do {
      r = q ;
    q = mem [q + 1 ].hh .v.LH ;
    mem [r + 1 ].hh .v.LH = curp ;
    curp = r ;
  } while ( ! ( q == -268435455L ) ) ;
  curline = curlist .pgfield + 1 ;
  do {
      if ( ( eqtb [15250 ].cint > 0 ) ) 
    {
      q = mem [memtop - 3 ].hh .v.RH ;
      if ( LRptr != -268435455L ) 
      {
	tempptr = LRptr ;
	r = q ;
	do {
	    s = newmath ( 0 , ( mem [tempptr ].hh .v.LH - 1 ) ) ;
	  mem [s ].hh .v.RH = r ;
	  r = s ;
	  tempptr = mem [tempptr ].hh .v.RH ;
	} while ( ! ( tempptr == -268435455L ) ) ;
	mem [memtop - 3 ].hh .v.RH = r ;
      } 
      while ( q != mem [curp + 1 ].hh .v.RH ) {
	  
	if ( ! ( q >= himemmin ) ) 
	if ( mem [q ].hh.b0 == 9 ) 
	if ( odd ( mem [q ].hh.b1 ) ) 
	{
	  if ( LRptr != -268435455L ) 
	  if ( mem [LRptr ].hh .v.LH == ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) 
	  ) 
	  {
	    tempptr = LRptr ;
	    LRptr = mem [tempptr ].hh .v.RH ;
	    {
	      mem [tempptr ].hh .v.RH = avail ;
	      avail = tempptr ;
	;
#ifdef STAT
	      decr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	} 
	else {
	    
	  tempptr = getavail () ;
	  mem [tempptr ].hh .v.LH = ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) ;
	  mem [tempptr ].hh .v.RH = LRptr ;
	  LRptr = tempptr ;
	} 
	q = mem [q ].hh .v.RH ;
      } 
    } 
    q = mem [curp + 1 ].hh .v.RH ;
    discbreak = false ;
    postdiscbreak = false ;
    if ( q != -268435455L ) 
    if ( mem [q ].hh.b0 == 10 ) 
    {
      deleteglueref ( mem [q + 1 ].hh .v.LH ) ;
      mem [q + 1 ].hh .v.LH = eqtb [12534 ].hh .v.RH ;
      mem [q ].hh.b1 = 9 ;
      incr ( mem [eqtb [12534 ].hh .v.RH ].hh .v.RH ) ;
      goto lab30 ;
    } 
    else {
	
      if ( mem [q ].hh.b0 == 7 ) 
      {
	t = mem [q ].hh.b1 ;
	if ( t == 0 ) 
	r = mem [q ].hh .v.RH ;
	else {
	    
	  r = q ;
	  while ( t > 1 ) {
	      
	    r = mem [r ].hh .v.RH ;
	    decr ( t ) ;
	  } 
	  s = mem [r ].hh .v.RH ;
	  r = mem [s ].hh .v.RH ;
	  mem [s ].hh .v.RH = -268435455L ;
	  flushnodelist ( mem [q ].hh .v.RH ) ;
	  mem [q ].hh.b1 = 0 ;
	} 
	if ( mem [q + 1 ].hh .v.RH != -268435455L ) 
	{
	  s = mem [q + 1 ].hh .v.RH ;
	  while ( mem [s ].hh .v.RH != -268435455L ) s = mem [s ].hh .v.RH 
	  ;
	  mem [s ].hh .v.RH = r ;
	  r = mem [q + 1 ].hh .v.RH ;
	  mem [q + 1 ].hh .v.RH = -268435455L ;
	  postdiscbreak = true ;
	} 
	if ( mem [q + 1 ].hh .v.LH != -268435455L ) 
	{
	  s = mem [q + 1 ].hh .v.LH ;
	  mem [q ].hh .v.RH = s ;
	  while ( mem [s ].hh .v.RH != -268435455L ) s = mem [s ].hh .v.RH 
	  ;
	  mem [q + 1 ].hh .v.LH = -268435455L ;
	  q = s ;
	} 
	mem [q ].hh .v.RH = r ;
	discbreak = true ;
      } 
      else if ( mem [q ].hh.b0 == 11 ) 
      mem [q + 1 ].cint = 0 ;
      else if ( mem [q ].hh.b0 == 9 ) 
      {
	mem [q + 1 ].cint = 0 ;
	if ( ( eqtb [15250 ].cint > 0 ) ) 
	if ( odd ( mem [q ].hh.b1 ) ) 
	{
	  if ( LRptr != -268435455L ) 
	  if ( mem [LRptr ].hh .v.LH == ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) 
	  ) 
	  {
	    tempptr = LRptr ;
	    LRptr = mem [tempptr ].hh .v.RH ;
	    {
	      mem [tempptr ].hh .v.RH = avail ;
	      avail = tempptr ;
	;
#ifdef STAT
	      decr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	} 
	else {
	    
	  tempptr = getavail () ;
	  mem [tempptr ].hh .v.LH = ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) ;
	  mem [tempptr ].hh .v.RH = LRptr ;
	  LRptr = tempptr ;
	} 
      } 
    } 
    else {
	
      q = memtop - 3 ;
      while ( mem [q ].hh .v.RH != -268435455L ) q = mem [q ].hh .v.RH ;
    } 
    r = newparamglue ( 8 ) ;
    mem [r ].hh .v.RH = mem [q ].hh .v.RH ;
    mem [q ].hh .v.RH = r ;
    q = r ;
    lab30: if ( eqtb [15234 ].cint > 0 ) 
    {
      p = prevrightmost ( memtop - 3 , q ) ;
      if ( ( p != -268435455L ) && ( ( mem [p ].hh.b0 == 7 ) || ( mem [p ]
      .hh.b0 == 12 ) ) ) 
      p = prevrightmost ( memtop - 3 , p ) ;
      w = charpw ( p , 1 ) ;
      if ( p != -268435455L ) 
      {
	while ( mem [p ].hh .v.RH != q ) p = mem [p ].hh .v.RH ;
	if ( w != 0 ) 
	{
	  k = newmarginkern ( - (integer) w , lastrightmostchar , 1 ) ;
	  mem [p ].hh .v.RH = k ;
	  mem [k ].hh .v.RH = q ;
	} 
      } 
    } 
    if ( ( eqtb [15250 ].cint > 0 ) ) 
    if ( LRptr != -268435455L ) 
    {
      s = memtop - 3 ;
      r = mem [s ].hh .v.RH ;
      while ( r != q ) {
	  
	s = r ;
	r = mem [s ].hh .v.RH ;
      } 
      r = LRptr ;
      while ( r != -268435455L ) {
	  
	tempptr = newmath ( 0 , mem [r ].hh .v.LH ) ;
	mem [s ].hh .v.RH = tempptr ;
	s = tempptr ;
	r = mem [r ].hh .v.RH ;
      } 
      mem [s ].hh .v.RH = q ;
    } 
    r = mem [q ].hh .v.RH ;
    mem [q ].hh .v.RH = -268435455L ;
    q = mem [memtop - 3 ].hh .v.RH ;
    mem [memtop - 3 ].hh .v.RH = r ;
    if ( eqtb [15234 ].cint > 0 ) 
    {
      p = q ;
      while ( ( p != -268435455L ) && ! ( ( p >= himemmin ) || ( mem [p ]
      .hh.b0 < 9 ) || ( ( mem [p ].hh.b0 == 11 ) && ( mem [p ].hh.b1 != 1 
      ) ) || ( mem [p ].hh.b0 == 40 ) ) ) p = mem [p ].hh .v.RH ;
      w = charpw ( p , 0 ) ;
      if ( w != 0 ) 
      {
	k = newmarginkern ( - (integer) w , lastleftmostchar , 0 ) ;
	mem [k ].hh .v.RH = q ;
	q = k ;
      } 
    } 
    if ( eqtb [12533 ].hh .v.RH != membot ) 
    {
      r = newparamglue ( 7 ) ;
      mem [r ].hh .v.RH = q ;
      q = r ;
    } 
    if ( curline > lastspecialline ) 
    {
      curwidth = secondwidth ;
      curindent = secondindent ;
    } 
    else if ( eqtb [13056 ].hh .v.RH == -268435455L ) 
    {
      curwidth = firstwidth ;
      curindent = firstindent ;
    } 
    else {
	
      curwidth = mem [eqtb [13056 ].hh .v.RH + 2 * curline ].cint ;
      curindent = mem [eqtb [13056 ].hh .v.RH + 2 * curline - 1 ].cint ;
    } 
    adjusttail = memtop - 5 ;
    preadjusttail = memtop - 14 ;
    if ( eqtb [15227 ].cint > 0 ) 
    justbox = hpack ( q , curwidth , 2 ) ;
    else justbox = hpack ( q , curwidth , 0 ) ;
    mem [justbox + 4 ].cint = curindent ;
    if ( memtop - 14 != preadjusttail ) 
    {
      mem [curlist .tailfield ].hh .v.RH = mem [memtop - 14 ].hh .v.RH ;
      curlist .tailfield = preadjusttail ;
    } 
    preadjusttail = -268435455L ;
    prependlinesnapnodes () ;
    appendtovlist ( justbox ) ;
    if ( memtop - 5 != adjusttail ) 
    {
      mem [curlist .tailfield ].hh .v.RH = mem [memtop - 5 ].hh .v.RH ;
      curlist .tailfield = adjusttail ;
    } 
    adjusttail = -268435455L ;
    if ( curline + 1 != bestline ) 
    {
      q = eqtb [13057 ].hh .v.RH ;
      if ( q != -268435455L ) 
      {
	r = curline ;
	if ( r > mem [q + 1 ].cint ) 
	r = mem [q + 1 ].cint ;
	pen = mem [q + r + 1 ].cint ;
      } 
      else pen = eqtb [15184 ].cint ;
      q = eqtb [13058 ].hh .v.RH ;
      if ( q != -268435455L ) 
      {
	r = curline - curlist .pgfield ;
	if ( r > mem [q + 1 ].cint ) 
	r = mem [q + 1 ].cint ;
	pen = pen + mem [q + r + 1 ].cint ;
      } 
      else if ( curline == curlist .pgfield + 1 ) 
      pen = pen + eqtb [15176 ].cint ;
      if ( d ) 
      q = eqtb [13060 ].hh .v.RH ;
      else q = eqtb [13059 ].hh .v.RH ;
      if ( q != -268435455L ) 
      {
	r = bestline - curline - 1 ;
	if ( r > mem [q + 1 ].cint ) 
	r = mem [q + 1 ].cint ;
	pen = pen + mem [q + r + 1 ].cint ;
      } 
      else if ( curline + 2 == bestline ) 
      if ( d ) 
      pen = pen + eqtb [15178 ].cint ;
      else pen = pen + eqtb [15177 ].cint ;
      if ( discbreak ) 
      pen = pen + eqtb [15179 ].cint ;
      if ( pen != 0 ) 
      {
	r = newpenalty ( pen ) ;
	mem [curlist .tailfield ].hh .v.RH = r ;
	curlist .tailfield = r ;
      } 
    } 
    incr ( curline ) ;
    curp = mem [curp + 1 ].hh .v.LH ;
    if ( curp != -268435455L ) 
    if ( ! postdiscbreak ) 
    {
      r = memtop - 3 ;
      while ( true ) {
	  
	q = mem [r ].hh .v.RH ;
	if ( q == mem [curp + 1 ].hh .v.RH ) 
	goto lab31 ;
	if ( ( q >= himemmin ) ) 
	goto lab31 ;
	if ( ( mem [q ].hh.b0 < 9 ) ) 
	goto lab31 ;
	if ( mem [q ].hh.b0 == 11 ) 
	if ( mem [q ].hh.b1 != 1 ) 
	goto lab31 ;
	r = q ;
	if ( mem [q ].hh.b0 == 9 ) 
	if ( ( eqtb [15250 ].cint > 0 ) ) 
	if ( odd ( mem [q ].hh.b1 ) ) 
	{
	  if ( LRptr != -268435455L ) 
	  if ( mem [LRptr ].hh .v.LH == ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) 
	  ) 
	  {
	    tempptr = LRptr ;
	    LRptr = mem [tempptr ].hh .v.RH ;
	    {
	      mem [tempptr ].hh .v.RH = avail ;
	      avail = tempptr ;
	;
#ifdef STAT
	      decr ( dynused ) ;
#endif /* STAT */
	    } 
	  } 
	} 
	else {
	    
	  tempptr = getavail () ;
	  mem [tempptr ].hh .v.LH = ( 4 * ( mem [q ].hh.b1 / 4 ) + 3 ) ;
	  mem [tempptr ].hh .v.RH = LRptr ;
	  LRptr = tempptr ;
	} 
      } 
      lab31: if ( r != memtop - 3 ) 
      {
	mem [r ].hh .v.RH = -268435455L ;
	flushnodelist ( mem [memtop - 3 ].hh .v.RH ) ;
	mem [memtop - 3 ].hh .v.RH = q ;
      } 
    } 
  } while ( ! ( curp == -268435455L ) ) ;
  if ( ( curline != bestline ) || ( mem [memtop - 3 ].hh .v.RH != 
  -268435455L ) ) 
  confusion ( 1179 ) ;
  curlist .pgfield = bestline - 1 ;
  curlist .eTeXauxfield = LRptr ;
} 
smallnumber 
#ifdef HAVE_PROTOTYPES
zreconstitute ( smallnumber j , smallnumber n , halfword bchar , halfword 
hchar ) 
#else
zreconstitute ( j , n , bchar , hchar ) 
  smallnumber j ;
  smallnumber n ;
  halfword bchar ;
  halfword hchar ;
#endif
{
  /* 22 30 */ register smallnumber Result; reconstitute_regmem 
  halfword p  ;
  halfword t  ;
  fourquarters q  ;
  halfword currh  ;
  halfword testchar  ;
  scaled w  ;
  fontindex k  ;
  hyphenpassed = 0 ;
  t = memtop - 4 ;
  w = 0 ;
  mem [memtop - 4 ].hh .v.RH = -268435455L ;
  curl = hu [j ];
  curq = t ;
  if ( j == 0 ) 
  {
    ligaturepresent = initlig ;
    p = initlist ;
    if ( ligaturepresent ) 
    lfthit = initlft ;
    while ( p > -268435455L ) {
	
      {
	mem [t ].hh .v.RH = getavail () ;
	t = mem [t ].hh .v.RH ;
	mem [t ].hh.b0 = hf ;
	mem [t ].hh.b1 = mem [p ].hh.b1 ;
      } 
      p = mem [p ].hh .v.RH ;
    } 
  } 
  else if ( curl < 256 ) 
  {
    mem [t ].hh .v.RH = getavail () ;
    t = mem [t ].hh .v.RH ;
    mem [t ].hh.b0 = hf ;
    mem [t ].hh.b1 = curl ;
  } 
  ligstack = -268435455L ;
  {
    if ( j < n ) 
    curr = hu [j + 1 ];
    else curr = bchar ;
    if ( odd ( hyf [j ]) ) 
    currh = hchar ;
    else currh = 256 ;
  } 
  lab22: if ( curl == 256 ) 
  {
    k = bcharlabel [hf ];
    if ( k == 0 ) 
    goto lab30 ;
    else q = fontinfo [k ].qqqq ;
  } 
  else {
      
    q = fontinfo [charbase [hf ]+ effectivechar ( true , hf , curl ) ]
    .qqqq ;
    if ( ( ( q .b2 ) % 4 ) != 1 ) 
    goto lab30 ;
    k = ligkernbase [hf ]+ q .b3 ;
    q = fontinfo [k ].qqqq ;
    if ( q .b0 > 128 ) 
    {
      k = ligkernbase [hf ]+ 256 * q .b2 + q .b3 + 32768L - 256 * ( 128 ) ;
      q = fontinfo [k ].qqqq ;
    } 
  } 
  if ( currh < 256 ) 
  testchar = currh ;
  else testchar = curr ;
  while ( true ) {
      
    if ( q .b1 == testchar ) 
    if ( q .b0 <= 128 ) 
    if ( currh < 256 ) 
    {
      hyphenpassed = j ;
      hchar = 256 ;
      currh = 256 ;
      goto lab22 ;
    } 
    else {
	
      if ( hchar < 256 ) 
      if ( odd ( hyf [j ]) ) 
      {
	hyphenpassed = j ;
	hchar = 256 ;
      } 
      if ( q .b2 < 128 ) 
      {
	if ( curl == 256 ) 
	lfthit = true ;
	if ( j == n ) 
	if ( ligstack == -268435455L ) 
	rthit = true ;
	{
	  if ( interrupt != 0 ) 
	  pauseforinstructions () ;
	} 
	switch ( q .b2 ) 
	{case 1 : 
	case 5 : 
	  {
	    curl = q .b3 ;
	    ligaturepresent = true ;
	  } 
	  break ;
	case 2 : 
	case 6 : 
	  {
	    curr = q .b3 ;
	    if ( ligstack > -268435455L ) 
	    mem [ligstack ].hh.b1 = curr ;
	    else {
		
	      ligstack = newligitem ( curr ) ;
	      if ( j == n ) 
	      bchar = 256 ;
	      else {
		  
		p = getavail () ;
		mem [ligstack + 1 ].hh .v.RH = p ;
		mem [p ].hh.b1 = hu [j + 1 ];
		mem [p ].hh.b0 = hf ;
	      } 
	    } 
	  } 
	  break ;
	case 3 : 
	  {
	    curr = q .b3 ;
	    p = ligstack ;
	    ligstack = newligitem ( curr ) ;
	    mem [ligstack ].hh .v.RH = p ;
	  } 
	  break ;
	case 7 : 
	case 11 : 
	  {
	    if ( ligaturepresent ) 
	    {
	      p = newligature ( hf , curl , mem [curq ].hh .v.RH ) ;
	      if ( lfthit ) 
	      {
		mem [p ].hh.b1 = 2 ;
		lfthit = false ;
	      } 
	      if ( false ) 
	      if ( ligstack == -268435455L ) 
	      {
		incr ( mem [p ].hh.b1 ) ;
		rthit = false ;
	      } 
	      mem [curq ].hh .v.RH = p ;
	      t = p ;
	      ligaturepresent = false ;
	    } 
	    curq = t ;
	    curl = q .b3 ;
	    ligaturepresent = true ;
	  } 
	  break ;
	  default: 
	  {
	    curl = q .b3 ;
	    ligaturepresent = true ;
	    if ( ligstack > -268435455L ) 
	    {
	      if ( mem [ligstack + 1 ].hh .v.RH > -268435455L ) 
	      {
		mem [t ].hh .v.RH = mem [ligstack + 1 ].hh .v.RH ;
		t = mem [t ].hh .v.RH ;
		incr ( j ) ;
	      } 
	      p = ligstack ;
	      ligstack = mem [p ].hh .v.RH ;
	      freenode ( p , 2 ) ;
	      if ( ligstack == -268435455L ) 
	      {
		if ( j < n ) 
		curr = hu [j + 1 ];
		else curr = bchar ;
		if ( odd ( hyf [j ]) ) 
		currh = hchar ;
		else currh = 256 ;
	      } 
	      else curr = mem [ligstack ].hh.b1 ;
	    } 
	    else if ( j == n ) 
	    goto lab30 ;
	    else {
		
	      {
		mem [t ].hh .v.RH = getavail () ;
		t = mem [t ].hh .v.RH ;
		mem [t ].hh.b0 = hf ;
		mem [t ].hh.b1 = curr ;
	      } 
	      incr ( j ) ;
	      {
		if ( j < n ) 
		curr = hu [j + 1 ];
		else curr = bchar ;
		if ( odd ( hyf [j ]) ) 
		currh = hchar ;
		else currh = 256 ;
	      } 
	    } 
	  } 
	  break ;
	} 
	if ( q .b2 > 4 ) 
	if ( q .b2 != 7 ) 
	goto lab30 ;
	goto lab22 ;
      } 
      w = fontinfo [kernbase [hf ]+ 256 * q .b2 + q .b3 ].cint ;
      goto lab30 ;
    } 
    if ( q .b0 >= 128 ) 
    if ( currh == 256 ) 
    goto lab30 ;
    else {
	
      currh = 256 ;
      goto lab22 ;
    } 
    k = k + q .b0 + 1 ;
    q = fontinfo [k ].qqqq ;
  } 
  lab30: ;
  if ( ligaturepresent ) 
  {
    p = newligature ( hf , curl , mem [curq ].hh .v.RH ) ;
    if ( lfthit ) 
    {
      mem [p ].hh.b1 = 2 ;
      lfthit = false ;
    } 
    if ( rthit ) 
    if ( ligstack == -268435455L ) 
    {
      incr ( mem [p ].hh.b1 ) ;
      rthit = false ;
    } 
    mem [curq ].hh .v.RH = p ;
    t = p ;
    ligaturepresent = false ;
  } 
  if ( w != 0 ) 
  {
    mem [t ].hh .v.RH = newkern ( w ) ;
    t = mem [t ].hh .v.RH ;
    w = 0 ;
  } 
  if ( ligstack > -268435455L ) 
  {
    curq = t ;
    curl = mem [ligstack ].hh.b1 ;
    ligaturepresent = true ;
    {
      if ( mem [ligstack + 1 ].hh .v.RH > -268435455L ) 
      {
	mem [t ].hh .v.RH = mem [ligstack + 1 ].hh .v.RH ;
	t = mem [t ].hh .v.RH ;
	incr ( j ) ;
      } 
      p = ligstack ;
      ligstack = mem [p ].hh .v.RH ;
      freenode ( p , 2 ) ;
      if ( ligstack == -268435455L ) 
      {
	if ( j < n ) 
	curr = hu [j + 1 ];
	else curr = bchar ;
	if ( odd ( hyf [j ]) ) 
	currh = hchar ;
	else currh = 256 ;
      } 
      else curr = mem [ligstack ].hh.b1 ;
    } 
    goto lab22 ;
  } 
  Result = j ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
hyphenate ( void ) 
#else
hyphenate ( ) 
#endif
{
  /* 50 30 40 41 42 45 10 */ hyphenate_regmem 
  char i, j, l  ;
  halfword q, r, s  ;
  halfword bchar  ;
  halfword majortail, minortail  ;
  ASCIIcode c  ;
  char cloc  ;
  integer rcount  ;
  halfword hyfnode  ;
  triepointer z  ;
  integer v  ;
  hyphpointer h  ;
  strnumber k  ;
  poolpointer u  ;
  {register integer for_end; j = 0 ;for_end = hn ; if ( j <= for_end) do 
    hyf [j ]= 0 ;
  while ( j++ < for_end ) ;} 
  h = hc [1 ];
  incr ( hn ) ;
  hc [hn ]= curlang ;
  {register integer for_end; j = 2 ;for_end = hn ; if ( j <= for_end) do 
    h = ( h + h + hc [j ]) % 607 ;
  while ( j++ < for_end ) ;} 
  while ( true ) {
      
    k = hyphword [h ];
    if ( k == 0 ) 
    goto lab45 ;
    if ( ( strstart [k + 1 ]- strstart [k ]) == hn ) 
    {
      j = 1 ;
      u = strstart [k ];
      do {
	  if ( strpool [u ]!= hc [j ]) 
	goto lab30 ;
	incr ( j ) ;
	incr ( u ) ;
      } while ( ! ( j > hn ) ) ;
      s = hyphlist [h ];
      while ( s != -268435455L ) {
	  
	hyf [mem [s ].hh .v.LH ]= 1 ;
	s = mem [s ].hh .v.RH ;
      } 
      decr ( hn ) ;
      goto lab40 ;
    } 
    lab30: ;
    h = hyphlink [h ];
    if ( h == 0 ) 
    goto lab45 ;
    decr ( h ) ;
  } 
  lab45: decr ( hn ) ;
  if ( trietrc [curlang + 1 ]!= curlang ) 
  return ;
  hc [0 ]= 0 ;
  hc [hn + 1 ]= 0 ;
  hc [hn + 2 ]= 256 ;
  {register integer for_end; j = 0 ;for_end = hn - rhyf + 1 ; if ( j <= 
  for_end) do 
    {
      z = trietrl [curlang + 1 ]+ hc [j ];
      l = j ;
      while ( hc [l ]== trietrc [z ]) {
	  
	if ( trietro [z ]!= mintrieop ) 
	{
	  v = trietro [z ];
	  do {
	      v = v + opstart [curlang ];
	    i = l - hyfdistance [v ];
	    if ( hyfnum [v ]> hyf [i ]) 
	    hyf [i ]= hyfnum [v ];
	    v = hyfnext [v ];
	  } while ( ! ( v == mintrieop ) ) ;
	} 
	incr ( l ) ;
	z = trietrl [z ]+ hc [l ];
      } 
    } 
  while ( j++ < for_end ) ;} 
  lab40: {
      register integer for_end; j = 0 ;for_end = lhyf - 1 ; if ( j <= 
  for_end) do 
    hyf [j ]= 0 ;
  while ( j++ < for_end ) ;} 
  {register integer for_end; j = 0 ;for_end = rhyf - 1 ; if ( j <= for_end) 
  do 
    hyf [hn - j ]= 0 ;
  while ( j++ < for_end ) ;} 
  {register integer for_end; j = lhyf ;for_end = hn - rhyf ; if ( j <= 
  for_end) do 
    if ( odd ( hyf [j ]) ) 
    goto lab41 ;
  while ( j++ < for_end ) ;} 
  return ;
  lab41: ;
  q = mem [hb ].hh .v.RH ;
  mem [hb ].hh .v.RH = -268435455L ;
  r = mem [ha ].hh .v.RH ;
  mem [ha ].hh .v.RH = -268435455L ;
  bchar = hyfbchar ;
  if ( ( ha >= himemmin ) ) 
  if ( mem [ha ].hh.b0 != hf ) 
  goto lab42 ;
  else {
      
    initlist = ha ;
    initlig = false ;
    hu [0 ]= mem [ha ].hh.b1 ;
  } 
  else if ( mem [ha ].hh.b0 == 6 ) 
  if ( mem [ha + 1 ].hh.b0 != hf ) 
  goto lab42 ;
  else {
      
    initlist = mem [ha + 1 ].hh .v.RH ;
    initlig = true ;
    initlft = ( mem [ha ].hh.b1 > 1 ) ;
    hu [0 ]= mem [ha + 1 ].hh.b1 ;
    if ( initlist == -268435455L ) 
    if ( initlft ) 
    {
      hu [0 ]= 256 ;
      initlig = false ;
    } 
    freenode ( ha , 2 ) ;
  } 
  else {
      
    if ( ! ( r >= himemmin ) ) 
    if ( mem [r ].hh.b0 == 6 ) 
    if ( mem [r ].hh.b1 > 1 ) 
    goto lab42 ;
    j = 1 ;
    s = ha ;
    initlist = -268435455L ;
    goto lab50 ;
  } 
  s = curp ;
  while ( mem [s ].hh .v.RH != ha ) s = mem [s ].hh .v.RH ;
  j = 0 ;
  goto lab50 ;
  lab42: s = ha ;
  j = 0 ;
  hu [0 ]= 256 ;
  initlig = false ;
  initlist = -268435455L ;
  lab50: flushnodelist ( r ) ;
  do {
      l = j ;
    j = reconstitute ( j , hn , bchar , hyfchar ) + 1 ;
    if ( hyphenpassed == 0 ) 
    {
      mem [s ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
      while ( mem [s ].hh .v.RH > -268435455L ) s = mem [s ].hh .v.RH ;
      if ( odd ( hyf [j - 1 ]) ) 
      {
	l = j ;
	hyphenpassed = j - 1 ;
	mem [memtop - 4 ].hh .v.RH = -268435455L ;
      } 
    } 
    if ( hyphenpassed > 0 ) 
    do {
	r = getnode ( 2 ) ;
      mem [r ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
      mem [r ].hh.b0 = 7 ;
      majortail = r ;
      rcount = 0 ;
      while ( mem [majortail ].hh .v.RH > -268435455L ) {
	  
	majortail = mem [majortail ].hh .v.RH ;
	incr ( rcount ) ;
      } 
      i = hyphenpassed ;
      hyf [i ]= 0 ;
      minortail = -268435455L ;
      mem [r + 1 ].hh .v.LH = -268435455L ;
      hyfnode = newcharacter ( hf , hyfchar ) ;
      if ( hyfnode != -268435455L ) 
      {
	incr ( i ) ;
	c = hu [i ];
	hu [i ]= hyfchar ;
	{
	  mem [hyfnode ].hh .v.RH = avail ;
	  avail = hyfnode ;
	;
#ifdef STAT
	  decr ( dynused ) ;
#endif /* STAT */
	} 
      } 
      while ( l <= i ) {
	  
	l = reconstitute ( l , i , fontbchar [hf ], 256 ) + 1 ;
	if ( mem [memtop - 4 ].hh .v.RH > -268435455L ) 
	{
	  if ( minortail == -268435455L ) 
	  mem [r + 1 ].hh .v.LH = mem [memtop - 4 ].hh .v.RH ;
	  else mem [minortail ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
	  minortail = mem [memtop - 4 ].hh .v.RH ;
	  while ( mem [minortail ].hh .v.RH > -268435455L ) minortail = mem 
	  [minortail ].hh .v.RH ;
	} 
      } 
      if ( hyfnode != -268435455L ) 
      {
	hu [i ]= c ;
	l = i ;
	decr ( i ) ;
      } 
      minortail = -268435455L ;
      mem [r + 1 ].hh .v.RH = -268435455L ;
      cloc = 0 ;
      if ( bcharlabel [hf ]!= 0 ) 
      {
	decr ( l ) ;
	c = hu [l ];
	cloc = l ;
	hu [l ]= 256 ;
      } 
      while ( l < j ) {
	  
	do {
	    l = reconstitute ( l , hn , bchar , 256 ) + 1 ;
	  if ( cloc > 0 ) 
	  {
	    hu [cloc ]= c ;
	    cloc = 0 ;
	  } 
	  if ( mem [memtop - 4 ].hh .v.RH > -268435455L ) 
	  {
	    if ( minortail == -268435455L ) 
	    mem [r + 1 ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
	    else mem [minortail ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
	    minortail = mem [memtop - 4 ].hh .v.RH ;
	    while ( mem [minortail ].hh .v.RH > -268435455L ) minortail = 
	    mem [minortail ].hh .v.RH ;
	  } 
	} while ( ! ( l >= j ) ) ;
	while ( l > j ) {
	    
	  j = reconstitute ( j , hn , bchar , 256 ) + 1 ;
	  mem [majortail ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
	  while ( mem [majortail ].hh .v.RH > -268435455L ) {
	      
	    majortail = mem [majortail ].hh .v.RH ;
	    incr ( rcount ) ;
	  } 
	} 
      } 
      if ( rcount > 127 ) 
      {
	mem [s ].hh .v.RH = mem [r ].hh .v.RH ;
	mem [r ].hh .v.RH = -268435455L ;
	flushnodelist ( r ) ;
      } 
      else {
	  
	mem [s ].hh .v.RH = r ;
	mem [r ].hh.b1 = rcount ;
      } 
      s = majortail ;
      hyphenpassed = j - 1 ;
      mem [memtop - 4 ].hh .v.RH = -268435455L ;
    } while ( ! ( ! odd ( hyf [j - 1 ]) ) ) ;
  } while ( ! ( j > hn ) ) ;
  mem [s ].hh .v.RH = q ;
  flushlist ( initlist ) ;
} 
boolean 
#ifdef HAVE_PROTOTYPES
zeTeXenabled ( boolean b , quarterword j , halfword k ) 
#else
zeTeXenabled ( b , j , k ) 
  boolean b ;
  quarterword j ;
  halfword k ;
#endif
{
  register boolean Result; eTeXenabled_regmem 
  if ( ! b ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 733 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 733 ) ;
      } 
    } 
    printcmdchr ( j , k ) ;
    {
      helpptr = 1 ;
      helpline [0 ]= 1717 ;
    } 
    error () ;
  } 
  Result = b ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
showsavegroups ( void ) 
#else
showsavegroups ( ) 
#endif
{
  /* 41 42 40 30 */ showsavegroups_regmem 
  integer p  ;
  short m  ;
  savepointer v  ;
  quarterword l  ;
  groupcode c  ;
  schar a  ;
  integer i  ;
  quarterword j  ;
  strnumber s  ;
  p = nestptr ;
  nest [p ]= curlist ;
  v = saveptr ;
  l = curlevel ;
  c = curgroup ;
  saveptr = curboundary ;
  decr ( curlevel ) ;
  a = 1 ;
  printnl ( 263 ) ;
  println () ;
  while ( true ) {
      
    printnl ( 367 ) ;
    printgroup ( true ) ;
    if ( curgroup == 0 ) 
    goto lab30 ;
    do {
	m = nest [p ].modefield ;
      if ( p > 0 ) 
      decr ( p ) ;
      else m = 1 ;
    } while ( ! ( m != 102 ) ) ;
    print ( 287 ) ;
    switch ( curgroup ) 
    {case 1 : 
      {
	incr ( p ) ;
	goto lab42 ;
      } 
      break ;
    case 2 : 
    case 3 : 
      s = 1300 ;
      break ;
    case 4 : 
      s = 1207 ;
      break ;
    case 5 : 
      s = 1299 ;
      break ;
    case 6 : 
      if ( a == 0 ) 
      {
	if ( m == -1 ) 
	s = 550 ;
	else s = 569 ;
	a = 1 ;
	goto lab41 ;
      } 
      else {
	  
	if ( a == 1 ) 
	print ( 1755 ) ;
	else printesc ( 1136 ) ;
	if ( p >= a ) 
	p = p - a ;
	a = 0 ;
	goto lab40 ;
      } 
      break ;
    case 7 : 
      {
	incr ( p ) ;
	a = -1 ;
	printesc ( 557 ) ;
	goto lab42 ;
      } 
      break ;
    case 8 : 
      {
	printesc ( 403 ) ;
	goto lab40 ;
      } 
      break ;
    case 9 : 
      goto lab42 ;
      break ;
    case 10 : 
    case 13 : 
      {
	if ( curgroup == 10 ) 
	printesc ( 352 ) ;
	else printesc ( 555 ) ;
	{register integer for_end; i = 1 ;for_end = 3 ; if ( i <= for_end) 
	do 
	  if ( i <= savestack [saveptr - 2 ].cint ) 
	  print ( 1096 ) ;
	while ( i++ < for_end ) ;} 
	goto lab42 ;
      } 
      break ;
    case 11 : 
      {
	if ( savestack [saveptr - 2 ].cint == 255 ) 
	printesc ( 355 ) ;
	else {
	    
	  printesc ( 333 ) ;
	  printint ( savestack [saveptr - 2 ].cint ) ;
	} 
	goto lab42 ;
      } 
      break ;
    case 12 : 
      {
	s = 570 ;
	goto lab41 ;
      } 
      break ;
    case 14 : 
      {
	incr ( p ) ;
	printesc ( 542 ) ;
	goto lab40 ;
      } 
      break ;
    case 15 : 
      {
	if ( m == 203 ) 
	printchar ( 36 ) ;
	else if ( nest [p ].modefield == 203 ) 
	{
	  printcmdchr ( 48 , savestack [saveptr - 2 ].cint ) ;
	  goto lab40 ;
	} 
	printchar ( 36 ) ;
	goto lab40 ;
      } 
      break ;
    case 16 : 
      {
	if ( mem [nest [p + 1 ].eTeXauxfield ].hh.b0 == 30 ) 
	printesc ( 1112 ) ;
	else printesc ( 1114 ) ;
	goto lab40 ;
      } 
      break ;
    } 
    i = savestack [saveptr - 4 ].cint ;
    if ( i != 0 ) 
    if ( i < 1073741824L ) 
    {
      if ( abs ( nest [p ].modefield ) == 1 ) 
      j = 21 ;
      else j = 22 ;
      if ( i > 0 ) 
      printcmdchr ( j , 0 ) ;
      else printcmdchr ( j , 1 ) ;
      printscaled ( abs ( i ) ) ;
      print ( 402 ) ;
    } 
    else if ( i < 1073807360L ) 
    {
      if ( i >= 1073774592L ) 
      {
	printesc ( 1414 ) ;
	i = i - ( 32768L ) ;
      } 
      printesc ( 567 ) ;
      printint ( i - 1073741824L ) ;
      printchar ( 61 ) ;
    } 
    else printcmdchr ( 31 , i - ( 1073807261L ) ) ;
    lab41: printesc ( s ) ;
    if ( savestack [saveptr - 2 ].cint != 0 ) 
    {
      printchar ( 32 ) ;
      if ( savestack [saveptr - 3 ].cint == 0 ) 
      print ( 1072 ) ;
      else print ( 1073 ) ;
      printscaled ( savestack [saveptr - 2 ].cint ) ;
      print ( 402 ) ;
    } 
    lab42: printchar ( 123 ) ;
    lab40: printchar ( 41 ) ;
    decr ( curlevel ) ;
    curgroup = savestack [saveptr ].hh.b1 ;
    saveptr = savestack [saveptr ].hh .v.RH ;
  } 
  lab30: saveptr = v ;
  curlevel = l ;
  curgroup = c ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zprunepagetop ( halfword p , boolean s ) 
#else
zprunepagetop ( p , s ) 
  halfword p ;
  boolean s ;
#endif
{
  register halfword Result; prunepagetop_regmem 
  halfword prevp  ;
  halfword q, r  ;
  prevp = memtop - 3 ;
  mem [memtop - 3 ].hh .v.RH = p ;
  while ( p != -268435455L ) switch ( mem [p ].hh.b0 ) 
  {case 0 : 
  case 1 : 
  case 2 : 
    {
      q = newskipparam ( 10 ) ;
      mem [prevp ].hh .v.RH = q ;
      mem [q ].hh .v.RH = p ;
      if ( mem [tempptr + 1 ].cint > mem [p + 3 ].cint ) 
      mem [tempptr + 1 ].cint = mem [tempptr + 1 ].cint - mem [p + 3 ]
      .cint ;
      else mem [tempptr + 1 ].cint = 0 ;
      p = -268435455L ;
    } 
    break ;
  case 8 : 
  case 4 : 
  case 3 : 
    {
      prevp = p ;
      p = mem [prevp ].hh .v.RH ;
    } 
    break ;
  case 10 : 
  case 11 : 
  case 12 : 
    {
      q = p ;
      p = mem [q ].hh .v.RH ;
      mem [q ].hh .v.RH = -268435455L ;
      mem [prevp ].hh .v.RH = p ;
      if ( s ) 
      {
	if ( discptr [3 ]== -268435455L ) 
	discptr [3 ]= q ;
	else mem [r ].hh .v.RH = q ;
	r = q ;
      } 
      else flushnodelist ( q ) ;
    } 
    break ;
    default: 
    confusion ( 1199 ) ;
    break ;
  } 
  Result = mem [memtop - 3 ].hh .v.RH ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zvertbreak ( halfword p , scaled h , scaled d ) 
#else
zvertbreak ( p , h , d ) 
  halfword p ;
  scaled h ;
  scaled d ;
#endif
{
  /* 30 45 90 */ register halfword Result; vertbreak_regmem 
  halfword prevp  ;
  halfword q, r  ;
  integer pi  ;
  integer b  ;
  integer leastcost  ;
  halfword bestplace  ;
  scaled prevdp  ;
  smallnumber t  ;
  prevp = p ;
  leastcost = 1073741823L ;
  activewidth [1 ]= 0 ;
  activewidth [2 ]= 0 ;
  activewidth [3 ]= 0 ;
  activewidth [4 ]= 0 ;
  activewidth [5 ]= 0 ;
  activewidth [6 ]= 0 ;
  prevdp = 0 ;
  while ( true ) {
      
    if ( p == -268435455L ) 
    pi = -10000 ;
    else switch ( mem [p ].hh.b0 ) 
    {case 0 : 
    case 1 : 
    case 2 : 
      {
	activewidth [1 ]= activewidth [1 ]+ prevdp + mem [p + 3 ].cint ;
	prevdp = mem [p + 2 ].cint ;
	goto lab45 ;
      } 
      break ;
    case 8 : 
      {
	if ( ( mem [p ].hh.b1 == 10 ) || ( mem [p ].hh.b1 == 12 ) ) 
	{
	  activewidth [1 ]= activewidth [1 ]+ prevdp + mem [p + 2 ].cint 
	  ;
	  prevdp = mem [p + 3 ].cint ;
	} 
	goto lab45 ;
      } 
      break ;
    case 10 : 
      if ( ( mem [prevp ].hh.b0 < 9 ) ) 
      pi = 0 ;
      else goto lab90 ;
      break ;
    case 11 : 
      {
	if ( mem [p ].hh .v.RH == -268435455L ) 
	t = 12 ;
	else t = mem [mem [p ].hh .v.RH ].hh.b0 ;
	if ( t == 10 ) 
	pi = 0 ;
	else goto lab90 ;
      } 
      break ;
    case 12 : 
      pi = mem [p + 1 ].cint ;
      break ;
    case 4 : 
    case 3 : 
      goto lab45 ;
      break ;
      default: 
      confusion ( 1200 ) ;
      break ;
    } 
    if ( pi < 10000 ) 
    {
      if ( activewidth [1 ]< h ) 
      if ( ( activewidth [3 ]!= 0 ) || ( activewidth [4 ]!= 0 ) || ( 
      activewidth [5 ]!= 0 ) ) 
      b = 0 ;
      else b = badness ( h - activewidth [1 ], activewidth [2 ]) ;
      else if ( activewidth [1 ]- h > activewidth [6 ]) 
      b = 1073741823L ;
      else b = badness ( activewidth [1 ]- h , activewidth [6 ]) ;
      if ( b < 1073741823L ) 
      if ( pi <= -10000 ) 
      b = pi ;
      else if ( b < 10000 ) 
      b = b + pi ;
      else b = 100000L ;
      if ( b <= leastcost ) 
      {
	bestplace = p ;
	leastcost = b ;
	bestheightplusdepth = activewidth [1 ]+ prevdp ;
      } 
      if ( ( b == 1073741823L ) || ( pi <= -10000 ) ) 
      goto lab30 ;
    } 
    if ( ( mem [p ].hh.b0 < 10 ) || ( mem [p ].hh.b0 > 11 ) ) 
    goto lab45 ;
    lab90: if ( mem [p ].hh.b0 == 11 ) 
    q = p ;
    else {
	
      q = mem [p + 1 ].hh .v.LH ;
      activewidth [2 + mem [q ].hh.b0 ]= activewidth [2 + mem [q ]
      .hh.b0 ]+ mem [q + 2 ].cint ;
      activewidth [6 ]= activewidth [6 ]+ mem [q + 3 ].cint ;
      if ( ( mem [q ].hh.b1 != 0 ) && ( mem [q + 3 ].cint != 0 ) ) 
      {
	{
	  if ( interaction == 3 ) 
	  ;
	  if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) 
	  ) ) 
	  {
	    printnl ( 263 ) ;
	    print ( fullsourcefilenamestack [inopen ]) ;
	    print ( 58 ) ;
	    printint ( line ) ;
	    print ( 264 ) ;
	    print ( 1201 ) ;
	  } 
	  else {
	      
	    printnl ( 265 ) ;
	    print ( 1201 ) ;
	  } 
	} 
	{
	  helpptr = 4 ;
	  helpline [3 ]= 1202 ;
	  helpline [2 ]= 1203 ;
	  helpline [1 ]= 1204 ;
	  helpline [0 ]= 1159 ;
	} 
	error () ;
	r = newspec ( q ) ;
	mem [r ].hh.b1 = 0 ;
	deleteglueref ( q ) ;
	mem [p + 1 ].hh .v.LH = r ;
	q = r ;
      } 
    } 
    activewidth [1 ]= activewidth [1 ]+ prevdp + mem [q + 1 ].cint ;
    prevdp = 0 ;
    lab45: if ( prevdp > d ) 
    {
      activewidth [1 ]= activewidth [1 ]+ prevdp - d ;
      prevdp = d ;
    } 
    prevp = p ;
    p = mem [prevp ].hh .v.RH ;
  } 
  lab30: Result = bestplace ;
  if ( bestplace == -268435455L ) 
  lastvbreakpenalty = -10000 ;
  else if ( mem [bestplace ].hh.b0 == 12 ) 
  lastvbreakpenalty = mem [bestplace + 1 ].cint ;
  else lastvbreakpenalty = 0 ;
  return Result ;
} 
halfword 
#ifdef HAVE_PROTOTYPES
zvsplit ( halfword n , scaled h ) 
#else
zvsplit ( n , h ) 
  halfword n ;
  scaled h ;
#endif
{
  /* 10 30 */ register halfword Result; vsplit_regmem 
  halfword v  ;
  halfword p  ;
  halfword q  ;
  curval = n ;
  if ( curval < 256 ) 
  v = eqtb [13330 + curval ].hh .v.RH ;
  else {
      
    findsaelement ( 4 , curval , false ) ;
    if ( curptr == -268435455L ) 
    v = -268435455L ;
    else v = mem [curptr + 1 ].hh .v.RH ;
  } 
  flushnodelist ( discptr [3 ]) ;
  discptr [3 ]= -268435455L ;
  if ( saroot [6 ]!= -268435455L ) 
  if ( domarks ( 0 , 0 , saroot [6 ]) ) 
  saroot [6 ]= -268435455L ;
  if ( curmark [3 ]!= -268435455L ) 
  {
    deletetokenref ( curmark [3 ]) ;
    curmark [3 ]= -268435455L ;
    deletetokenref ( curmark [4 ]) ;
    curmark [4 ]= -268435455L ;
  } 
  if ( v == -268435455L ) 
  {
    Result = -268435455L ;
    return Result ;
  } 
  if ( mem [v ].hh.b0 != 1 ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 263 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 263 ) ;
      } 
    } 
    printesc ( 1205 ) ;
    print ( 1206 ) ;
    printesc ( 1207 ) ;
    {
      helpptr = 2 ;
      helpline [1 ]= 1208 ;
      helpline [0 ]= 1209 ;
    } 
    error () ;
    Result = -268435455L ;
    return Result ;
  } 
  q = vertbreak ( mem [v + 5 ].hh .v.RH , h , eqtb [15769 ].cint ) ;
  p = mem [v + 5 ].hh .v.RH ;
  if ( p == q ) 
  mem [v + 5 ].hh .v.RH = -268435455L ;
  else while ( true ) {
      
    if ( mem [p ].hh.b0 == 4 ) 
    if ( mem [p + 1 ].hh .v.LH != 0 ) 
    {
      findsaelement ( 6 , mem [p + 1 ].hh .v.LH , true ) ;
      if ( mem [curptr + 2 ].hh .v.RH == -268435455L ) 
      {
	mem [curptr + 2 ].hh .v.RH = mem [p + 1 ].hh .v.RH ;
	incr ( mem [mem [p + 1 ].hh .v.RH ].hh .v.LH ) ;
      } 
      else deletetokenref ( mem [curptr + 3 ].hh .v.LH ) ;
      mem [curptr + 3 ].hh .v.LH = mem [p + 1 ].hh .v.RH ;
      incr ( mem [mem [p + 1 ].hh .v.RH ].hh .v.LH ) ;
    } 
    else if ( curmark [3 ]== -268435455L ) 
    {
      curmark [3 ]= mem [p + 1 ].hh .v.RH ;
      curmark [4 ]= curmark [3 ];
      mem [curmark [3 ]].hh .v.LH = mem [curmark [3 ]].hh .v.LH + 2 ;
    } 
    else {
	
      deletetokenref ( curmark [4 ]) ;
      curmark [4 ]= mem [p + 1 ].hh .v.RH ;
      incr ( mem [curmark [4 ]].hh .v.LH ) ;
    } 
    if ( mem [p ].hh .v.RH == q ) 
    {
      mem [p ].hh .v.RH = -268435455L ;
      goto lab30 ;
    } 
    p = mem [p ].hh .v.RH ;
  } 
  lab30: ;
  q = prunepagetop ( q , eqtb [15248 ].cint > 0 ) ;
  p = mem [v + 5 ].hh .v.RH ;
  freenode ( v , 7 ) ;
  if ( q != -268435455L ) 
  q = vpackage ( q , 0 , 1 , 1073741823L ) ;
  if ( curval < 256 ) 
  eqtb [13330 + curval ].hh .v.RH = q ;
  else {
      
    findsaelement ( 4 , curval , false ) ;
    if ( curptr != -268435455L ) 
    {
      mem [curptr + 1 ].hh .v.RH = q ;
      incr ( mem [curptr + 1 ].hh .v.LH ) ;
      deletesaref ( curptr ) ;
    } 
  } 
  Result = vpackage ( p , h , 0 , eqtb [15769 ].cint ) ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
printtotals ( void ) 
#else
printtotals ( ) 
#endif
{
  printtotals_regmem 
  printscaled ( pagesofar [1 ]) ;
  if ( pagesofar [2 ]!= 0 ) 
  {
    print ( 313 ) ;
    printscaled ( pagesofar [2 ]) ;
    print ( 263 ) ;
  } 
  if ( pagesofar [3 ]!= 0 ) 
  {
    print ( 313 ) ;
    printscaled ( pagesofar [3 ]) ;
    print ( 312 ) ;
  } 
  if ( pagesofar [4 ]!= 0 ) 
  {
    print ( 313 ) ;
    printscaled ( pagesofar [4 ]) ;
    print ( 1218 ) ;
  } 
  if ( pagesofar [5 ]!= 0 ) 
  {
    print ( 313 ) ;
    printscaled ( pagesofar [5 ]) ;
    print ( 1219 ) ;
  } 
  if ( pagesofar [6 ]!= 0 ) 
  {
    print ( 314 ) ;
    printscaled ( pagesofar [6 ]) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zfreezepagespecs ( smallnumber s ) 
#else
zfreezepagespecs ( s ) 
  smallnumber s ;
#endif
{
  freezepagespecs_regmem 
  pagecontents = s ;
  pagesofar [0 ]= eqtb [15767 ].cint ;
  pagemaxdepth = eqtb [15768 ].cint ;
  pagesofar [7 ]= 0 ;
  pagesofar [1 ]= 0 ;
  pagesofar [2 ]= 0 ;
  pagesofar [3 ]= 0 ;
  pagesofar [4 ]= 0 ;
  pagesofar [5 ]= 0 ;
  pagesofar [6 ]= 0 ;
  leastpagecost = 1073741823L ;
	;
#ifdef STAT
  if ( eqtb [15204 ].cint > 0 ) 
  {
    begindiagnostic () ;
    printnl ( 1227 ) ;
    printscaled ( pagesofar [0 ]) ;
    print ( 1228 ) ;
    printscaled ( pagemaxdepth ) ;
    enddiagnostic ( false ) ;
  } 
#endif /* STAT */
} 
void 
#ifdef HAVE_PROTOTYPES
zboxerror ( eightbits n ) 
#else
zboxerror ( n ) 
  eightbits n ;
#endif
{
  boxerror_regmem 
  error () ;
  begindiagnostic () ;
  printnl ( 887 ) ;
  showbox ( eqtb [13330 + n ].hh .v.RH ) ;
  enddiagnostic ( true ) ;
  flushnodelist ( eqtb [13330 + n ].hh .v.RH ) ;
  eqtb [13330 + n ].hh .v.RH = -268435455L ;
} 
void 
#ifdef HAVE_PROTOTYPES
zensurevbox ( eightbits n ) 
#else
zensurevbox ( n ) 
  eightbits n ;
#endif
{
  ensurevbox_regmem 
  halfword p  ;
  p = eqtb [13330 + n ].hh .v.RH ;
  if ( p != -268435455L ) 
  if ( mem [p ].hh.b0 == 0 ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 1229 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 1229 ) ;
      } 
    } 
    {
      helpptr = 3 ;
      helpline [2 ]= 1230 ;
      helpline [1 ]= 1231 ;
      helpline [0 ]= 1232 ;
    } 
    boxerror ( n ) ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
zfireup ( halfword c ) 
#else
zfireup ( c ) 
  halfword c ;
#endif
{
  /* 10 */ fireup_regmem 
  halfword p, q, r, s  ;
  halfword prevp  ;
  unsigned char n  ;
  boolean wait  ;
  integer savevbadness  ;
  scaled savevfuzz  ;
  halfword savesplittopskip  ;
  if ( mem [bestpagebreak ].hh.b0 == 12 ) 
  {
    geqworddefine ( 15210 , mem [bestpagebreak + 1 ].cint ) ;
    mem [bestpagebreak + 1 ].cint = 10000 ;
  } 
  else geqworddefine ( 15210 , 10000 ) ;
  if ( saroot [6 ]!= -268435455L ) 
  if ( domarks ( 1 , 0 , saroot [6 ]) ) 
  saroot [6 ]= -268435455L ;
  if ( curmark [2 ]!= -268435455L ) 
  {
    if ( curmark [0 ]!= -268435455L ) 
    deletetokenref ( curmark [0 ]) ;
    curmark [0 ]= curmark [2 ];
    incr ( mem [curmark [0 ]].hh .v.LH ) ;
    deletetokenref ( curmark [1 ]) ;
    curmark [1 ]= -268435455L ;
  } 
  if ( c == bestpagebreak ) 
  bestpagebreak = -268435455L ;
  if ( eqtb [13585 ].hh .v.RH != -268435455L ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 263 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 263 ) ;
      } 
    } 
    printesc ( 417 ) ;
    print ( 1243 ) ;
    {
      helpptr = 2 ;
      helpline [1 ]= 1244 ;
      helpline [0 ]= 1232 ;
    } 
    boxerror ( 255 ) ;
  } 
  insertpenalties = 0 ;
  savesplittopskip = eqtb [12536 ].hh .v.RH ;
  if ( eqtb [15224 ].cint <= 0 ) 
  {
    r = mem [memtop ].hh .v.RH ;
    while ( r != memtop ) {
	
      if ( mem [r + 2 ].hh .v.LH != -268435455L ) 
      {
	n = mem [r ].hh.b1 ;
	ensurevbox ( n ) ;
	if ( eqtb [13330 + n ].hh .v.RH == -268435455L ) 
	eqtb [13330 + n ].hh .v.RH = newnullbox () ;
	p = eqtb [13330 + n ].hh .v.RH + 5 ;
	while ( mem [p ].hh .v.RH != -268435455L ) p = mem [p ].hh .v.RH ;
	mem [r + 2 ].hh .v.RH = p ;
      } 
      r = mem [r ].hh .v.RH ;
    } 
  } 
  q = memtop - 4 ;
  mem [q ].hh .v.RH = -268435455L ;
  prevp = memtop - 2 ;
  p = mem [prevp ].hh .v.RH ;
  while ( p != bestpagebreak ) {
      
    if ( mem [p ].hh.b0 == 3 ) 
    {
      if ( eqtb [15224 ].cint <= 0 ) 
      {
	r = mem [memtop ].hh .v.RH ;
	while ( mem [r ].hh.b1 != mem [p ].hh.b1 ) r = mem [r ].hh .v.RH 
	;
	if ( mem [r + 2 ].hh .v.LH == -268435455L ) 
	wait = true ;
	else {
	    
	  wait = false ;
	  s = mem [r + 2 ].hh .v.RH ;
	  mem [s ].hh .v.RH = mem [p + 4 ].hh .v.LH ;
	  if ( mem [r + 2 ].hh .v.LH == p ) 
	  {
	    if ( mem [r ].hh.b0 == 1 ) 
	    if ( ( mem [r + 1 ].hh .v.LH == p ) && ( mem [r + 1 ].hh .v.RH 
	    != -268435455L ) ) 
	    {
	      while ( mem [s ].hh .v.RH != mem [r + 1 ].hh .v.RH ) s = mem 
	      [s ].hh .v.RH ;
	      mem [s ].hh .v.RH = -268435455L ;
	      eqtb [12536 ].hh .v.RH = mem [p + 4 ].hh .v.RH ;
	      mem [p + 4 ].hh .v.LH = prunepagetop ( mem [r + 1 ].hh .v.RH 
	      , false ) ;
	      if ( mem [p + 4 ].hh .v.LH != -268435455L ) 
	      {
		tempptr = vpackage ( mem [p + 4 ].hh .v.LH , 0 , 1 , 
		1073741823L ) ;
		mem [p + 3 ].cint = mem [tempptr + 3 ].cint + mem [
		tempptr + 2 ].cint ;
		freenode ( tempptr , 7 ) ;
		wait = true ;
	      } 
	    } 
	    mem [r + 2 ].hh .v.LH = -268435455L ;
	    n = mem [r ].hh.b1 ;
	    tempptr = mem [eqtb [13330 + n ].hh .v.RH + 5 ].hh .v.RH ;
	    freenode ( eqtb [13330 + n ].hh .v.RH , 7 ) ;
	    eqtb [13330 + n ].hh .v.RH = vpackage ( tempptr , 0 , 1 , 
	    1073741823L ) ;
	  } 
	  else {
	      
	    while ( mem [s ].hh .v.RH != -268435455L ) s = mem [s ].hh 
	    .v.RH ;
	    mem [r + 2 ].hh .v.RH = s ;
	  } 
	} 
	mem [prevp ].hh .v.RH = mem [p ].hh .v.RH ;
	mem [p ].hh .v.RH = -268435455L ;
	if ( wait ) 
	{
	  mem [q ].hh .v.RH = p ;
	  q = p ;
	  incr ( insertpenalties ) ;
	} 
	else {
	    
	  deleteglueref ( mem [p + 4 ].hh .v.RH ) ;
	  freenode ( p , 5 ) ;
	} 
	p = prevp ;
      } 
    } 
    else if ( mem [p ].hh.b0 == 4 ) 
    if ( mem [p + 1 ].hh .v.LH != 0 ) 
    {
      findsaelement ( 6 , mem [p + 1 ].hh .v.LH , true ) ;
      if ( mem [curptr + 1 ].hh .v.RH == -268435455L ) 
      {
	mem [curptr + 1 ].hh .v.RH = mem [p + 1 ].hh .v.RH ;
	incr ( mem [mem [p + 1 ].hh .v.RH ].hh .v.LH ) ;
      } 
      if ( mem [curptr + 2 ].hh .v.LH != -268435455L ) 
      deletetokenref ( mem [curptr + 2 ].hh .v.LH ) ;
      mem [curptr + 2 ].hh .v.LH = mem [p + 1 ].hh .v.RH ;
      incr ( mem [mem [p + 1 ].hh .v.RH ].hh .v.LH ) ;
    } 
    else {
	
      if ( curmark [1 ]== -268435455L ) 
      {
	curmark [1 ]= mem [p + 1 ].hh .v.RH ;
	incr ( mem [curmark [1 ]].hh .v.LH ) ;
      } 
      if ( curmark [2 ]!= -268435455L ) 
      deletetokenref ( curmark [2 ]) ;
      curmark [2 ]= mem [p + 1 ].hh .v.RH ;
      incr ( mem [curmark [2 ]].hh .v.LH ) ;
    } 
    prevp = p ;
    p = mem [prevp ].hh .v.RH ;
  } 
  eqtb [12536 ].hh .v.RH = savesplittopskip ;
  if ( p != -268435455L ) 
  {
    if ( mem [memtop - 1 ].hh .v.RH == -268435455L ) 
    if ( nestptr == 0 ) 
    curlist .tailfield = pagetail ;
    else nest [0 ].tailfield = pagetail ;
    mem [pagetail ].hh .v.RH = mem [memtop - 1 ].hh .v.RH ;
    mem [memtop - 1 ].hh .v.RH = p ;
    mem [prevp ].hh .v.RH = -268435455L ;
  } 
  savevbadness = eqtb [15198 ].cint ;
  eqtb [15198 ].cint = 10000 ;
  savevfuzz = eqtb [15772 ].cint ;
  eqtb [15772 ].cint = 1073741823L ;
  eqtb [13585 ].hh .v.RH = vpackage ( mem [memtop - 2 ].hh .v.RH , 
  bestsize , 0 , pagemaxdepth ) ;
  eqtb [15198 ].cint = savevbadness ;
  eqtb [15772 ].cint = savevfuzz ;
  if ( lastglue != 268435455L ) 
  deleteglueref ( lastglue ) ;
  pagecontents = 0 ;
  pagetail = memtop - 2 ;
  mem [memtop - 2 ].hh .v.RH = -268435455L ;
  lastglue = 268435455L ;
  lastpenalty = 0 ;
  lastkern = 0 ;
  lastnodetype = -1 ;
  pagesofar [7 ]= 0 ;
  pagemaxdepth = 0 ;
  if ( q != memtop - 4 ) 
  {
    mem [memtop - 2 ].hh .v.RH = mem [memtop - 4 ].hh .v.RH ;
    pagetail = q ;
  } 
  r = mem [memtop ].hh .v.RH ;
  while ( r != memtop ) {
      
    q = mem [r ].hh .v.RH ;
    freenode ( r , 4 ) ;
    r = q ;
  } 
  mem [memtop ].hh .v.RH = memtop ;
  if ( saroot [6 ]!= -268435455L ) 
  if ( domarks ( 2 , 0 , saroot [6 ]) ) 
  saroot [6 ]= -268435455L ;
  if ( ( curmark [0 ]!= -268435455L ) && ( curmark [1 ]== -268435455L ) ) 
  {
    curmark [1 ]= curmark [0 ];
    incr ( mem [curmark [0 ]].hh .v.LH ) ;
  } 
  if ( eqtb [13061 ].hh .v.RH != -268435455L ) 
  if ( deadcycles >= eqtb [15211 ].cint ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 1245 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 1245 ) ;
      } 
    } 
    printint ( deadcycles ) ;
    print ( 1246 ) ;
    {
      helpptr = 3 ;
      helpline [2 ]= 1247 ;
      helpline [1 ]= 1248 ;
      helpline [0 ]= 1249 ;
    } 
    error () ;
  } 
  else {
      
    outputactive = true ;
    incr ( deadcycles ) ;
    pushnest () ;
    curlist .modefield = -1 ;
    curlist .auxfield .cint = -65536000L ;
    curlist .mlfield = - (integer) line ;
    begintokenlist ( eqtb [13061 ].hh .v.RH , 6 ) ;
    newsavelevel ( 8 ) ;
    normalparagraph () ;
    scanleftbrace () ;
    return ;
  } 
  {
    if ( mem [memtop - 2 ].hh .v.RH != -268435455L ) 
    {
      if ( mem [memtop - 1 ].hh .v.RH == -268435455L ) 
      if ( nestptr == 0 ) 
      curlist .tailfield = pagetail ;
      else nest [0 ].tailfield = pagetail ;
      else mem [pagetail ].hh .v.RH = mem [memtop - 1 ].hh .v.RH ;
      mem [memtop - 1 ].hh .v.RH = mem [memtop - 2 ].hh .v.RH ;
      mem [memtop - 2 ].hh .v.RH = -268435455L ;
      pagetail = memtop - 2 ;
    } 
    flushnodelist ( discptr [2 ]) ;
    discptr [2 ]= -268435455L ;
    shipout ( eqtb [13585 ].hh .v.RH ) ;
    eqtb [13585 ].hh .v.RH = -268435455L ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
buildpage ( void ) 
#else
buildpage ( ) 
#endif
{
  /* 10 30 31 22 80 90 */ buildpage_regmem 
  halfword p  ;
  halfword q, r  ;
  integer b, c  ;
  integer pi  ;
  unsigned char n  ;
  scaled delta, h, w  ;
  if ( ( mem [memtop - 1 ].hh .v.RH == -268435455L ) || outputactive ) 
  return ;
  do {
      lab22: p = mem [memtop - 1 ].hh .v.RH ;
    if ( lastglue != 268435455L ) 
    deleteglueref ( lastglue ) ;
    lastpenalty = 0 ;
    lastkern = 0 ;
    lastnodetype = mem [p ].hh.b0 + 1 ;
    if ( mem [p ].hh.b0 == 10 ) 
    {
      lastglue = mem [p + 1 ].hh .v.LH ;
      incr ( mem [lastglue ].hh .v.RH ) ;
    } 
    else {
	
      lastglue = 268435455L ;
      if ( mem [p ].hh.b0 == 12 ) 
      lastpenalty = mem [p + 1 ].cint ;
      else if ( mem [p ].hh.b0 == 11 ) 
      lastkern = mem [p + 1 ].cint ;
    } 
    switch ( mem [p ].hh.b0 ) 
    {case 0 : 
    case 1 : 
    case 2 : 
      if ( pagecontents < 2 ) 
      {
	if ( pagecontents == 0 ) 
	freezepagespecs ( 2 ) ;
	else pagecontents = 2 ;
	q = newskipparam ( 9 ) ;
	if ( mem [tempptr + 1 ].cint > mem [p + 3 ].cint ) 
	mem [tempptr + 1 ].cint = mem [tempptr + 1 ].cint - mem [p + 3 ]
	.cint ;
	else mem [tempptr + 1 ].cint = 0 ;
	mem [q ].hh .v.RH = p ;
	mem [memtop - 1 ].hh .v.RH = q ;
	goto lab22 ;
      } 
      else {
	  
	pagesofar [1 ]= pagesofar [1 ]+ pagesofar [7 ]+ mem [p + 3 ]
	.cint ;
	pagesofar [7 ]= mem [p + 2 ].cint ;
	goto lab80 ;
      } 
      break ;
    case 8 : 
      {
	if ( ( mem [p ].hh.b1 == 10 ) || ( mem [p ].hh.b1 == 12 ) ) 
	{
	  pagesofar [1 ]= pagesofar [1 ]+ pagesofar [7 ]+ mem [p + 2 ]
	  .cint ;
	  pagesofar [7 ]= mem [p + 3 ].cint ;
	} 
	goto lab80 ;
      } 
      break ;
    case 10 : 
      if ( pagecontents < 2 ) 
      goto lab31 ;
      else if ( ( mem [pagetail ].hh.b0 < 9 ) ) 
      pi = 0 ;
      else goto lab90 ;
      break ;
    case 11 : 
      if ( pagecontents < 2 ) 
      goto lab31 ;
      else if ( mem [p ].hh .v.RH == -268435455L ) 
      return ;
      else if ( mem [mem [p ].hh .v.RH ].hh.b0 == 10 ) 
      pi = 0 ;
      else goto lab90 ;
      break ;
    case 12 : 
      if ( pagecontents < 2 ) 
      goto lab31 ;
      else pi = mem [p + 1 ].cint ;
      break ;
    case 4 : 
      goto lab80 ;
      break ;
    case 3 : 
      {
	if ( pagecontents == 0 ) 
	freezepagespecs ( 1 ) ;
	n = mem [p ].hh.b1 ;
	r = memtop ;
	while ( n >= mem [mem [r ].hh .v.RH ].hh.b1 ) r = mem [r ].hh 
	.v.RH ;
	n = n ;
	if ( mem [r ].hh.b1 != n ) 
	{
	  q = getnode ( 4 ) ;
	  mem [q ].hh .v.RH = mem [r ].hh .v.RH ;
	  mem [r ].hh .v.RH = q ;
	  r = q ;
	  mem [r ].hh.b1 = n ;
	  mem [r ].hh.b0 = 0 ;
	  ensurevbox ( n ) ;
	  if ( eqtb [13330 + n ].hh .v.RH == -268435455L ) 
	  mem [r + 3 ].cint = 0 ;
	  else mem [r + 3 ].cint = mem [eqtb [13330 + n ].hh .v.RH + 3 ]
	  .cint + mem [eqtb [13330 + n ].hh .v.RH + 2 ].cint ;
	  mem [r + 2 ].hh .v.LH = -268435455L ;
	  q = eqtb [12544 + n ].hh .v.RH ;
	  if ( eqtb [15251 + n ].cint == 1000 ) 
	  h = mem [r + 3 ].cint ;
	  else h = xovern ( mem [r + 3 ].cint , 1000 ) * eqtb [15251 + n ]
	  .cint ;
	  pagesofar [0 ]= pagesofar [0 ]- h - mem [q + 1 ].cint ;
	  pagesofar [2 + mem [q ].hh.b0 ]= pagesofar [2 + mem [q ]
	  .hh.b0 ]+ mem [q + 2 ].cint ;
	  pagesofar [6 ]= pagesofar [6 ]+ mem [q + 3 ].cint ;
	  if ( ( mem [q ].hh.b1 != 0 ) && ( mem [q + 3 ].cint != 0 ) ) 
	  {
	    {
	      if ( interaction == 3 ) 
	      ;
	      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 
	      0 ) ) ) 
	      {
		printnl ( 263 ) ;
		print ( fullsourcefilenamestack [inopen ]) ;
		print ( 58 ) ;
		printint ( line ) ;
		print ( 264 ) ;
		print ( 1238 ) ;
	      } 
	      else {
		  
		printnl ( 265 ) ;
		print ( 1238 ) ;
	      } 
	    } 
	    printesc ( 400 ) ;
	    printint ( n ) ;
	    {
	      helpptr = 3 ;
	      helpline [2 ]= 1239 ;
	      helpline [1 ]= 1240 ;
	      helpline [0 ]= 1159 ;
	    } 
	    error () ;
	  } 
	} 
	if ( mem [r ].hh.b0 == 1 ) 
	insertpenalties = insertpenalties + mem [p + 1 ].cint ;
	else {
	    
	  mem [r + 2 ].hh .v.RH = p ;
	  delta = pagesofar [0 ]- pagesofar [1 ]- pagesofar [7 ]+ 
	  pagesofar [6 ];
	  if ( eqtb [15251 + n ].cint == 1000 ) 
	  h = mem [p + 3 ].cint ;
	  else h = xovern ( mem [p + 3 ].cint , 1000 ) * eqtb [15251 + n ]
	  .cint ;
	  if ( ( ( h <= 0 ) || ( h <= delta ) ) && ( mem [p + 3 ].cint + mem 
	  [r + 3 ].cint <= eqtb [15791 + n ].cint ) ) 
	  {
	    pagesofar [0 ]= pagesofar [0 ]- h ;
	    mem [r + 3 ].cint = mem [r + 3 ].cint + mem [p + 3 ].cint ;
	  } 
	  else {
	      
	    if ( eqtb [15251 + n ].cint <= 0 ) 
	    w = 1073741823L ;
	    else {
		
	      w = pagesofar [0 ]- pagesofar [1 ]- pagesofar [7 ];
	      if ( eqtb [15251 + n ].cint != 1000 ) 
	      w = xovern ( w , eqtb [15251 + n ].cint ) * 1000 ;
	    } 
	    if ( w > eqtb [15791 + n ].cint - mem [r + 3 ].cint ) 
	    w = eqtb [15791 + n ].cint - mem [r + 3 ].cint ;
	    q = vertbreak ( mem [p + 4 ].hh .v.LH , w , mem [p + 2 ].cint 
	    ) ;
	    mem [r + 3 ].cint = mem [r + 3 ].cint + bestheightplusdepth ;
	;
#ifdef STAT
	    if ( eqtb [15204 ].cint > 0 ) 
	    {
	      begindiagnostic () ;
	      printnl ( 1241 ) ;
	      printint ( n ) ;
	      print ( 1242 ) ;
	      printscaled ( w ) ;
	      printchar ( 44 ) ;
	      printscaled ( bestheightplusdepth ) ;
	      print ( 1169 ) ;
	      if ( q == -268435455L ) 
	      printint ( -10000 ) ;
	      else if ( mem [q ].hh.b0 == 12 ) 
	      printint ( mem [q + 1 ].cint ) ;
	      else printchar ( 48 ) ;
	      enddiagnostic ( false ) ;
	    } 
#endif /* STAT */
	    if ( eqtb [15251 + n ].cint != 1000 ) 
	    bestheightplusdepth = xovern ( bestheightplusdepth , 1000 ) * eqtb 
	    [15251 + n ].cint ;
	    pagesofar [0 ]= pagesofar [0 ]- bestheightplusdepth ;
	    mem [r ].hh.b0 = 1 ;
	    mem [r + 1 ].hh .v.RH = q ;
	    mem [r + 1 ].hh .v.LH = p ;
	    if ( q == -268435455L ) 
	    insertpenalties = insertpenalties - 10000 ;
	    else if ( mem [q ].hh.b0 == 12 ) 
	    insertpenalties = insertpenalties + mem [q + 1 ].cint ;
	  } 
	} 
	goto lab80 ;
      } 
      break ;
      default: 
      confusion ( 1233 ) ;
      break ;
    } 
    if ( pi < 10000 ) 
    {
      if ( pagesofar [1 ]< pagesofar [0 ]) 
      if ( ( pagesofar [3 ]!= 0 ) || ( pagesofar [4 ]!= 0 ) || ( pagesofar 
      [5 ]!= 0 ) ) 
      b = 0 ;
      else b = badness ( pagesofar [0 ]- pagesofar [1 ], pagesofar [2 ]) 
      ;
      else if ( pagesofar [1 ]- pagesofar [0 ]> pagesofar [6 ]) 
      b = 1073741823L ;
      else b = badness ( pagesofar [1 ]- pagesofar [0 ], pagesofar [6 ]) 
      ;
      if ( b < 1073741823L ) 
      if ( pi <= -10000 ) 
      c = pi ;
      else if ( b < 10000 ) 
      c = b + pi + insertpenalties ;
      else c = 100000L ;
      else c = b ;
      if ( insertpenalties >= 10000 ) 
      c = 1073741823L ;
	;
#ifdef STAT
      if ( eqtb [15204 ].cint > 0 ) 
      {
	begindiagnostic () ;
	printnl ( 37 ) ;
	print ( 1164 ) ;
	printtotals () ;
	print ( 1236 ) ;
	printscaled ( pagesofar [0 ]) ;
	print ( 1168 ) ;
	if ( b == 1073741823L ) 
	printchar ( 42 ) ;
	else printint ( b ) ;
	print ( 1169 ) ;
	printint ( pi ) ;
	print ( 1237 ) ;
	if ( c == 1073741823L ) 
	printchar ( 42 ) ;
	else printint ( c ) ;
	if ( c <= leastpagecost ) 
	printchar ( 35 ) ;
	enddiagnostic ( false ) ;
      } 
#endif /* STAT */
      if ( c <= leastpagecost ) 
      {
	bestpagebreak = p ;
	bestsize = pagesofar [0 ];
	leastpagecost = c ;
	r = mem [memtop ].hh .v.RH ;
	while ( r != memtop ) {
	    
	  mem [r + 2 ].hh .v.LH = mem [r + 2 ].hh .v.RH ;
	  r = mem [r ].hh .v.RH ;
	} 
      } 
      if ( ( c == 1073741823L ) || ( pi <= -10000 ) ) 
      {
	fireup ( p ) ;
	if ( outputactive ) 
	return ;
	goto lab30 ;
      } 
    } 
    if ( ( mem [p ].hh.b0 < 10 ) || ( mem [p ].hh.b0 > 11 ) ) 
    goto lab80 ;
    lab90: if ( mem [p ].hh.b0 == 11 ) 
    q = p ;
    else {
	
      q = mem [p + 1 ].hh .v.LH ;
      pagesofar [2 + mem [q ].hh.b0 ]= pagesofar [2 + mem [q ].hh.b0 ]
      + mem [q + 2 ].cint ;
      pagesofar [6 ]= pagesofar [6 ]+ mem [q + 3 ].cint ;
      if ( ( mem [q ].hh.b1 != 0 ) && ( mem [q + 3 ].cint != 0 ) ) 
      {
	{
	  if ( interaction == 3 ) 
	  ;
	  if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) 
	  ) ) 
	  {
	    printnl ( 263 ) ;
	    print ( fullsourcefilenamestack [inopen ]) ;
	    print ( 58 ) ;
	    printint ( line ) ;
	    print ( 264 ) ;
	    print ( 1234 ) ;
	  } 
	  else {
	      
	    printnl ( 265 ) ;
	    print ( 1234 ) ;
	  } 
	} 
	{
	  helpptr = 4 ;
	  helpline [3 ]= 1235 ;
	  helpline [2 ]= 1203 ;
	  helpline [1 ]= 1204 ;
	  helpline [0 ]= 1159 ;
	} 
	error () ;
	r = newspec ( q ) ;
	mem [r ].hh.b1 = 0 ;
	deleteglueref ( q ) ;
	mem [p + 1 ].hh .v.LH = r ;
	q = r ;
      } 
    } 
    pagesofar [1 ]= pagesofar [1 ]+ pagesofar [7 ]+ mem [q + 1 ].cint 
    ;
    pagesofar [7 ]= 0 ;
    lab80: if ( pagesofar [7 ]> pagemaxdepth ) 
    {
      pagesofar [1 ]= pagesofar [1 ]+ pagesofar [7 ]- pagemaxdepth ;
      pagesofar [7 ]= pagemaxdepth ;
    } 
    mem [pagetail ].hh .v.RH = p ;
    pagetail = p ;
    mem [memtop - 1 ].hh .v.RH = mem [p ].hh .v.RH ;
    mem [p ].hh .v.RH = -268435455L ;
    goto lab30 ;
    lab31: mem [memtop - 1 ].hh .v.RH = mem [p ].hh .v.RH ;
    mem [p ].hh .v.RH = -268435455L ;
    if ( eqtb [15248 ].cint > 0 ) 
    {
      if ( discptr [2 ]== -268435455L ) 
      discptr [2 ]= p ;
      else mem [discptr [1 ]].hh .v.RH = p ;
      discptr [1 ]= p ;
    } 
    else flushnodelist ( p ) ;
    lab30: ;
  } while ( ! ( mem [memtop - 1 ].hh .v.RH == -268435455L ) ) ;
  if ( nestptr == 0 ) 
  curlist .tailfield = memtop - 1 ;
  else nest [0 ].tailfield = memtop - 1 ;
} 
void 
#ifdef HAVE_PROTOTYPES
appspace ( void ) 
#else
appspace ( ) 
#endif
{
  appspace_regmem 
  halfword q  ;
  if ( ( curlist .auxfield .hh .v.LH >= 2000 ) && ( eqtb [12539 ].hh .v.RH 
  != membot ) ) 
  q = newparamglue ( 13 ) ;
  else {
      
    if ( eqtb [12538 ].hh .v.RH != membot ) 
    mainp = eqtb [12538 ].hh .v.RH ;
    else {
	
      mainp = fontglue [eqtb [13586 ].hh .v.RH ];
      if ( mainp == -268435455L ) 
      {
	mainp = newspec ( membot ) ;
	maink = parambase [eqtb [13586 ].hh .v.RH ]+ 2 ;
	mem [mainp + 1 ].cint = fontinfo [maink ].cint ;
	mem [mainp + 2 ].cint = fontinfo [maink + 1 ].cint ;
	mem [mainp + 3 ].cint = fontinfo [maink + 2 ].cint ;
	fontglue [eqtb [13586 ].hh .v.RH ]= mainp ;
      } 
    } 
    mainp = newspec ( mainp ) ;
    if ( curlist .auxfield .hh .v.LH >= 2000 ) 
    mem [mainp + 1 ].cint = mem [mainp + 1 ].cint + fontinfo [7 + 
    parambase [eqtb [13586 ].hh .v.RH ]].cint ;
    mem [mainp + 2 ].cint = xnoverd ( mem [mainp + 2 ].cint , curlist 
    .auxfield .hh .v.LH , 1000 ) ;
    mem [mainp + 3 ].cint = xnoverd ( mem [mainp + 3 ].cint , 1000 , 
    curlist .auxfield .hh .v.LH ) ;
    q = newglue ( mainp ) ;
    mem [mainp ].hh .v.RH = -268435455L ;
  } 
  mem [curlist .tailfield ].hh .v.RH = q ;
  curlist .tailfield = q ;
} 
void 
#ifdef HAVE_PROTOTYPES
insertdollarsign ( void ) 
#else
insertdollarsign ( ) 
#endif
{
  insertdollarsign_regmem 
  backinput () ;
  curtok = 804 ;
  {
    if ( interaction == 3 ) 
    ;
    if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
    {
      printnl ( 263 ) ;
      print ( fullsourcefilenamestack [inopen ]) ;
      print ( 58 ) ;
      printint ( line ) ;
      print ( 264 ) ;
      print ( 1257 ) ;
    } 
    else {
	
      printnl ( 265 ) ;
      print ( 1257 ) ;
    } 
  } 
  {
    helpptr = 2 ;
    helpline [1 ]= 1258 ;
    helpline [0 ]= 1259 ;
  } 
  inserror () ;
} 
void 
#ifdef HAVE_PROTOTYPES
youcant ( void ) 
#else
youcant ( ) 
#endif
{
  youcant_regmem 
  {
    if ( interaction == 3 ) 
    ;
    if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
    {
      printnl ( 263 ) ;
      print ( fullsourcefilenamestack [inopen ]) ;
      print ( 58 ) ;
      printint ( line ) ;
      print ( 264 ) ;
      print ( 738 ) ;
    } 
    else {
	
      printnl ( 265 ) ;
      print ( 738 ) ;
    } 
  } 
  printcmdchr ( curcmd , curchr ) ;
  print ( 1260 ) ;
  printmode ( curlist .modefield ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
reportillegalcase ( void ) 
#else
reportillegalcase ( ) 
#endif
{
  reportillegalcase_regmem 
  youcant () ;
  {
    helpptr = 4 ;
    helpline [3 ]= 1261 ;
    helpline [2 ]= 1262 ;
    helpline [1 ]= 1263 ;
    helpline [0 ]= 1264 ;
  } 
  error () ;
} 
boolean 
#ifdef HAVE_PROTOTYPES
privileged ( void ) 
#else
privileged ( ) 
#endif
{
  register boolean Result; privileged_regmem 
  if ( curlist .modefield > 0 ) 
  Result = true ;
  else {
      
    reportillegalcase () ;
    Result = false ;
  } 
  return Result ;
} 
boolean 
#ifdef HAVE_PROTOTYPES
itsallover ( void ) 
#else
itsallover ( ) 
#endif
{
  /* 10 */ register boolean Result; itsallover_regmem 
  if ( privileged () ) 
  {
    if ( ( memtop - 2 == pagetail ) && ( curlist .headfield == curlist 
    .tailfield ) && ( deadcycles == 0 ) ) 
    {
      Result = true ;
      return Result ;
    } 
    backinput () ;
    {
      mem [curlist .tailfield ].hh .v.RH = newnullbox () ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    mem [curlist .tailfield + 1 ].cint = eqtb [15766 ].cint ;
    {
      mem [curlist .tailfield ].hh .v.RH = newglue ( membot + 8 ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    {
      mem [curlist .tailfield ].hh .v.RH = newpenalty ( -1073741824L ) ;
      curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
    } 
    buildpage () ;
  } 
  Result = false ;
  return Result ;
} 
void 
#ifdef HAVE_PROTOTYPES
appendglue ( void ) 
#else
appendglue ( ) 
#endif
{
  appendglue_regmem 
  smallnumber s  ;
  s = curchr ;
  switch ( s ) 
  {case 0 : 
    curval = membot + 4 ;
    break ;
  case 1 : 
    curval = membot + 8 ;
    break ;
  case 2 : 
    curval = membot + 12 ;
    break ;
  case 3 : 
    curval = membot + 16 ;
    break ;
  case 4 : 
    scanglue ( 2 ) ;
    break ;
  case 5 : 
    scanglue ( 3 ) ;
    break ;
  } 
  {
    mem [curlist .tailfield ].hh .v.RH = newglue ( curval ) ;
    curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
  } 
  if ( s >= 4 ) 
  {
    decr ( mem [curval ].hh .v.RH ) ;
    if ( s > 4 ) 
    mem [curlist .tailfield ].hh.b1 = 99 ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
appendkern ( void ) 
#else
appendkern ( ) 
#endif
{
  appendkern_regmem 
  quarterword s  ;
  s = curchr ;
  scandimen ( s == 99 , false , false ) ;
  {
    mem [curlist .tailfield ].hh .v.RH = newkern ( curval ) ;
    curlist .tailfield = mem [curlist .tailfield ].hh .v.RH ;
  } 
  mem [curlist .tailfield ].hh.b1 = s ;
} 
void 
#ifdef HAVE_PROTOTYPES
offsave ( void ) 
#else
offsave ( ) 
#endif
{
  offsave_regmem 
  halfword p  ;
  if ( curgroup == 0 ) 
  {
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 831 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 831 ) ;
      } 
    } 
    printcmdchr ( curcmd , curchr ) ;
    {
      helpptr = 1 ;
      helpline [0 ]= 1282 ;
    } 
    error () ;
  } 
  else {
      
    backinput () ;
    p = getavail () ;
    mem [memtop - 3 ].hh .v.RH = p ;
    {
      if ( interaction == 3 ) 
      ;
      if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
      {
	printnl ( 263 ) ;
	print ( fullsourcefilenamestack [inopen ]) ;
	print ( 58 ) ;
	printint ( line ) ;
	print ( 264 ) ;
	print ( 664 ) ;
      } 
      else {
	  
	printnl ( 265 ) ;
	print ( 664 ) ;
      } 
    } 
    switch ( curgroup ) 
    {case 14 : 
      {
	mem [p ].hh .v.LH = 14611 ;
	printesc ( 546 ) ;
      } 
      break ;
    case 15 : 
      {
	mem [p ].hh .v.LH = 804 ;
	printchar ( 36 ) ;
      } 
      break ;
    case 16 : 
      {
	mem [p ].hh .v.LH = 14612 ;
	mem [p ].hh .v.RH = getavail () ;
	p = mem [p ].hh .v.RH ;
	mem [p ].hh .v.LH = 3118 ;
	printesc ( 1281 ) ;
      } 
      break ;
      default: 
      {
	mem [p ].hh .v.LH = 637 ;
	printchar ( 125 ) ;
      } 
      break ;
    } 
    print ( 665 ) ;
    begintokenlist ( mem [memtop - 3 ].hh .v.RH , 4 ) ;
    {
      helpptr = 5 ;
      helpline [4 ]= 1276 ;
      helpline [3 ]= 1277 ;
      helpline [2 ]= 1278 ;
      helpline [1 ]= 1279 ;
      helpline [0 ]= 1280 ;
    } 
    error () ;
  } 
} 
void 
#ifdef HAVE_PROTOTYPES
extrarightbrace ( void ) 
#else
extrarightbrace ( ) 
#endif
{
  extrarightbrace_regmem 
  {
    if ( interaction == 3 ) 
    ;
    if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) ) 
    {
      printnl ( 263 ) ;
      print ( fullsourcefilenamestack [inopen ]) ;
      print ( 58 ) ;
      printint ( line ) ;
      print ( 264 ) ;
      print ( 1287 ) ;
    } 
    else {
	
      printnl ( 265 ) ;
      print ( 1287 ) ;
    } 
  } 
  switch ( curgroup ) 
  {case 14 : 
    printesc ( 546 ) ;
    break ;
  case 15 : 
    printchar ( 36 ) ;
    break ;
  case 16 : 
    printesc ( 1113 ) ;
    break ;
  } 
  {
    helpptr = 5 ;
    helpline [4 ]= 1288 ;
    helpline [3 ]= 1289 ;
    helpline [2 ]= 1290 ;
    helpline [1 ]= 1291 ;
    helpline [0 ]= 1292 ;
  } 
  error () ;
  incr ( alignstate ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
normalparagraph ( void ) 
#else
normalparagraph ( ) 
#endif
{
  normalparagraph_regmem 
  if ( eqtb [15190 ].cint != 0 ) 
  eqworddefine ( 15190 , 0 ) ;
  if ( eqtb [15780 ].cint != 0 ) 
  eqworddefine ( 15780 , 0 ) ;
  if ( eqtb [15212 ].cint != 1 ) 
  eqworddefine ( 15212 , 1 ) ;
  if ( eqtb [13056 ].hh .v.RH != -268435455L ) 
  eqdefine ( 13056 , 118 , -268435455L ) ;
  if ( eqtb [13057 ].hh .v.RH != -268435455L ) 
  eqdefine ( 13057 , 118 , -268435455L ) ;
} 
void 
#ifdef HAVE_PROTOTYPES
zboxend ( integer boxcontext ) 
#else
zboxend ( boxcontext ) 
  integer boxcontext ;
#endif
{
  boxend_regmem 
  halfword p  ;
  smallnumber a  ;
  if ( boxcontext < 1073741824L ) 
  {
    if ( curbox != -268435455L ) 
    {
      mem [curbox + 4 ].cint = boxcontext ;
      if ( abs ( curlist .modefield ) == 1 ) 
      {
	if ( preadjusttail != -268435455L ) 
	{
	  if ( memtop - 14 != preadjusttail ) 
	  {
	    mem [curlist .tailfield ].hh .v.RH = mem [memtop - 14 ].hh 
	    .v.RH ;
	    curlist .tailfield = preadjusttail ;
	  } 
	  preadjusttail = -268435455L ;
	} 
	appendtovlist ( curbox ) ;
	if ( adjusttail != -268435455L ) 
	{
	  if ( memtop - 5 != adjusttail ) 
	  {
	    mem [curlist .tailfield ].hh .v.RH = mem [memtop - 5 ].hh 
	    .v.RH ;
	    curlist .tailfield = adjusttail ;
	  } 
	  adjusttail = -268435455L ;
	} 
	if ( curlist .modefield > 0 ) 
	buildpage () ;
      } 
      else {
	  
	if ( abs ( curlist .modefield ) == 102 ) 
	curlist .auxfield .hh .v.LH = 1000 ;
	else {
	    
	  p = newnoad () ;
	  mem [p + 1 ].hh .v.RH = 2 ;
	  mem [p + 1 ].hh .v.LH = curbox ;
	  curbox = p ;
	} 
	mem [curlist .tailfield ].hh .v.RH = curbox ;
	curlist .tailfield = curbox ;
      } 
    } 
  } 
  else if ( boxcontext < 1073807360L ) 
  {
    if ( boxcontext < 1073774592L ) 
    {
      curval = boxcontext - 1073741824L ;
      a = 0 ;
    } 
    else {
	
      curval = boxcontext - 1073774592L ;
      a = 4 ;
    } 
    if ( curval < 256 ) 
    if ( ( a >= 4 ) ) 
    geqdefine ( 13330 + curval , 119 , curbox ) ;
    else eqdefine ( 13330 + curval , 119 , curbox ) ;
    else {
	
      findsaelement ( 4 , curval , true ) ;
      if ( ( a >= 4 ) ) 
      gsadef ( curptr , curbox ) ;
      else sadef ( curptr , curbox ) ;
    } 
  } 
  else if ( curbox != -268435455L ) 
  if ( boxcontext > 1073807360L ) 
  {
    do {
	getxtoken () ;
    } while ( ! ( ( curcmd != 10 ) && ( curcmd != 0 ) ) ) ;
    if ( ( ( curcmd == 26 ) && ( abs ( curlist .modefield ) != 1 ) ) || ( ( 
    curcmd == 27 ) && ( abs ( curlist .modefield ) == 1 ) ) || ( ( curcmd == 
    28 ) && ( abs ( curlist .modefield ) == 203 ) ) ) 
    {
      appendglue () ;
      mem [curlist .tailfield ].hh.b1 = boxcontext - ( 1073807261L ) ;
      mem [curlist .tailfield + 1 ].hh .v.RH = curbox ;
    } 
    else {
	
      {
	if ( interaction == 3 ) 
	;
	if ( ( outputcstyleerrormessagesp && ! ( curinput .namefield == 0 ) ) 
	) 
	{
	  printnl ( 263 ) ;
	  print ( fullsourcefilenamestack [inopen ]) ;
	  print ( 58 ) ;
	  printint ( line ) ;
	  print ( 264 ) ;
	  print ( 1305 ) ;
	} 
	else {
	    
	  printnl ( 265 ) ;
	  print ( 1305 ) ;
	} 
      } 
      {
	helpptr = 3 ;
	helpline [2 ]= 1306 ;
	helpline [1 ]= 1307 ;
	helpline [0 ]= 1308 ;
      } 
      backerror () ;
      flushnodelist ( curbox ) ;
    } 
  } 
  else shipout ( curbox ) ;
} 
